Attribute VB_Name = "ModSOUND"
' *******************************************************************************
' VB81 XuR
' ModDX8_SOUND.BAS - Added by XavSnap. (2007)
' *******************************************************************************


'ZX-81 (and compatibles) tape encoding

'ZX-81 uses tape encoding which makes loading A LOT slower than the other machines. Unfortunately this type of encoding can not be described with the 'Custom Loading Data' block, but with a series of 'Pure Tone' and 'Pause' blocks. Since no custom loaders were used on it, all ZX-81 tapes used this encoding and therefore the 'Standard Speed Data' block can be used for it.

'The main difference is that the encoding is not frequency-based, it is rather based on the number of waves. Bit-0 is represented by 3 to 5 (normally 4) waves and Bit-1 is represented by 6 to 9 waves (normally 8). The frequency of the waves is 12kHz (each pulse is ~637 T-states long). After each series of waves there is a small pause (approximately the same duration as Bit-0).

'So the 01 sequence would look like this (~~__ is one wave, --- is pause):

'---~~__~~__~~__~~__---------~~__~~__~~__~~__~~__~~__~~__~~__---------~~__~~...

'The pilot tone seems to be structured as the following sequence: 10101010 (the same timing as the data), after which the data follows immediately (no sync pulses are present between them).

'If the tape should be used for any other computer than ZX-Spectrum then it should have the 'Hardware info' block as the first block in which the computer type should be described.

'Because the standard loading data blocks of ZX-Spectrum, SAM Coupe and ZX-81 are so unique (i.e. they are always the same) the 'Standard speed' data block can be used for their description. Amstrad CPC tapes should always use the 'Custom loading' data block, since the speed is not always the same.

'// "OCTAVIA" SOUND CARD.
Function Get_OctSound(SndByte As Byte) As Long

Dim Soundval As Long, SoundFrequ As Long


Select Case SndByte
Case 7
'1 DO
SoundFrequ = 65406

Case 11
'2   DO#
SoundFrequ = 69296

Case 13
'3    RE
SoundFrequ = 73416

Case 14
'4    RE#
SoundFrequ = 77782

Case 15
' PAUSA
SoundFrequ = 0

Case 23
'5    MI
SoundFrequ = 82407

Case 27
'6    FA
SoundFrequ = 87307

Case 29
'7   FA#
SoundFrequ = 92499

Case 30
'8    SOL
SoundFrequ = 97999

Case 39
'9   SOL#
SoundFrequ = 103830

Case 43
'10   LA
SoundFrequ = 110000

Case 45
'11  LA#
SoundFrequ = 116540

Case 46
'12   SI
SoundFrequ = 123470

Case 71
'13   Do
SoundFrequ = 130810

Case 75
'14  Do
SoundFrequ = 138590

Case 77
'15   RE
SoundFrequ = 146830

Case 78
'16  RE#
SoundFrequ = 155560

Case 87
'17   MI
SoundFrequ = 164810

Case 91
'18   FA
SoundFrequ = 174610

Case 93
'19  FA#
SoundFrequ = 185000

Case 94
'20  SOL
SoundFrequ = 196000

Case 103
'21  SOL#
SoundFrequ = 207650

Case 107
'22   LA
SoundFrequ = 220000

Case 109
'23  LA#
SoundFrequ = 223080

Case 110
'24   SI
SoundFrequ = 246940

Case 135
'25  Do
SoundFrequ = 261630

Case 139
'26  Do
SoundFrequ = 277180

Case 141
'27   RE
SoundFrequ = 293660

Case 142
'28  RE#
SoundFrequ = 311130

Case 151
'29   MI
SoundFrequ = 329630

Case 155
'30   FA
SoundFrequ = 349230

Case 157
'31  FA#
SoundFrequ = 369990

Case 158
'32  SOL
SoundFrequ = 392000

Case 167
'33  SOL#
SoundFrequ = 415300

Case 171
'34   LA
SoundFrequ = 440000

Case 173
'35  LA#
SoundFrequ = 466160

Case 174
'36   SI
SoundFrequ = 493880
     
Case 199
'37   Do
SoundFrequ = 523250

Case 203
'38  Do
SoundFrequ = 554370

Case 205
'39   RE
SoundFrequ = 587330

Case 206
'40  RE#
SoundFrequ = 622250

Case 215
'41   MI
SoundFrequ = 659260

Case 219
'42   FA
SoundFrequ = 698460

Case 221
'43  FA#
SoundFrequ = 739990

Case 222
'44  SOL
SoundFrequ = 783990

Case 231
'45  SOL#
SoundFrequ = 830610

Case 235
'46   LA
SoundFrequ = 880000

Case 237
'47  LA#
SoundFrequ = 932330

Case 238
'48    SI
SoundFrequ = 987770

Case 229
'49   Do
SoundFrequ = 1046000

Case 236
'50  Do
SoundFrequ = 1108700
Case Else
SoundFrequ = 0
End Select

Soundval = 0

If SoundFrequ > 0 Then Soundval = 101562.5 / SoundFrequ * 1000


        glSoundRegister = 7
        AYWriteReg glSoundRegister, 10
        
        'Set the Chanel A
        glSoundRegister = 1
        'Set Octavia datas
        AYWriteReg glSoundRegister, Soundval \ 256
        
        'Set the Chanel A
        glSoundRegister = 0
        'Set Octavia datas
        AYWriteReg glSoundRegister, Soundval And 255
        AYWriteReg 8, 15
End Function


Sub InitSound()
gbEmulateAYSound = True

        ' // A ZX81has 16000 tstates per interrupt (0.8 MHz/SLOW)
        'glTstatesPerInterrupt = 16000
        'glWaveAddTStates = 36
        glWaveAddTStates = 160

InitializeWaveOut
End Sub

Sub CloseSound()
CloseWaveOut
End Sub

