Attribute VB_Name = "ModDiass"
' *******************************************************************************
' VB81 XuR
' ModDeass.BAS - Added by XavSnap. (2007)
' *******************************************************************************

Function Disassemble(addr As Long) As String
If addr < 0 Then Exit Function

        Dim opcode As Byte
        Dim p As Integer, Dd As Integer
        Dim Val_nnnn As Long
        Dim StrAddr As String
        Dim StrCode As String
        Dim strText As String
        Dim StrComment As String
        
        
        Dd = 0
        
        ' Comment Rom diassembly
        If addr <= 16509 Then StrComment = RomComment(addr)
        
        opcode = MEM(addr)
        StrAddr = "$" + Hex16(CLng(addr))
        
        Select Case Distag
        Case show_hex_val
         StrCode = Hex8(CLng(opcode))
        Case show_dec_val
         StrCode = opcode
        Case show_str_val
         StrCode = Chr(&H22) & ZXCharToASCII(opcode) & Chr(&H22)
        End Select
        
        
        
        addr = addr + 1
        
        If (addr > (SRamLim + 1) And Not (opcode And 64)) Then strText = "*NOP*"

If addr > 16384 And addr < 16510 Then strText = "' SYSTEM :"

        Select Case opcode
        
        Case &H0
                   strText = "NOP"
        Case &H1
                   strText = "LD BC,nnnn"
        Case &H2
                   strText = "LD (BC),A"
        Case &H3
                   strText = "INC BC"
        Case &H4
                   strText = "INC B"
        Case &H5
                   strText = "DEC B"
        Case &H6
                   strText = "LD B,nn"
        Case &H7
                   strText = "RLCA"
        Case &H8
                   strText = "EX AF,AF'"
        Case &H9
                   strText = "ADD HL,BC"
        Case &HA
                   strText = "LD A,(BC)"
        Case &HB
                   strText = "DEC BC"
        Case &HC
                   strText = "INC C"
        Case &HD
                   strText = "DEC C"
        Case &HE
                   strText = "LD C,nn"
        Case &HF
                   strText = "RRCA"
        Case &H10
                   strText = "DJNZ fz"
        Case &H11
                   strText = "LD DE,nnnn"
        Case &H12
                   strText = "LD (DE),A"
        Case &H13
                   strText = "INC DE"
        Case &H14
                   strText = "INC D"
        Case &H15
                   strText = "DEC D"
        Case &H16
                   strText = "LD D,nn"
        Case &H17
                   strText = "RLA"
        Case &H18
                   strText = "JR fz"
        Case &H19
                   strText = "ADD HL,DE"
        Case &H1A
                   strText = "LD A,(DE)"
        Case &H1B
                   strText = "DEC DE"
        Case &H1C
                   strText = "INC E"
        Case &H1D
                   strText = "DEC E"
        Case &H1E
                   strText = "LD E,nn"
        Case &H1F
                   strText = "RRA"
        Case &H20
                   strText = "JR NZ,fz"
        Case &H21
                   strText = "LD HL,nnnn"
        Case &H22
                   strText = "LD (nnnn),HL"
        Case &H23
                   strText = "INC HL"
        Case &H24
                   strText = "INC H"
        Case &H25
                   strText = "DEC H"
        Case &H26
                   strText = "LD H,nn"
        Case &H27
                   strText = "DAA"
        Case &H28
                   strText = "JR Z,fz"
        Case &H29
                   strText = "ADD HL,HL"
        Case &H2A
                   strText = "LD HL,(nnnn)"
        Case &H2B
                   strText = "DEC HL"
        Case &H2C
                   strText = "INC L"
        Case &H2D
                   strText = "DEC L"
        Case &H2E
                   strText = "LD L,nn"
        Case &H2F
                   strText = "CPL"
        Case &H30
                   strText = "JR NC,fz"
        Case &H31
                   strText = "LD SP,nnnn"
        Case &H32
                   strText = "LD (nnnn),A"
        Case &H33
                   strText = "INC SP"
        Case &H34
                   strText = "INC (HL)"
        Case &H35
                   strText = "DEC (HL)"
        Case &H36
                   strText = "LD (HL),nn"
        Case &H37
                   strText = "SCF"
        Case &H38
                   strText = "JR C,fz"
        Case &H39
                   strText = "ADD HL,SP"
        Case &H3A
                   strText = "LD A,(nnnn)"
        Case &H3B
                   strText = "DEC SP"
        Case &H3C
                   strText = "INC A"
        Case &H3D
                   strText = "DEC A"
        Case &H3E
                   strText = "LD A,nn"
        Case &H3F
                   strText = "CCF"
        Case &H40
                   strText = "LD B,B"
        Case &H41
                   strText = "LD B,C"
        Case &H42
                   strText = "LD B,D"
        Case &H43
                   strText = "LD B,E"
        Case &H44
                   strText = "LD B,H"
        Case &H45
                   strText = "LD B,L"
        Case &H46
                   strText = "LD B,(HL)"
        Case &H47
                   strText = "LD B,A"
        Case &H48
                   strText = "LD C,B"
        Case &H49
                   strText = "LD C,C"
        Case &H4A
                   strText = "LD C,D"
        Case &H4B
                   strText = "LD C,E"
        Case &H4C
                   strText = "LD C,H"
        Case &H4D
                   strText = "LD C,L"
        Case &H4E
                   strText = "LD C,(HL)"
        Case &H4F
                   strText = "LD C,A"
        Case &H50
                   strText = "LD D,B"
        Case &H51
                   strText = "LD D,C"
        Case &H52
                   strText = "LD D,D"
        Case &H53
                   strText = "LD D,E"
        Case &H54
                   strText = "LD D,H"
        Case &H55
                   strText = "LD D,L"
        Case &H56
                   strText = "LD D,(HL)"
        Case &H57
                   strText = "LD D,A"
        Case &H58
                   strText = "LD E,B"
        Case &H59
                   strText = "LD E,C"
        Case &H5A
                   strText = "LD E,D"
        Case &H5B
                   strText = "LD E,E"
        Case &H5C
                   strText = "LD E,H"
        Case &H5D
                   strText = "LD E,L"
        Case &H5E
                   strText = "LD E,(HL)"
        Case &H5F
                   strText = "LD E,A"
        Case &H60
                   strText = "LD H,B"
        Case &H61
                   strText = "LD H,C"
        Case &H62
                   strText = "LD H,D"
        Case &H63
                   strText = "LD H,E"
        Case &H64
                   strText = "LD H,H"
        Case &H65
                   strText = "LD H,L"
        Case &H66
                   strText = "LD H,(HL)"
        Case &H67
                   strText = "LD H,A"
        Case &H68
                   strText = "LD L,B"
        Case &H69
                   strText = "LD L,C"
        Case &H6A
                   strText = "LD L,D"
        Case &H6B
                   strText = "LD L,E"
        Case &H6C
                   strText = "LD L,H"
        Case &H6D
                   strText = "LD L,L"
        Case &H6E
                   strText = "LD L,(HL)"
        Case &H6F
                   strText = "LD L,A"
        Case &H70
                   strText = "LD (HL),B"
        Case &H71
                   strText = "LD (HL),C"
        Case &H72
                   strText = "LD (HL),D"
        Case &H73
                   strText = "LD (HL),E"
        Case &H74
                   strText = "LD (HL),H"
        Case &H75
                   strText = "LD (HL),L"
        Case &H76
                   strText = "HALT"
        Case &H77
                   strText = "LD (HL),A"
        Case &H78
                   strText = "LD A,B"
        Case &H79
                   strText = "LD A,C"
        Case &H7A
                   strText = "LD A,D"
        Case &H7B
                   strText = "LD A,E"
        Case &H7C
                   strText = "LD A,H"
        Case &H7D
                   strText = "LD A,L"
        Case &H7E
                   strText = "LD A,(HL)"
        Case &H7F
                   strText = "LD A,A"
        Case &H80
                   strText = "ADD A,B"
        Case &H81
                   strText = "ADD A,C"
        Case &H82
                   strText = "ADD A,D"
        Case &H83
                   strText = "ADD A,E"
        Case &H84
                   strText = "ADD A,H"
        Case &H85
                   strText = "ADD A,L"
        Case &H86
                   strText = "ADD A,(HL)"
        Case &H87
                   strText = "ADD A,A"
        Case &H88
                   strText = "ADC A,B"
        Case &H89
                   strText = "ADC A,C"
        Case &H8A
                   strText = "ADC A,D"
        Case &H8B
                   strText = "ADC A,E"
        Case &H8C
                   strText = "ADC A,H"
        Case &H8D
                   strText = "ADC A,L"
        Case &H8E
                   strText = "ADC A,(HL)"
        Case &H8F
                   strText = "ADC A,A"
        Case &H90
                   strText = "SUB B"
        Case &H91
                   strText = "SUB C"
        Case &H92
                   strText = "SUB D"
        Case &H93
                   strText = "SUB E"
        Case &H94
                   strText = "SUB H"
        Case &H95
                   strText = "SUB L"
        Case &H96
                   strText = "SUB (HL)"
        Case &H97
                   strText = "SUB A"
        Case &H98
                   strText = "SBC A,B"
        Case &H99
                   strText = "SBC A,C"
        Case &H9A
                   strText = "SBC A,D"
        Case &H9B
                   strText = "SBC A,E"
        Case &H9C
                   strText = "SBC A,H"
        Case &H9D
                   strText = "SBC A,L"
        Case &H9E
                   strText = "SBC A,(HL)"
        Case &H9F
                   strText = "SBC A,A"
        Case &HA0
                   strText = "AND A,B"
        Case &HA1
                   strText = "AND A,C"
        Case &HA2
                   strText = "AND A,D"
        Case &HA3
                   strText = "AND A,E"
        Case &HA4
                   strText = "AND A,H"
        Case &HA5
                   strText = "AND A,L"
        Case &HA6
                   strText = "AND A,(HL)"
        Case &HA7
                   strText = "AND A,A"
        Case &HA8
                   strText = "XOR A,B"
        Case &HA9
                   strText = "XOR A,C"
        Case &HAA
                   strText = "XOR A,D"
        Case &HAB
                   strText = "XOR A,E"
        Case &HAC
                   strText = "XOR A,H"
        Case &HAD
                   strText = "XOR A,L"
        Case &HAE
                   strText = "XOR A,(HL)"
        Case &HAF
                   strText = "XOR A,A"
        Case &HB0
                   strText = "OR A,B"
        Case &HB1
                   strText = "OR A,C"
        Case &HB2
                   strText = "OR A,D"
        Case &HB3
                   strText = "OR A,E"
        Case &HB4
                   strText = "OR A,H"
        Case &HB5
                   strText = "OR A,L"
        Case &HB6
                   strText = "OR A,(HL)"
        Case &HB7
                   strText = "OR A,A"
        Case &HB8
                   strText = "CP B"
        Case &HB9
                   strText = "CP C"
        Case &HBA
                   strText = "CP D"
        Case &HBB
                   strText = "CP E"
        Case &HBC
                   strText = "CP H"
        Case &HBD
                   strText = "CP L"
        Case &HBE
                   strText = "CP (HL)"
        Case &HBF
                   strText = "CP A"
        Case &HC0
                   strText = "RET NZ"
        Case &HC1
                   strText = "POP BC"
        Case &HC2
                   strText = "JP NZ,nnnn"
        Case &HC3
                   strText = "JP nnnn"
        Case &HC4
                   strText = "CALL NZ,nnnn"
        Case &HC5
                   strText = "PUSH BC"
        Case &HC6
                   strText = "ADD A,nn"
        Case &HC7
                   strText = "RST 00"
        Case &HC8
                   strText = "RET Z"
        Case &HC9
                   strText = "RET"
        Case &HCA
                   strText = "JP Z,nnnn"
        Case &HCB
                opcode = MEM(addr)
  '              If (addr >= 32768 And Not (Opcode And 64)) Then Opcode = 0
                
                        
     Select Case Distag
        Case show_hex_val
         StrCode = StrCode & ";" & Hex8(CLng(opcode))
        Case show_dec_val
         StrCode = StrCode & ";" & opcode
        Case show_str_val
         StrCode = StrCode & ";" & Chr(&H22) & ZXCharToASCII(opcode) & Chr(&H22)
     End Select
     
                             
                addr = addr + 1

                Select Case opcode
                
                Case &H0
                   strText = "RLC B"
                Case &H1
                   strText = "RLC C"
                Case &H2
                   strText = "RLC D"
                Case &H3
                   strText = "RLC E"
                Case &H4
                   strText = "RLC H"
                Case &H5
                   strText = "RLC L"
                Case &H6
                   strText = "RLC (HL)"
                Case &H7
                   strText = "RLC A"
                Case &H8
                   strText = "RRC B"
                Case &H9
                   strText = "RRC C"
                Case &HA
                   strText = "RRC D"
                Case &HB
                   strText = "RRC E"
                Case &HC
                   strText = "RRC H"
                Case &HD
                   strText = "RRC L"
                Case &HE
                   strText = "RRC (HL)"
                Case &HF
                   strText = "RRC A"
                Case &H10
                   strText = "RL B"
                Case &H11
                   strText = "RL C"
                Case &H12
                   strText = "RL D"
                Case &H13
                   strText = "RL E"
                Case &H14
                   strText = "RL H"
                Case &H15
                   strText = "RL L"
                Case &H16
                   strText = "RL (HL)"
                Case &H17
                   strText = "RL A"
                Case &H18
                   strText = "RR B"
                Case &H19
                   strText = "RR C"
                Case &H1A
                   strText = "RR D"
                Case &H1B
                   strText = "RR E"
                Case &H1C
                   strText = "RR H"
                Case &H1D
                   strText = "RR L"
                Case &H1E
                   strText = "RR (HL)"
                Case &H1F
                   strText = "RR A"
                Case &H20
                   strText = "SLA B"
                Case &H21
                   strText = "SLA C"
                Case &H22
                   strText = "SLA D"
                Case &H23
                   strText = "SLA E"
                Case &H24
                   strText = "SLA H"
                Case &H25
                   strText = "SLA L"
                Case &H26
                   strText = "SLA (HL)"
                Case &H27
                   strText = "SLA A"
                Case &H28
                   strText = "SRA B"
                Case &H29
                   strText = "SRA C"
                Case &H2A
                   strText = "SRA D"
                Case &H2B
                   strText = "SRA E"
                Case &H2C
                   strText = "SRA H"
                Case &H2D
                   strText = "SRA L"
                Case &H2E
                   strText = "SRA (HL)"
                Case &H2F
                   strText = "SRA A"
                Case &H30
                   strText = "SLL B"
                Case &H31
                   strText = "SLL C"
                Case &H32
                   strText = "SLL D"
                Case &H33
                   strText = "SLL E"
                Case &H34
                   strText = "SLL H"
                Case &H35
                   strText = "SLL L"
                Case &H36
                   strText = "SLL (HL)"
                Case &H37
                   strText = "SLL A"
                Case &H38
                   strText = "SRL B"
                Case &H39
                   strText = "SRL C"
                Case &H3A
                   strText = "SRL D"
                Case &H3B
                   strText = "SRL E"
                Case &H3C
                   strText = "SRL H"
                Case &H3D
                   strText = "SRL L"
                Case &H3E
                   strText = "SRL (HL)"
                Case &H3F
                   strText = "SRL A"
                Case &H40
                   strText = "BIT 0,B"
                Case &H41
                   strText = "BIT 0,C"
                Case &H42
                   strText = "BIT 0,D"
                Case &H43
                   strText = "BIT 0,E"
                Case &H44
                   strText = "BIT 0,H"
                Case &H45
                   strText = "BIT 0,L"
                Case &H46
                   strText = "BIT 0,(HL)"
                Case &H47
                   strText = "BIT 0,A"
                Case &H48
                   strText = "BIT 1,B"
                Case &H49
                   strText = "BIT 1,C"
                Case &H4A
                   strText = "BIT 1,D"
                Case &H4B
                   strText = "BIT 1,E"
                Case &H4C
                   strText = "BIT 1,H"
                Case &H4D
                   strText = "BIT 1,L"
                Case &H4E
                   strText = "BIT 1,(HL)"
                Case &H4F
                   strText = "BIT 1,A"
                Case &H50
                   strText = "BIT 2,B"
                Case &H51
                   strText = "BIT 2,C"
                Case &H52
                   strText = "BIT 2,D"
                Case &H53
                   strText = "BIT 2,E"
                Case &H54
                   strText = "BIT 2,H"
                Case &H55
                   strText = "BIT 2,L"
                Case &H56
                   strText = "BIT 2,(HL)"
                Case &H57
                   strText = "BIT 2,A"
                Case &H58
                   strText = "BIT 3,B"
                Case &H59
                   strText = "BIT 3,C"
                Case &H5A
                   strText = "BIT 3,D"
                Case &H5B
                   strText = "BIT 3,E"
                Case &H5C
                   strText = "BIT 3,H"
                Case &H5D
                   strText = "BIT 3,L"
                Case &H5E
                   strText = "BIT 3,(HL)"
                Case &H5F
                   strText = "BIT 3,A"
                Case &H60
                   strText = "BIT 4,B"
                Case &H61
                   strText = "BIT 4,C"
                Case &H62
                   strText = "BIT 4,D"
                Case &H63
                   strText = "BIT 4,E"
                Case &H64
                   strText = "BIT 4,H"
                Case &H65
                   strText = "BIT 4,L"
                Case &H66
                   strText = "BIT 4,(HL)"
                Case &H67
                   strText = "BIT 4,A"
                Case &H68
                   strText = "BIT 5,B"
                Case &H69
                   strText = "BIT 5,C"
                Case &H6A
                   strText = "BIT 5,D"
                Case &H6B
                   strText = "BIT 5,E"
                Case &H6C
                   strText = "BIT 5,H"
                Case &H6D
                   strText = "BIT 5,L"
                Case &H6E
                   strText = "BIT 5,(HL)"
                Case &H6F
                   strText = "BIT 5,A"
                Case &H70
                   strText = "BIT 6,B"
                Case &H71
                   strText = "BIT 6,C"
                Case &H72
                   strText = "BIT 6,D"
                Case &H73
                   strText = "BIT 6,E"
                Case &H74
                   strText = "BIT 6,H"
                Case &H75
                   strText = "BIT 6,L"
                Case &H76
                   strText = "BIT 6,(HL)"
                Case &H77
                   strText = "BIT 6,A"
                Case &H78
                   strText = "BIT 7,B"
                Case &H79
                   strText = "BIT 7,C"
                Case &H7A
                   strText = "BIT 7,D"
                Case &H7B
                   strText = "BIT 7,E"
                Case &H7C
                   strText = "BIT 7,H"
                Case &H7D
                   strText = "BIT 7,L"
                Case &H7E
                   strText = "BIT 7,(HL)"
                Case &H7F
                   strText = "BIT 7,A"
                Case &H80
                   strText = "RES 0,B"
                Case &H81
                   strText = "RES 0,C"
                Case &H82
                   strText = "RES 0,D"
                Case &H83
                   strText = "RES 0,E"
                Case &H84
                   strText = "RES 0,H"
                Case &H85
                   strText = "RES 0,L"
                Case &H86
                   strText = "RES 0,(HL)"
                Case &H87
                   strText = "RES 0,A"
                Case &H88
                   strText = "RES 1,B"
                Case &H89
                   strText = "RES 1,C"
                Case &H8A
                   strText = "RES 1,D"
                Case &H8B
                   strText = "RES 1,E"
                Case &H8C
                   strText = "RES 1,H"
                Case &H8D
                   strText = "RES 1,L"
                Case &H8E
                   strText = "RES 1,(HL)"
                Case &H8F
                   strText = "RES 1,A"
                Case &H90
                   strText = "RES 2,B"
                Case &H91
                   strText = "RES 2,C"
                Case &H92
                   strText = "RES 2,D"
                Case &H93
                   strText = "RES 2,E"
                Case &H94
                   strText = "RES 2,H"
                Case &H95
                   strText = "RES 2,L"
                Case &H96
                   strText = "RES 2,(HL)"
                Case &H97
                   strText = "RES 2,A"
                Case &H98
                   strText = "RES 3,B"
                Case &H99
                   strText = "RES 3,C"
                Case &H9A
                   strText = "RES 3,D"
                Case &H9B
                   strText = "RES 3,E"
                Case &H9C
                   strText = "RES 3,H"
                Case &H9D
                   strText = "RES 3,L"
                Case &H9E
                   strText = "RES 3,(HL)"
                Case &H9F
                   strText = "RES 3,A"
                Case &HA0
                   strText = "RES 4,B"
                Case &HA1
                   strText = "RES 4,C"
                Case &HA2
                   strText = "RES 4,D"
                Case &HA3
                   strText = "RES 4,E"
                Case &HA4
                   strText = "RES 4,H"
                Case &HA5
                   strText = "RES 4,L"
                Case &HA6
                   strText = "RES 4,(HL)"
                Case &HA7
                   strText = "RES 4,A"
                Case &HA8
                   strText = "RES 5,B"
                Case &HA9
                   strText = "RES 5,C"
                Case &HAA
                   strText = "RES 5,D"
                Case &HAB
                   strText = "RES 5,E"
                Case &HAC
                   strText = "RES 5,H"
                Case &HAD
                   strText = "RES 5,L"
                Case &HAE
                   strText = "RES 5,(HL)"
                Case &HAF
                   strText = "RES 5,A"
                Case &HB0
                   strText = "RES 6,B"
                Case &HB1
                   strText = "RES 6,C"
                Case &HB2
                   strText = "RES 6,D"
                Case &HB3
                   strText = "RES 6,E"
                Case &HB4
                   strText = "RES 6,H"
                Case &HB5
                   strText = "RES 6,L"
                Case &HB6
                   strText = "RES 6,(HL)"
                Case &HB7
                   strText = "RES 6,A"
                Case &HB8
                   strText = "RES 7,B"
                Case &HB9
                   strText = "RES 7,C"
                Case &HBA
                   strText = "RES 7,D"
                Case &HBB
                   strText = "RES 7,E"
                Case &HBC
                   strText = "RES 7,H"
                Case &HBD
                   strText = "RES 7,L"
                Case &HBE
                   strText = "RES 7,(HL)"
                Case &HBF
                   strText = "RES 7,A"
                Case &HC0
                   strText = "SET 0,B"
                Case &HC1
                   strText = "SET 0,C"
                Case &HC2
                   strText = "SET 0,D"
                Case &HC3
                   strText = "SET 0,E"
                Case &HC4
                   strText = "SET 0,H"
                Case &HC5
                   strText = "SET 0,L"
                Case &HC6
                   strText = "SET 0,(HL)"
                Case &HC7
                   strText = "SET 0,A"
                Case &HC8
                   strText = "SET 1,B"
                Case &HC9
                   strText = "SET 1,C"
                Case &HCA
                   strText = "SET 1,D"
                Case &HCB
                   strText = "SET 1,E"
                Case &HCC
                   strText = "SET 1,H"
                Case &HCD
                   strText = "SET 1,L"
                Case &HCE
                   strText = "SET 1,(HL)"
                Case &HCF
                   strText = "SET 1,A"
                Case &HD0
                   strText = "SET 2,B"
                Case &HD1
                   strText = "SET 2,C"
                Case &HD2
                   strText = "SET 2,D"
                Case &HD3
                   strText = "SET 2,E"
                Case &HD4
                   strText = "SET 2,H"
                Case &HD5
                   strText = "SET 2,L"
                Case &HD6
                   strText = "SET 2,(HL)"
                Case &HD7
                   strText = "SET 2,A"
                Case &HD8
                   strText = "SET 3,B"
                Case &HD9
                   strText = "SET 3,C"
                Case &HDA
                   strText = "SET 3,D"
                Case &HDB
                   strText = "SET 3,E"
                Case &HDC
                   strText = "SET 3,H"
                Case &HDD
                   strText = "SET 3,L"
                Case &HDE
                   strText = "SET 3,(HL)"
                Case &HDF
                   strText = "SET 3,A"
                Case &HE0
                   strText = "SET 4,B"
                Case &HE1
                   strText = "SET 4,C"
                Case &HE2
                   strText = "SET 4,D"
                Case &HE3
                   strText = "SET 4,E"
                Case &HE4
                   strText = "SET 4,H"
                Case &HE5
                   strText = "SET 4,L"
                Case &HE6
                   strText = "SET 4,(HL)"
                Case &HE7
                   strText = "SET 4,A"
                Case &HE8
                   strText = "SET 5,B"
                Case &HE9
                   strText = "SET 5,C"
                Case &HEA
                   strText = "SET 5,D"
                Case &HEB
                   strText = "SET 5,E"
                Case &HEC
                   strText = "SET 5,H"
                Case &HED
                   strText = "SET 5,L"
                Case &HEE
                   strText = "SET 5,(HL)"
                Case &HEF
                   strText = "SET 5,A"
                Case &HF0
                   strText = "SET 6,B"
                Case &HF1
                   strText = "SET 6,C"
                Case &HF2
                   strText = "SET 6,D"
                Case &HF3
                   strText = "SET 6,E"
                Case &HF4
                   strText = "SET 6,H"
                Case &HF5
                   strText = "SET 6,L"
                Case &HF6
                   strText = "SET 6,(HL)"
                Case &HF7
                   strText = "SET 6,A"
                Case &HF8
                   strText = "SET 7,B"
                Case &HF9
                   strText = "SET 7,C"
                Case &HFA
                   strText = "SET 7,D"
                Case &HFB
                   strText = "SET 7,E"
                Case &HFC
                   strText = "SET 7,H"
                Case &HFD
                   strText = "SET 7,L"
                Case &HFE
                   strText = "SET 7,(HL)"
                Case &HFF
                   strText = "SET 7,A"
                End Select
                 GoTo End_Of_OpCode
        Case &HCC
                   strText = "CALL Z,nnnn"
        Case &HCD
                   strText = "CALL nnnn"
        Case &HCE
                   strText = "ADC A,nn"
        Case &HCF
                   strText = "RST 08"
        Case &HD0
                   strText = "RET NC"
        Case &HD1
                   strText = "POP DE"
        Case &HD2
                   strText = "JP NC,nnnn"
        Case &HD3
                   strText = "OUT (nn),A"
        Case &HD4
                   strText = "CALL NC,nnnn"
        Case &HD5
                   strText = "PUSH DE"
        Case &HD6
                   strText = "SUB nn"
        Case &HD7
                   strText = "RST 10": StrComment = "Display= A reg."
        Case &HD8
                   strText = "RET C"
        Case &HD9
                   strText = "EXX"
        Case &HDA
                   strText = "JP C,nnnn"
        Case &HDB
                   strText = "IN A,(nn)"
        Case &HDC
                   strText = "CALL C,nnnn"
        Case &HDD
                opcode = MEM(addr)
                'If (addr >= 32768 And Not (Opcode And 64)) Then Opcode = 0
                                   
     Select Case Distag
        Case show_hex_val
         StrCode = StrCode & ";" & Hex8(CLng(opcode))
        Case show_dec_val
         StrCode = StrCode & ";" & opcode
        Case show_str_val
         StrCode = StrCode & ";" & Chr(&H22) & ZXCharToASCII(opcode) & Chr(&H22)
     End Select
     
                addr = addr + 1

                Select Case opcode
                
                Case &H9
                   strText = "ADD IX,BC"
                Case &H19
                   strText = "ADD IX,DE"
                Case &H21
                   strText = "LD IX,nnnn"
                Case &H22
                   strText = "LD (nnnn),IX"
                Case &H23
                   strText = "INC IX"
                Case &H24
                   strText = "INC IXH"
                Case &H25
                   strText = "DEC IXH"
                Case &H26
                   strText = "LD IXH,nn"
                Case &H29
                   strText = "ADD IX,IX"
                Case &H2A
                   strText = "LD IX,(nnnn)"
                Case &H2B
                   strText = "DEC IX"
                Case &H2C
                   strText = "INC IXL"
                Case &H2D
                   strText = "DEC IXL"
                Case &H2E
                   strText = "LD IXL,nn"
                Case &H34
                   strText = "INC (IX+dd)"
                Case &H35
                   strText = "DEC (IX+dd)"
                Case &H36
                   strText = "LD (IX+dd),nn"
                Case &H39
                   strText = "ADD IX,SP"
                Case &H44
                   strText = "LD B,IXH"
                Case &H45
                   strText = "LD B,IXL"
                Case &H46
                   strText = "LD B,(IX+dd)"
                Case &H4C
                   strText = "LD C,IXH"
                Case &H4D
                   strText = "LD C,IXL"
                Case &H4E
                   strText = "LD C,(IX+dd)"
                Case &H54
                   strText = "LD D,IXH"
                Case &H55
                   strText = "LD D,IXL"
                Case &H56
                   strText = "LD D,(IX+dd)"
                Case &H5C
                   strText = "LD E,IXH"
                Case &H5D
                   strText = "LD E,IXL"
                Case &H5E
                   strText = "LD E,(IX+dd)"
                Case &H60
                   strText = "LD IXH,B"
                Case &H61
                   strText = "LD IXH,C"
                Case &H62
                   strText = "LD IXH,D"
                Case &H63
                   strText = "LD IXH,E"
                Case &H64
                   strText = "LD IXH,IXH"
                Case &H65
                   strText = "LD IXH,IXL"
                Case &H66
                   strText = "LD H,(IX+dd)"
                Case &H67
                   strText = "LD IXH,A"
                Case &H68
                   strText = "LD IXL,B"
                Case &H69
                   strText = "LD IXL,C"
                Case &H6A
                   strText = "LD IXL,D"
                Case &H6B
                   strText = "LD IXL,E"
                Case &H6C
                   strText = "LD IXL,IXH"
                Case &H6D
                   strText = "LD IXL,IXL"
                Case &H6E
                   strText = "LD L,(IX+dd)"
                Case &H6F
                   strText = "LD IXL,A"
                Case &H70
                   strText = "LD (IX+dd),B"
                Case &H71
                   strText = "LD (IX+dd),C"
                Case &H72
                   strText = "LD (IX+dd),D"
                Case &H73
                   strText = "LD (IX+dd),E"
                Case &H74
                   strText = "LD (IX+dd),H"
                Case &H75
                   strText = "LD (IX+dd),L"
                Case &H77
                   strText = "LD (IX+dd),A"
                Case &H7C
                   strText = "LD A,IXH"
                Case &H7D
                   strText = "LD A,IXL"
                Case &H7E
                   strText = "LD A,(IX+dd)"
                Case &H84
                   strText = "ADD A,IXH"
                Case &H85
                   strText = "ADD A,IXL"
                Case &H86
                   strText = "ADD A,(IX+dd)"
                Case &H8C
                   strText = "ADC A,IXH"
                Case &H8D
                   strText = "ADC A,IXL"
                Case &H8E
                   strText = "ADC A,(IX+dd)"
                Case &H94
                   strText = "SUB A,IXH"
                Case &H95
                   strText = "SUB A,IXL"
                Case &H96
                   strText = "SUB A,(IX+dd)"
                Case &H9C
                   strText = "SBC A,IXH"
                Case &H9D
                   strText = "SBC A,IXL"
                Case &H9E
                   strText = "SBC A,(IX+dd)"
                Case &HA4
                   strText = "AND A,IXH"
                Case &HA5
                   strText = "AND A,IXL"
                Case &HA6
                   strText = "AND A,(IX+dd)"
                Case &HAC
                   strText = "XOR A,IXH"
                Case &HAD
                   strText = "XOR A,IXL"
                Case &HAE
                   strText = "XOR A,(IX+dd)"
                Case &HB4
                   strText = "OR A,IXH"
                Case &HB5
                   strText = "OR A,IXL"
                Case &HB6
                   strText = "OR A,(IX+dd)"
                Case &HBC
                   strText = "CP A,IXH"
                Case &HBD
                   strText = "CP A,IXL"
                Case &HBE
                   strText = "CP A,(IX+dd)"
                Case &HCB
                
                opcode = MEM(addr)
                'If (addr >= 32768 And Not (Opcode And 64)) Then Opcode = 0
            
                                   
     Select Case Distag
        Case show_hex_val
         StrCode = StrCode & ";" & Hex8(CLng(opcode))
        Case show_dec_val
         StrCode = StrCode & ";" & opcode
        Case show_str_val
         StrCode = StrCode & ";" & Chr(&H22) & ZXCharToASCII(opcode) & Chr(&H22)
     End Select
     
    
            Dd = MEM(addr): addr = addr + 1: opcode = MEM(addr)
 
              ' IX bit instructions (DD:CB)
              strText = GetXi_Yi(opcode, "IX")
              GoTo End_Of_OpCode
                
                Case &HE1
                   strText = "POP IX"
                Case &HE3
                   strText = "EX (SP),IX"
                Case &HE5
                   strText = "PUSH IX"
                Case &HE9
                   strText = "JP (IX)"
                Case &HF9
                   strText = "LD SP,IX"
                End Select
                
        Case &HDE
                   strText = "SBC A,nn"
        Case &HDF
                   strText = "RST 18"
        Case &HE0
                   strText = "RET PO"
        Case &HE1
                   strText = "POP HL"
        Case &HE2
                   strText = "JP PO,nnnn"
        Case &HE3
                   strText = "EX (SP),HL"
        Case &HE4
                   strText = "CALL PO,nnnn"
        Case &HE5
                   strText = "PUSH HL"
        Case &HE6
                   strText = "AND nn"
        Case &HE7
                   strText = "RST 20"
        Case &HE8
                   strText = "RET PE"
        Case &HE9
                   strText = "JP (HL)"
        Case &HEA
                   strText = "JP PE,nnnn"
        Case &HEB
                   strText = "EX DE,HL"
        Case &HEC
                   strText = "CALL PE,nnnn"
        Case &HED
                opcode = MEM(addr)
   '             If (addr >= 32768 And Not (Opcode And 64)) Then Opcode = 0
                                   
     Select Case Distag
        Case show_hex_val
         StrCode = StrCode & ";" & Hex8(CLng(opcode))
        Case show_dec_val
         StrCode = StrCode & ";" & opcode
        Case show_str_val
         StrCode = StrCode & ";" & Chr(&H22) & ZXCharToASCII(opcode) & Chr(&H22)
     End Select
     

                addr = addr + 1

                Select Case opcode
                
                Case &H40
                   strText = "IN B,(C)"
                Case &H41
                   strText = "OUT (C),B"
                Case &H42
                   strText = "SBC HL,BC"
                Case &H43
                   strText = "LD (nnnn),BC"
                Case &H44
                   strText = "NEG"
                Case &H45
                   strText = "RETN"
                Case &H46
                   strText = "IM 0"
                Case &H47
                   strText = "LD I,A"
                Case &H48 '72
                   strText = "IN C,(nn)"
                Case &H49
                   strText = "OUT (nn),C"
                Case &H4A '74
                   strText = "ADC HL,BC"
                Case &H4B '75
                   strText = "LD BC,(nnnn)"
                Case &H4C
                   strText = "NEG"
                Case &H4D '77
                   strText = "RETI"
                Case &H4E '78
                   strText = "IM 0"
                Case &H4F '79
                   strText = "LD R,A"
                Case &H50 '80
                   strText = "IN D,(c)"
                Case &H51 '81
                   strText = "OUT (c),D"
                Case &H52 '82
                   strText = "SBC HL,DE"
                Case &H53 '83
                   strText = "LD (nnnn),DE"
                Case &H54 '84
                    strText = "NEG"
                Case &H55 '85
                   strText = "RETn"
                Case &H56 '86
                   strText = "IM 1"
                Case &H57 '87
                   strText = "LD A,I"
                Case &H58 '88
                   strText = "IN E,(c)"
                Case &H59 '89
                   strText = "OUT (c),E"
                Case &H5A '90
                   strText = "ADC HL,DE"
                Case &H5B '91
                   strText = "LD DE,(nnnn)"
                Case &H5C '92
                   strText = "NEG"
                Case &H5D '93
                   strText = "RETI"
                Case &H5E '94
                   strText = "IM 2"
                Case &H5F '95
                   strText = "LD A,R"
                Case &H60 '96
                   strText = "IN H,(c)"
                Case &H61 '97
                   strText = "OUT (c),H"
                Case &H62 '98
                   strText = "SBC HL,HL"
                Case &H63 '99
                   strText = "LD (nnnn),HL"
                Case &H64 '100
                   strText = "NEG"
                Case &H65 '101
                   strText = "RETn"
                Case &H66 '102
                   strText = "IM 0"
                Case &H67 '103
                   strText = "RRD"
                Case &H68 '104
                   strText = "IN L,(c)"
                Case &H69 '105
                   strText = "OUT (c),L"
                Case &H6A '106
                   strText = "ADC HL,HL"
                Case &H6B '107
                   strText = "LD HL,(nnnn)"
                Case &H6C '108
                   strText = "NEG"
                Case &H6D '109
                   strText = "RETI"
                Case &H6E '110
                   strText = "IM 0"
                Case &H6F '111
                   strText = "RLD"
                Case &H70 '112
                   strText = "IN (c)"
                Case &H71 '113
                   strText = "OUT (c),0"
                Case &H72 '114
                   strText = "SBC HL,SP"
                Case &H73 '115
                   strText = "LD (nnnn),SP"
                Case &H74 '116
                   strText = "NEG"
                Case &H75 '117
                   strText = "RETn"
                Case &H76 '118
                   strText = "IM 1"
                Case &H77 '119
                   strText = "Unknown"
                Case &H78 '120
                   strText = "IN A,(c)"
                Case &H79 '121
                   strText = "OUT (c),A"
                Case &H80 '122
                   strText = "ADC HL,SP"
                Case &H81 '123
                   strText = "LD SP,(nnnn)"
                Case &H82 '124
                   strText = "NEG"
                Case &H83 '125
                   strText = "RETI"
                Case &H84 '126
                   strText = "IM 2"
                Case &H85 '127
                   strText = "NOP"
                Case &H6E
                   strText = "IM 0"
                Case &H47
                   strText = "LD I,A"
                Case &H48
                   strText = "IN C,(C)"
                Case &H49
                   strText = "OUT (C),C"
                Case &H4A
                   strText = "ADC HL,BC"
                Case &H4B
                   strText = "LD BC,(nnnn)"
                Case &H4F
                   strText = "LD R,A"
                Case &H50
                   strText = "IN D,(C)"
                Case &H51
                   strText = "OUT (C),D"
                Case &H52
                   strText = "SBC HL,DE"
                Case &H53
                   strText = "LD (nnnn),DE"
                Case &H56:
                Case &H76
                   strText = "IM 1"
                Case &H57
                   strText = "LD A,I"
                Case &H58
                   strText = "IN E,(C)"
                Case &H59
                   strText = "OUT (C),E"
                Case &H5A
                   strText = "ADC HL,DE"
                Case &H5B
                   strText = "LD DE,(nnnn)"
                Case &H5E
                Case &H7E
                   strText = "IM 2"
                Case &H5F
                   strText = "LD A,R"
                Case &H60
                   strText = "IN H,(C)"
                Case &H61
                   strText = "OUT (C),H"
                Case &H62
                   strText = "SBC HL,HL"
                Case &H63
                   strText = "LD (nnnn),HL"
                Case &H67
                   strText = "RRD"
                Case &H68
                   strText = "IN L,(C)"
                Case &H69
                   strText = "OUT (C),L"
                Case &H6A
                   strText = "ADC HL,HL"
                Case &H6B
                   strText = "LD HL,(nnnn)"
                Case &H6F
                   strText = "RLD"
                Case &H70
                   strText = "IN F,(C)"
                Case &H71
                   strText = "OUT (C),0"
                Case &H72
                   strText = "SBC HL,SP"
                Case &H73
                   strText = "LD (nnnn),SP"
                Case &H78
                   strText = "IN A,(C)"
                Case &H79
                   strText = "OUT (C),A"
                Case &H7A
                   strText = "ADC HL,SP"
                Case &H7B
                   strText = "LD SP,(nnnn)"
                Case &HA0
                   strText = "LDI"
                Case &HA1
                   strText = "CPI"
                Case &HA2
                   strText = "INI"
                Case &HA3
                   strText = "OUTI"
                Case &HA8
                   strText = "LDD"
                Case &HA9
                   strText = "CPD"
                Case &HAA
                   strText = "IND"
                Case &HAB
                   strText = "OUTD"
                Case &HB0
                   strText = "LDIR"
                Case &HB1
                   strText = "CPIR"
                Case &HB2
                   strText = "INIR"
                Case &HB3
                   strText = "OTIR"
                Case &HB8
                   strText = "LDDR"
                Case &HB9
                   strText = "CPDR"
                Case &HBA
                   strText = "INDR"
                Case &HBB
                   strText = "OTDR"
                   
                Case &HFC
                   strText = "LDIR" ' EDB0 ( ED;FC is illegal)
                   StrComment = "Patch tape LOAD"
                Case &HFD
                   strText = "LDIR" ' EDB0 ( ED;FD is illegal)
                   StrComment = "Patch tape SAVE"
                
                Case &HFE
                   strText = "LDIR" ' EDB0 ( ED;FE is illegal)
                   StrComment = "Patch Larken LOAD"
                   
                Case &HFF
                   strText = "LDIR" ' EDB0 ( ED;FF is illegal)
                   StrComment = "Patch Larken Save"
                   
                
                End Select
                GoTo End_Of_OpCode
        Case &HEE
                   strText = "XOR A,nn"
        Case &HEF
                   strText = "RST 28":  GoTo End_Of_OpCode
        Case &HF0
                   strText = "RET P"
        Case &HF1
                   strText = "POP AF"
        Case &HF2
                   strText = "JP P,nnnn"
        Case &HF3
                   strText = "DI"
        Case &HF4
                   strText = "CALL P,nnnn"
        Case &HF5
                   strText = "PUSH AF"
        Case &HF6
                   strText = "OR nn"
        Case &HF7
                   strText = "RST 30"
        Case &HF8
                   strText = "RET M"
        Case &HF9
                   strText = "LD SP,HL"
        Case &HFA
                   strText = "JP M,nnnn"
        Case &HFB
                   strText = "EI"
        Case &HFC
                   strText = "CALL M,nnnn"
        Case &HFD
                opcode = MEM(addr)
  '              If (addr >= 32768 And Not (Opcode And 64)) Then Opcode = 0
                  
                  
                                   
     Select Case Distag
        Case show_hex_val
         StrCode = StrCode & ";" & Hex8(CLng(opcode))
        Case show_dec_val
         StrCode = StrCode & ";" & opcode
        Case show_str_val
         StrCode = StrCode & ";" & Chr(&H22) & ZXCharToASCII(opcode) & Chr(&H22)
     End Select
      
                addr = addr + 1


                Select Case opcode
                
                Case &H9
                   strText = "ADD IY,BC"
                Case &H19
                   strText = "ADD IY,DE"
                Case &H21
                   strText = "LD IY,nnnn"
                Case &H22
                   strText = "LD (nnnn),IY"
                Case &H23
                   strText = "INC IY"
                Case &H24
                   strText = "INC IYH"
                Case &H25
                   strText = "DEC IYH"
                Case &H26
                   strText = "LD IYH,nn"
                Case &H29
                   strText = "ADD IY,IY"
                Case &H2A
                   strText = "LD IY,(nnnn)"
                Case &H2B
                   strText = "DEC IY"
                Case &H2C
                   strText = "INC IYL"
                Case &H2D
                   strText = "DEC IYL"
                Case &H2E
                   strText = "LD IYL,nn"
                Case &H34
                   strText = "INC (IY+dd)"
                Case &H35
                   strText = "DEC (IY+dd)"
                Case &H36
                   strText = "LD (IY+dd),nn"
                Case &H39
                   strText = "ADD IY,SP"
                Case &H44
                   strText = "LD B,IYH"
                Case &H45
                   strText = "LD B,IYL"
                Case &H46
                   strText = "LD B,(IY+dd)"
                Case &H4C
                   strText = "LD C,IYH"
                Case &H4D
                   strText = "LD C,IYL"
                Case &H4E
                   strText = "LD C,(IY+dd)"
                Case &H54
                   strText = "LD D,IYH"
                Case &H55
                   strText = "LD D,IYL"
                Case &H56
                   strText = "LD D,(IY+dd)"
                Case &H5C
                   strText = "LD E,IYH"
                Case &H5D
                   strText = "LD E,IYL"
                Case &H5E
                   strText = "LD E,(IY+dd)"
                Case &H60
                   strText = "LD IYH,B"
                Case &H61
                   strText = "LD IYH,C"
                Case &H62
                   strText = "LD IYH,D"
                Case &H63
                   strText = "LD IYH,E"
                Case &H64
                   strText = "LD IYH,IYH"
                Case &H65
                   strText = "LD IYH,IYL"
                Case &H66
                   strText = "LD H,(IY+dd)"
                Case &H67
                   strText = "LD IYH,A"
                Case &H68
                   strText = "LD IYL,B"
                Case &H69
                   strText = "LD IYL,C"
                Case &H6A
                   strText = "LD IYL,D"
                Case &H6B
                   strText = "LD IYL,E"
                Case &H6C
                   strText = "LD IYL,IYH"
                Case &H6D
                   strText = "LD IYL,IYL"
                Case &H6E
                   strText = "LD L,(IY+dd)"
                Case &H6F
                   strText = "LD IYL,A"
                Case &H70
                   strText = "LD (IY+dd),B"
                Case &H71
                   strText = "LD (IY+dd),C"
                Case &H72
                   strText = "LD (IY+dd),D"
                Case &H73
                   strText = "LD (IY+dd),E"
                Case &H74
                   strText = "LD (IY+dd),H"
                Case &H75
                   strText = "LD (IY+dd),L"
                Case &H77
                   strText = "LD (IY+dd),A"
                Case &H7C
                   strText = "LD A,IYH"
                Case &H7D
                   strText = "LD A,IYL"
                Case &H7E
                   strText = "LD A,(IY+dd)"
                Case &H84
                   strText = "ADD A,IYH"
                Case &H85
                   strText = "ADD A,IYL"
                Case &H86
                   strText = "ADD A,(IY+dd)"
                Case &H8C
                   strText = "ADC A,IYH"
                Case &H8D
                   strText = "ADC A,IYL"
                Case &H8E
                   strText = "ADC A,(IY+dd)"
                Case &H94
                   strText = "SUB A,IYH"
                Case &H95
                   strText = "SUB A,IYL"
                Case &H96
                   strText = "SUB A,(IY+dd)"
                Case &H9C
                   strText = "SBC A,IYH"
                Case &H9D
                   strText = "SBC A,IYL"
                Case &H9E
                   strText = "SBC A,(IY+dd)"
                Case &HA4
                   strText = "AND A,IYH"
                Case &HA5
                   strText = "AND A,IYL"
                Case &HA6
                   strText = "AND A,(IY+dd)"
                Case &HAC
                   strText = "XOR A,IYH"
                Case &HAD
                   strText = "XOR A,IYL"
                Case &HAE
                   strText = "XOR A,(IY+dd)"
                Case &HB4
                   strText = "OR A,IYH"
                Case &HB5
                   strText = "OR A,IYL"
                Case &HB6
                   strText = "OR A,(IY+dd)"
                Case &HBC
                   strText = "CP A,IYH"
                Case &HBD
                   strText = "CP A,IYL"
                Case &HBE
                   strText = "CP A,(IY+dd)"
                Case &HCB
                
                opcode = MEM(addr)
  '              If (addr >= 32768 And Not (Opcode And 64)) Then Opcode = 0
                
                                   
     Select Case Distag
        Case show_hex_val
         StrCode = StrCode & ";" & Hex8(CLng(opcode))
        Case show_dec_val
         StrCode = StrCode & ";" & opcode
        Case show_str_val
         StrCode = StrCode & ";" & Chr(&H22) & ZXCharToASCII(opcode) & Chr(&H22)
     End Select
     
            Dd = MEM(addr): addr = addr + 1: opcode = MEM(addr)
                            
              ' IX bit instructions (DD:CB)
              strText = GetXi_Yi(opcode, "IY")
              GoTo End_Of_OpCode
                

               
               Case &HE1
                   strText = "POP IY"
                Case &HE3
                   strText = "EX (SP),IY"
                Case &HE5
                   strText = "PUSH IY"
                Case &HE9
                   strText = "JP (IY)"
                Case &HF9
                   strText = "LD SP,IY"
                End Select
                GoTo End_Of_OpCode
                
        Case &HFE
                strText = "CP nn"
                If addr < UBound(MEM) Then
                    StrComment = "[" & Trim(Str(CLng(MEM(addr)))) & IIf((MEM(addr) > 10 And MEM(addr) < 64) Or (MEM(addr) > 138 And MEM(addr) < 191), "-" & Chr(&H22) & ZXCharToASCII(MEM(addr)) & Chr(&H22), "") & "]"
                End If
                GoTo End_Of_OpCode
        Case &HFF
                   strText = "RST 38"
                   
        End Select
      
        
End_Of_OpCode:

p = InStr(1, strText, "+dd")
        If p > 0 Then
                
                Dim i As Byte
               
                i = MEM(addr)
                If Dd > 0 Then i = Dd
                Dd = 0
                If (i >= 128) Then
                strText = StrRep(strText, p, 3, "-" + Trim(Str(255 - i)))
                Else
                strText = StrRep(strText, p, 3, "+" + Trim(Str(i)))
                End If
                                   
             Select Case Distag
               Case show_hex_val
                StrCode = StrCode & ";" & Hex8(CLng(MEM(addr)))
                Case show_dec_val
                 StrCode = StrCode & ";" & MEM(addr)
                Case show_str_val
                 StrCode = StrCode & ";" & Chr(&H22) & ZXCharToASCII(MEM(addr)) & Chr(&H22)
             End Select
     
                addr = addr + 1
        End If
        


p = InStr(1, strText, "nnnn")
        If p > 0 Then
                Val_nnnn = CLng(MEM(addr)) + 256 * CLng(MEM(addr + 1))
     
                  
                  
                  If InStr(1, strText, "(nnnn),") > 0 And Val_nnnn > 16384 And Val_nnnn < 16512 Then
                  StrComment = "SET " & RomComment(Val_nnnn) & IIf(StrComment <> "", ";", "") & StrComment
                  End If
                  
                  If InStr(1, strText, ",(nnnn)") > 0 And Val_nnnn > 16384 And Val_nnnn < 16512 Then
                  StrComment = "GET " & RomComment(Val_nnnn) & IIf(StrComment <> "", ";", "") & StrComment
                  End If
     
                 strText = StrRep(strText, p, 4, "$" + Hex16(Val_nnnn))
                 
                  If InStr(1, strText, "CALL") > 0 Or InStr(1, strText, "JP") > 0 Then
                  
                     If Val_nnnn <= 8192 Then
                     StrComment = Trim(StrComment)
                     StrComment = "[" & RomComment(Val_nnnn) & "]" & IIf(StrComment <> "", ";", "") & StrComment

                  
                    If Left(StrComment, 2) = "[]" And Val_nnnn <= 8192 - 500 Then StrComment = StrComment + "*BIOS ROM*" & IIf(StrComment <> "[]", ";", "") & IIf(Len(StrComment) > 2, Right(StrComment, Len(StrComment) - 2), "")
                    If Left(StrComment, 2) = "[]" And Val_nnnn > 8192 - 500 And Val_nnnn <= 8192 Then StrComment = StrComment + "*CHR ROM*" & IIf(StrComment <> "[]", ";", "") & IIf(Len(StrComment) > 2, Right(StrComment, Len(StrComment) - 2), "")
                  Else
                    If Left(StrComment, 2) = "" Then StrComment = "[" & Val_nnnn & "]"
                  End If
                  

                  End If
                
                                   
             Select Case Distag
               Case show_hex_val
                StrCode = StrCode & ";" & Hex8(CLng(MEM(addr))) & ";" & Hex8(CLng(MEM(addr + 1)))
                Case show_dec_val
                 StrCode = StrCode & ";" & MEM(addr) & ";" & MEM(addr + 1)
                Case show_str_val
                 StrCode = StrCode & ";" & Chr(&H22) & ZXCharToASCII(MEM(addr)) & Chr(&H22) & ";" & Chr(&H22) & ZXCharToASCII(MEM(addr + 1)) & Chr(&H22)
             End Select
               
                 addr = addr + 2
        End If
        
p = InStr(1, strText, "nn")
        If p > 0 Then
                strText = StrRep(strText, p, 2, "$" + Hex8(CLng(MEM(addr))))
                
             If InStr(1, strText, "IN ") Then StrComment = GetIOinTagCom(Hex8(CLng(MEM(addr))))
             If InStr(1, strText, "OUT") Then StrComment = GetIOoutTagCom(Hex8(CLng(MEM(addr))))
              
             Select Case Distag
               Case show_hex_val
                StrCode = StrCode & ";" & Hex8(CLng(MEM(addr)))
                Case show_dec_val
                 StrCode = StrCode & ";" & MEM(addr)
                Case show_str_val
                 StrCode = StrCode & ";" & Chr(&H22) & ZXCharToASCII(MEM(addr)) & Chr(&H22)
             End Select
               
               
                addr = addr + 1


        End If
        
p = InStr(1, strText, "fz")
        If p > 0 Then
               If MEM(addr) And 128 Then
               strText = StrRep(strText, p, 2, Trim(Str(-255 + MEM(addr))))
               StrComment = "[$" & Hex16(addr - 255 + MEM(addr)) & ":" & (addr - 255 + MEM(addr)) & "]" & IIf(StrComment <> "", ";", "") & StrComment
               Else
               strText = StrRep(strText, p, 2, "+" & (Trim(Str(MEM(addr)))) + 1)
               StrComment = "[$" & Hex16(addr + MEM(addr) + 1) & ":" & (addr + MEM(addr) + 1) & "]" & IIf(StrComment <> "", ";", "") & StrComment
               End If
               
             Select Case Distag
               Case show_hex_val
                StrCode = StrCode & ";" & Hex8(CLng(MEM(addr)))
                Case show_dec_val
                 StrCode = StrCode & ";" & MEM(addr)
                Case show_str_val
                 StrCode = StrCode & ";" & Chr(&H22) & ZXCharToASCII(MEM(addr)) & Chr(&H22)
             End Select
                
               addr = addr + 1

        End If
        
'If addr > 40959 Then
'Debug.Print
'End If

     DASM_Offset = addr

     If StrComment = "" Then StrAddr = StrCode + "|" + strText Else StrAddr = StrCode + "|" + strText + "|" + StrComment
         
  
   
   Disassemble = StrAddr
End Function


Private Function StrRep(text As String, pos As Integer, length As Integer, put_str As String)
' "123","12","67" - StrRep("1231267",4,2,45)
' "123","45","67"

Dim tmp_char_L As String
Dim tmp_char_R As String
tmp_char_L = Left(text, pos - 1)

If (pos) + length <= Len(text) Then
tmp_char_R = Right(text, Len(text) - pos - length + 1)
End If

StrRep = tmp_char_L & put_str & tmp_char_R
End Function



Private Function Hex16(Value As Long) As String
If Value < 16 Then
   Hex16 = "000" & Hex(Value): Exit Function
ElseIf Value < 256 Then
   Hex16 = "00" & Hex(Value): Exit Function
ElseIf Value < 4096 Then
   Hex16 = "0" & Hex(Value): Exit Function
End If
Hex16 = Hex(Value)

End Function

Private Function RomComment(RomOffset As Long) As String

Select Case RomOffset
Case &H0
     RomComment = "Start": Exit Function

Case &H6
     RomComment = "ERROR-1": Exit Function

Case &H10
     RomComment = "Print-A": Exit Function

Case &H1B
     RomComment = "GET-CH": Exit Function

Case &H20
     RomComment = "NEXT-CH": Exit Function

Case &H28
     RomComment = "FP-CALC": Exit Function

Case &H2B
     RomComment = "END-CALC": Exit Function

Case &H30
     RomComment = "BC-SPACE": Exit Function

Case &H38
     RomComment = "INTERRUPT": Exit Function

Case &H41
     RomComment = "WAIT-INT": Exit Function

Case &H45
     RomComment = "SCAN-LINE": Exit Function

Case &H49
     RomComment = "CH-ADD": Exit Function

Case &H4C
     RomComment = "CURSOR-SO": Exit Function

Case &H4D
     RomComment = "TEMP-PTR": Exit Function

Case &H56
     RomComment = "ERROR-2": Exit Function

Case &H58
     RomComment = "ERROR-3": Exit Function

Case &H68
     RomComment = "NMI": Exit Function

Case &H6D
     RomComment = "NMI-RET": Exit Function

Case &H1FC
     RomComment = "Load/Save": Exit Function

Case &H207
     RomComment = "SLOW/FAST": Exit Function

Case &H216
     RomComment = "Loop-11": Exit Function

Case &H226
     RomComment = "No-SLOW": Exit Function

Case &H237
     RomComment = "ANOTHER": Exit Function

Case &H239
     RomComment = "OVER-NC": Exit Function

Case &H23E
     RomComment = "DISPLAY-2": Exit Function

Case &H264
     RomComment = "No-KEY": Exit Function

Case &H26A
     RomComment = "LOOP-B": Exit Function

Case &H292
     RomComment = "DISPLAY-3": Exit Function

Case &H2A9
     RomComment = "DISPLAY-4": Exit Function

Case &H2B5
     RomComment = "DISPLAY-5": Exit Function

Case &H2BB
     RomComment = "KEYBOARD": Exit Function

Case &H2C5
     RomComment = "EACH-LINE": Exit Function

Case &H2E7
     RomComment = "SET-FAST": Exit Function

Case &H2F4
     RomComment = "REPORT-F": Exit Function

Case &H2F6
     RomComment = "Save": Exit Function

Case &H2FF
     RomComment = "Save-Header": Exit Function

Case &H304
     RomComment = "DELAY-1": Exit Function

Case &H30B
     RomComment = "OUT-NAME": Exit Function

Case &H316
     RomComment = "OUT-PROGRAM": Exit Function

Case &H31E
     RomComment = "OUT-BYTE": Exit Function

Case &H320
     RomComment = "EACH-BIT": Exit Function

Case &H329
     RomComment = "PULSES": Exit Function

Case &H32D
     RomComment = "DELAY-2": Exit Function

Case &H332
     RomComment = "BREAK-2": Exit Function

Case &H336
     RomComment = "DELAY-3": Exit Function

Case &H33B
     RomComment = "DELAY-4": Exit Function

Case &H340
     RomComment = "LOAD": Exit Function

Case &H347
     RomComment = "NEXT-PROG": Exit Function

Case &H34C
     RomComment = "IN-BYTE": Exit Function

Case &H34E
     RomComment = "NEXT-BIT": Exit Function

Case &H350
     RomComment = "BREAK-3": Exit Function

Case &H361
     RomComment = "RESTART": Exit Function

Case &H366
     RomComment = "IN-NAME": Exit Function

Case &H371
     RomComment = "MATCHING": Exit Function

Case &H37B
     RomComment = "IN-PROGRAM": Exit Function

Case &H385
     RomComment = "GET-BIT": Exit Function

Case &H388
     RomComment = "TRAILER": Exit Function

Case &H38A
     RomComment = "COUNTER": Exit Function

Case &H39C
     RomComment = "BIT-DONE": Exit Function

Case &H3A2
     RomComment = "BREAK-4": Exit Function

Case &H3A6
     RomComment = "REPORT-D": Exit Function

Case &H3A8
     RomComment = "NAME": Exit Function

Case &H3C3
     RomComment = "NEW": Exit Function

Case &H3CB
     RomComment = "RAM-CHECK": Exit Function

Case &H3CF
     RomComment = "RAM-FILL": Exit Function

Case &H3D5
     RomComment = "RAM-READ": Exit Function

Case &H3E2
     RomComment = "SET-TOP": Exit Function

Case &H3E5
     RomComment = "INITIAL": Exit Function

Case &H408
     RomComment = "LINE": Exit Function

Case &H413
     RomComment = "N/L-Only": Exit Function

Case &H419
     RomComment = "UPPER": Exit Function

Case &H42D
     RomComment = "ADDR-TOP": Exit Function

Case &H433
     RomComment = "LIST-TOP": Exit Function

Case &H454
     RomComment = "DOWN-KEY": Exit Function

Case &H457
     RomComment = "INC-LINE": Exit Function

Case &H464
     RomComment = "KEY-INPUT": Exit Function

Case &H46F
     RomComment = "EDIT-INP": Exit Function

Case &H472
     RomComment = "LOWER": Exit Function

Case &H475
     RomComment = "EACH-CHAR": Exit Function

Case &H482
     RomComment = "END-LINE": Exit Function

Case &H487
     RomComment = "EDIT-LINE": Exit Function

Case &H48A
     RomComment = "EDIT-ROOM": Exit Function

Case &H4B1
     RomComment = "FREE-LINE": Exit Function

Case &H4C1
     RomComment = "DISPLAY-6": Exit Function

Case &H4CF
     RomComment = "SLOW-DISP": Exit Function

Case &H4DF
     RomComment = "MODE-SORT": Exit Function

Case &H4F2
     RomComment = "FUNC-BASE": Exit Function

Case &H4F7
     RomComment = "FETCH-1": Exit Function

Case &H505
     RomComment = "TABLE-ADD": Exit Function

Case &H508
     RomComment = "FETCH-2": Exit Function

Case &H515
     RomComment = "FETCH-3": Exit Function

Case &H516
     RomComment = "TEST-CURS": Exit Function

Case &H51B
     RomComment = "ENTER": Exit Function

Case &H523
     RomComment = "BACK-NEXT": Exit Function

Case &H526
     RomComment = "ADD-CHAR": Exit Function

Case &H52B
     RomComment = "K/L-KEY": Exit Function

Case &H52D
     RomComment = "KEY-SORT": Exit Function

Case &H537
     RomComment = "CURSOR": Exit Function

Case &H540
     RomComment = "K-MODE": Exit Function

Case &H544
     RomComment = "TEST-CHAR": Exit Function

Case &H556
     RomComment = "L-MODE": Exit Function

Case &H55C
     RomComment = "CLEAR-ONE": Exit Function

Case &H576
     RomComment = "LEFT-KEY": Exit Function

Case &H57F
     RomComment = "RIGHT-KEY": Exit Function

Case &H588
     RomComment = "GET-CODE": Exit Function

Case &H589
     RomComment = "ENDED-1": Exit Function

Case &H58B
     RomComment = "RUBOUT": Exit Function

Case &H593
     RomComment = "LEFT-EDGE": Exit Function

Case &H59D
     RomComment = "ENDED-2": Exit Function

Case &H59F
     RomComment = "UP-KEY": Exit Function

Case &H5AF
     RomComment = "FUNCTION": Exit Function

Case &H5B7
     RomComment = "ZERO-DE": Exit Function

Case &H5BB
     RomComment = "LINE-NO": Exit Function

Case &H5C4
     RomComment = "EDIT-KEY": Exit Function

Case &H60C
     RomComment = "N/L-KEY": Exit Function

Case &H626
     RomComment = "STK-UPPER": Exit Function

Case &H629
     RomComment = "NOW-SCAN": Exit Function

Case &H64E
     RomComment = "N/L-INP": Exit Function

Case &H661
     RomComment = "TEST-NULL": Exit Function

Case &H664
     RomComment = "N/L-NULL": Exit Function

Case &H66C
     RomComment = "NEXT-LINE": Exit Function

Case &H6AE
     RomComment = "STOP-LINE": Exit Function

Case &H6CA
     RomComment = "CONTINUE": Exit Function

Case &H6D1
     RomComment = "REPORT": Exit Function

Case &H6ED
     RomComment = "N/L-LINE": Exit Function

Case &H705
     RomComment = "COPY-OVER": Exit Function

Case &H72C
     RomComment = "LLIST": Exit Function

Case &H73C
     RomComment = "LIST": Exit Function

Case &H73E
     RomComment = "LIST-PROGRAM": Exit Function

Case &H740
     RomComment = "UNTIL-END": Exit Function

Case &H745
     RomComment = "OUT-LINE": Exit Function

Case &H755
     RomComment = "TEST-END": Exit Function

Case &H766
     RomComment = "COPY-LINE": Exit Function

Case &H76D
     RomComment = "MORE-LINE": Exit Function

Case &H77C
     RomComment = "TEST-NUM": Exit Function

Case &H79A
     RomComment = "Not-TOKEN": Exit Function

Case &H79D
     RomComment = "OUT-CURS": Exit Function

Case &H7AA
     RomComment = "FLAGS-2": Exit Function

Case &H784
     RomComment = "NUMBER": Exit Function

Case &H7BD
     RomComment = "DECODE": Exit Function

Case &H7C7
     RomComment = "KEY-LINE": Exit Function

Case &H7DC
     RomComment = "LEAD-SP": Exit Function

Case &H7E1
     RomComment = "OUT-DIGIT": Exit Function

Case &H7E2
     RomComment = "DIGIT-INC": Exit Function

Case &H7EB
     RomComment = "OUT-CODE": Exit Function

Case &H7EE
     RomComment = "OUT-CH": Exit Function

Case &H7F1
     RomComment = "PRINT-CH": Exit Function

Case &H7F5
     RomComment = "PRINT-SP": Exit Function

Case &H802
     RomComment = "LPRINT-A": Exit Function

Case &H805
     RomComment = "PRINT-EXX": Exit Function

Case &H808
     RomComment = "ENTER-CH": Exit Function

Case &H812
     RomComment = "TEST-N/L": Exit Function

Case &H82C
     RomComment = "TEST-LOW": Exit Function

Case &H835
     RomComment = "REPORT-5": Exit Function

Case &H83A
     RomComment = "EXPAND-1": Exit Function

Case &H83E
     RomComment = "WRITE-CH": Exit Function

Case &H847
     RomComment = "WRITE-N/L": Exit Function

Case &H851
     RomComment = "LPRINT-CH": Exit Function

Case &H869
     RomComment = "COPY": Exit Function

Case &H871
     RomComment = "COPY-Buffer": Exit Function

Case &H876
     RomComment = "COPY*D": Exit Function

Case &H87A
     RomComment = "COPY-LOOP": Exit Function

Case &H87D
     RomComment = "COPY-TIME": Exit Function

Case &H880
     RomComment = "COPY-BREAK": Exit Function

Case &H888
     RomComment = "REPORT-D2": Exit Function

Case &H88A
     RomComment = "COPY-CONT": Exit Function

Case &H89C
     RomComment = "COPY-NEXT": Exit Function

Case &H8B5
     RomComment = "COPY-BITS": Exit Function

Case &H8BA
     RomComment = "COPY-WAIT": Exit Function

Case &H8C7
     RomComment = "COPY-N/L": Exit Function

Case &H8DE
     RomComment = "COPY-END": Exit Function

Case &H8E2
     RomComment = "CLEAR-PRB": Exit Function

Case &H8E9
     RomComment = "PRB-BYTES": Exit Function

Case &H8F5
     RomComment = "PRINT-AT": Exit Function

Case &H8FA
     RomComment = "TEST-VAL": Exit Function

Case &H905
     RomComment = "WRONG-VAL": Exit Function

Case &H90B
     RomComment = "SET-FIELD": Exit Function

Case &H918
     RomComment = "LOC-ADDR": Exit Function

Case &H927
     RomComment = "LOOK-BACK": Exit Function

Case &H940
     RomComment = "EXPAND-2": Exit Function

Case &H94B
     RomComment = "TOKENS": Exit Function

Case &H959
     RomComment = "ALL-CHARS": Exit Function

Case &H96D
     RomComment = "TRAIL-SP": Exit Function

Case &H975
     RomComment = "TOKEN-ADD": Exit Function

Case &H97F
     RomComment = "TEST-HIGH": Exit Function

Case &H985
     RomComment = "WORDS": Exit Function

Case &H992
     RomComment = "COMP-FLAG": Exit Function

Case &H993
     RomComment = "FOUND": Exit Function

Case &H99B
     RomComment = "ONE-SPACE": Exit Function

Case &H99E
     RomComment = "MAKE-ROOM": Exit Function

Case &H9AD
     RomComment = "POINTERS": Exit Function

Case &H9B4
     RomComment = "NEXT-PTR": Exit Function

Case &H9C8
     RomComment = "PTR-DONE": Exit Function

Case &H9D8
     RomComment = "LINE-ADDR": Exit Function

Case &H9DE
     RomComment = "NEXT-TEST": Exit Function

Case &H9EA
     RomComment = "CP-LINES": Exit Function

Case &H9F2
     RomComment = "NEXT-ONE": Exit Function
     


Case &HA01
     RomComment = "NEXT-FIVE": Exit Function

Case &HA08
     RomComment = "NEXT-LETT": Exit Function

Case &HA0F
     RomComment = "LINES": Exit Function

Case &HA10
     RomComment = "BIT-5-NIL": Exit Function

Case &HA15
     RomComment = "NEXT-ADD": Exit Function

Case &HA17
     RomComment = "DIFFER": Exit Function

Case &HA1F
     RomComment = "LINE-ENDS": Exit Function

Case &HA2A
     RomComment = "CLS": Exit Function

Case &HA2C
     RomComment = "B-LINES": Exit Function

Case &HA42
     RomComment = "CLEAR-LOC": Exit Function

Case &HA52
     RomComment = "COLLAPSED": Exit Function

Case &HA5D
     RomComment = "RECLAIM-1": Exit Function

Case &HA60
     RomComment = "RECLAIM-2": Exit Function

Case &HA73
     RomComment = "E-LINE-NO": Exit Function

Case &HA91
     RomComment = "NO-NUMBER": Exit Function

Case &HA98
     RomComment = "OUT-NUM": Exit Function

Case &HAA5
     RomComment = "OUT-NO": Exit Function

Case &HAAD
     RomComment = "THOUSAND": Exit Function

Case &HABF
     RomComment = "UNITS": Exit Function

Case &HAC5
     RomComment = "UNSTACK-Z": Exit Function

Case &HACB
     RomComment = "LPRINT": Exit Function

Case &HACF
     RomComment = "PRINT": Exit Function

Case &HAD5
     RomComment = "PRINT-1": Exit Function

Case &HAFA
     RomComment = "NOT-AT": Exit Function

Case &HB1E
     RomComment = "TAB-TEST": Exit Function

Case &HB31
     RomComment = "NOT-TAB": Exit Function

Case &HB37
     RomComment = "PRINT-ON": Exit Function

Case &HB44
     RomComment = "SPACEING": Exit Function

Case &HB4E
     RomComment = "SYNTAX-ON": Exit Function

Case &HB55
     RomComment = "PRINT-STK": Exit Function

Case &HB64
     RomComment = "PR-STR-1": Exit Function

Case &HB66
     RomComment = "PR-STR-2": Exit Function

Case &HB67
     RomComment = "PR-STR-3": Exit Function

Case &HB6B
     RomComment = "PR-STR-4": Exit Function

Case &HB84
     RomComment = "PRINT-END": Exit Function

Case &HB8B
     RomComment = "FIELD": Exit Function

Case &HBA4
     RomComment = "CENTER": Exit Function

Case &HBAB
     RomComment = "RIGHT": Exit Function

Case &HBAF
     RomComment = "PLOT/UNP": Exit Function

Case &HBC5
     RomComment = "COLUMNS": Exit Function

Case &HBCA
     RomComment = "FIND-ADDR": Exit Function

Case &HBD9
     RomComment = "SQ-SAVE": Exit Function

Case &HBDA
     RomComment = "TABLE-PTR": Exit Function

Case &HBE9
     RomComment = "PLOT": Exit Function

Case &HBEB
     RomComment = "UNPLOT": Exit Function

Case &HBF1
     RomComment = "PLOT-END": Exit Function

Case &HBF5
     RomComment = "STK-TO-BC": Exit Function

Case &HC02
     RomComment = "STK-TO-A": Exit Function

Case &HC0E
     RomComment = "SCROLL": Exit Function

Case &HC29, &HCB4
     RomComment = "LPRINT(P)": Exit Function

Case &HC2A, &HCB7
     RomComment = "LLIST(P)": Exit Function

Case &HC2B, &HC58
     RomComment = "STOP(P)": Exit Function

Case &HC2C, &HCAB
     RomComment = "SLOW(P)": Exit Function

Case &HC2D, &HCAE
     RomComment = "FAST(P)": Exit Function
Case &HC2E, &HC77
     RomComment = "NEW(P)": Exit Function
Case &HC2F, &HCA4
     RomComment = "SCROLL(P)": Exit Function
Case &HC30, &HC8F
     RomComment = "CONT(P)": Exit Function
Case &HC31, &HC71
     RomComment = "DIM(P)": Exit Function
Case &HC32, &HC74
     RomComment = "REM(P)": Exit Function
Case &HC33, &HC5E
     RomComment = "FOR(P)": Exit Function
Case &HC34, &HC4B
     RomComment = "GOTO(P)": Exit Function
Case &HC35, &HC54
     RomComment = "GOSUB(P)": Exit Function
Case &HC36, &HC6D
     RomComment = "INPUT(P)": Exit Function
Case &HC37, &HC89
     RomComment = "LOAD(P)": Exit Function
Case &HC38, &HC7D
     RomComment = "LIST(P)": Exit Function
Case &HC39, &HC48
     RomComment = "LET(P)": Exit Function
Case &HC3A, &HCA7
     RomComment = "PAUSE(P)": Exit Function
Case &HC3B, &HC66
     RomComment = "NEXT(P)": Exit Function
Case &HC3C, &HC80
     RomComment = "POKE(P)": Exit Function
Case &HC3D, &HC6A
     RomComment = "PRINT(P)": Exit Function
Case &HC3E, &HC98
     RomComment = "PLOT(P)": Exit Function
Case &HC3F, &HC7A
     RomComment = "RUN(P)": Exit Function
Case &HC40, &HC8C
     RomComment = "SAVE(P)": Exit Function
Case &HC41, &HC86
     RomComment = "RAND(P)": Exit Function
Case &HC42, &HC4F
     RomComment = "IF(P)": Exit Function
Case &HC43, &HC95
     RomComment = "CLS(P)": Exit Function
Case &HC44, &HC9E
     RomComment = "UNPLOT(P)": Exit Function
Case &HC45, &HC92
     RomComment = "CLEAR(P)": Exit Function
Case &HC46, &HC5B
     RomComment = "RETURN(P)": Exit Function
Case &HC47, &HCB1
     RomComment = "COPY(P)": Exit Function
Case &HCBA
     RomComment = "LINE-SCAN": Exit Function
Case &HCC1
     RomComment = "LINE-RUN": Exit Function
Case &HCDC
     RomComment = "STOP": Exit Function
Case &HCDE
     RomComment = "LINE-NULL": Exit Function
Case &HCF4
     RomComment = "SCAN-LOOP": Exit Function
Case &HCF7
     RomComment = "GET-PARAM": Exit Function
Case &HD10
     RomComment = "SEPARATOR": Exit Function
Case &HD16, &HD2D
     RomComment = "CLASSE-0": Exit Function
Case &HD17, &HD3C
     RomComment = "CLASSE-1": Exit Function
Case &HD18, &HD6B
     RomComment = "CLASSE-2": Exit Function
Case &HD19, &HD28
     RomComment = "CLASSE-3": Exit Function
Case &HD1A, &HD85
     RomComment = "CLASSE-4": Exit Function
Case &HD1B, &HD2E
     RomComment = "CLASSE-5": Exit Function
Case &HD1C, &HD92
     RomComment = "CLASSE-6": Exit Function
Case &HD1D
     RomComment = "CHECK-END": Exit Function
Case &HD22
     RomComment = "CHECK-2": Exit Function
Case &HD26
     RomComment = "REPORT-C2": Exit Function
Case &HD3F
     RomComment = "CLASS-4-2": Exit Function
Case &HD3B
     RomComment = "REPORT-2": Exit Function
Case &HD4D
     RomComment = "SET-STK": Exit Function
Case &HD63
     RomComment = "SET-STK": Exit Function
Case &HD6A
     RomComment = "REM": Exit Function
Case &HD6F
     RomComment = "INPUT-REP": Exit Function
Case &HD9C
     RomComment = "NO-TO-STK": Exit Function
Case &HDA6
     RomComment = "SYNTAX-Z": Exit Function
Case &HDAB
     RomComment = "IF": Exit Function
Case &HDB6
     RomComment = "IF-END": Exit Function
Case &HDB9
     RomComment = "FOR": Exit Function
Case &HDC6
     RomComment = "USE-ONE": Exit Function
Case &HDCC
     RomComment = "REORDER": Exit Function
Case &HDEA
     RomComment = "LMT+STEP": Exit Function
Case &HE0E
     RomComment = "NEXTLINE-NO": Exit Function
Case &HE5A
     RomComment = "NEXT-LOOP": Exit Function
Case &HE62
     RomComment = "LMT-V-VAL": Exit Function
Case &HE69
     RomComment = "IMPOSS.": Exit Function
Case &HE6C
     RomComment = "RAND": Exit Function
Case &HE77
     RomComment = "SET-SEED": Exit Function
Case &HE7C
     RomComment = "CONT": Exit Function
Case &HE81
     RomComment = "GOTO": Exit Function
Case &HE86
     RomComment = "GOTO-2": Exit Function
Case &HE92
     RomComment = "POKE": Exit Function
Case &HE9B
     RomComment = "POKE-SAVE": Exit Function
Case &HEA7
     RomComment = "FIND-INT": Exit Function
Case &HEAD
     RomComment = "REPORT-B": Exit Function
Case &HEAF
     RomComment = "RUN": Exit Function
Case &HEB5
     RomComment = "GOSUB": Exit Function
Case &HEC5
     RomComment = "TEST-ROOM": Exit Function
Case &HED3
     RomComment = "REPORT-4": Exit Function
Case &HED8
     RomComment = "RETURN": Exit Function
Case &HEE5
     RomComment = "REPORT-7": Exit Function
Case &HEE9
     RomComment = "INPUT": Exit Function
Case &HF05
     RomComment = "PROMPT": Exit Function
Case &HF14
     RomComment = "ENTER-CUR": Exit Function
Case &HF21
     RomComment = "REPORT-8": Exit Function
Case &HF23
     RomComment = "FAST": Exit Function
Case &HF2B
     RomComment = "SLOW": Exit Function
Case &HF32
     RomComment = "PAUSE": Exit Function
Case &HF46
     RomComment = "BREAK-1": Exit Function
Case &HF4B
     RomComment = "DEBOUNCE": Exit Function
Case &HF55
     RomComment = "SCANNING": Exit Function
Case &H111C
     RomComment = "LOOK-VARS": Exit Function
Case &H11A7
     RomComment = "STK-VAR": Exit Function
Case &H1321
     RomComment = "LET": Exit Function
Case &H13F8
     RomComment = "STK-FETCH": Exit Function
Case &H1488
     RomComment = "RESERVE": Exit Function
Case &H149A
     RomComment = "CLEAR": Exit Function
Case &H14A3
     RomComment = "X-TEMP": Exit Function
Case &H14A6
     RomComment = "SET-STK-B": Exit Function
Case &H14AD
     RomComment = "CURSOR-IN": Exit Function
Case &H14BC
     RomComment = "SET-MEM": Exit Function
Case &H1548
     RomComment = "INT-TO-FP": Exit Function
Case &H158A
     RomComment = "FP-TO-BC": Exit Function
Case &H15CD
     RomComment = "FP-TO-A": Exit Function
Case &H15DB
     RomComment = "PRINT-FB": Exit Function
Case &H199D
     RomComment = "CALCULATE": Exit Function
Case &H1E00 To &H1FFF
     RomComment = "[CHR ROM]": Exit Function
Case &H4000
     RomComment = "ERR-NR": Exit Function
Case &H4001
     RomComment = "FLAGS": Exit Function
Case &H4002, &H4003
     RomComment = "ERR-SP": Exit Function
Case &H4004, &H4005
     RomComment = "RAM-TOP": Exit Function
Case &H4006
     RomComment = "MODE": Exit Function
Case &H4007, &H4008
     RomComment = "PPC": Exit Function
Case &H4009
     RomComment = "VERSION": Exit Function
Case &H400A, &H400B
     RomComment = "E-PPC": Exit Function
Case &H400C, &H400D
     RomComment = "D-FILE": Exit Function
Case &H400E, &H400F
     RomComment = "DF-CC": Exit Function
Case &H4010, &H4011
     RomComment = "VARS": Exit Function
Case &H4012, &H4013
     RomComment = "DEST": Exit Function
Case &H4014, &H4015
     RomComment = "E-LINE": Exit Function
Case &H4016, &H4017
     RomComment = "CH-ADD": Exit Function
Case &H4018, &H4019
     RomComment = "X-PTR": Exit Function
Case &H401A, &H401B
     RomComment = "STKBOT": Exit Function
Case &H401C, &H401D
     RomComment = "STKEND": Exit Function
Case &H401E
     RomComment = "BERG": Exit Function
Case &H401F, &H4020
     RomComment = "MEM": Exit Function
     
Case &H4021
     RomComment = "UNUSED-8": Exit Function
Case &H4022
     RomComment = "DF-SZ": Exit Function
Case &H4023, &H4024
     RomComment = "S-TOP": Exit Function
Case &H4025, &H4026
     RomComment = "LAST-K": Exit Function
Case &H4027
     RomComment = "DEBOUNCE": Exit Function
Case &H4028
     RomComment = "MARGIN": Exit Function
Case &H4029, &H402A
     RomComment = "NXT-LINE": Exit Function
Case &H402B, &H402C
     RomComment = "OLDPPC": Exit Function
Case &H402D
     RomComment = "FLAGX": Exit Function
Case &H402E, &H402F
     RomComment = "STRLEN": Exit Function
Case &H4030, &H4031
     RomComment = "T-ADDR": Exit Function
Case &H4032, &H4033
     RomComment = "SEED": Exit Function
Case &H4034, &H4035
     RomComment = "FRAMES": Exit Function
Case &H4036, &H4037
     RomComment = "COORDS": Exit Function
Case &H4038
     RomComment = "PR-CC": Exit Function
Case &H4039, &H403A
     RomComment = "S-POSN": Exit Function
Case &H403B
     RomComment = "CDFLAG": Exit Function
Case &H403C To &H405C
     RomComment = "PRBUFF": Exit Function
Case &H405D To &H407A
     RomComment = "MEMBOT": Exit Function
Case &H407B, &H407C
     RomComment = "UNUSED-16": Exit Function
Case &H407D
     RomComment = "BASIC-PRG": Exit Function
Case &H7FFE
     RomComment = "QuickSilva(Reg)": Exit Function
Case &H7FFF
     RomComment = "QuickSilva(Dta)": Exit Function
End Select

End Function
Private Function GetIOinTagCom(IoIn As String) As String
GetIOinTagCom = "User port."
Select Case IoIn
Case "3F"
' 8 E/S Card (3Fh Port)
Case "41"
' 41h : Datas LARKEN DISK DRIVE CONTROLER.
GetIOinTagCom = "Larken Disk: DATA."
Case "43"
' 43h - 67 : Larken Disk Drive ( Head Stat ).
GetIOinTagCom = "Larken Disk: STAT."
Case "45"
' 45h - Larken Disk Drive ( 45h... Port in Adrress : 12300 / 300Ch ).
GetIOinTagCom = "Larken Disk."
Case "5F"
' 5Fh - Memotech HRG card.
GetIOinTagCom = "Memotech HRG mode."
Case "7D"
' 7Dh - MAGECO LIGHT-PEN card.
GetIOinTagCom = "MAGECO LIGHT-PEN [H]."
Case "7F"
' 7Dh - MAGECO LIGHT-PEN card.
GetIOinTagCom = "MAGECO LIGHT-PEN [V]."
Case "FB"
' Printer read Info. (FBh Port)
GetIOinTagCom = "ZxPrinter Port."
Case "BF"
' &HBF = CZ1500 - CBM1541 disk interface
GetIOinTagCom = "CBM1541 disk."
Case "DF"
' DFh  - AGB JOYSTICK II ( Read Datas ).
GetIOinTagCom = "AGB Joystick: Port 1."
Case "EF"
' EFh  - AGB JOYSTICK II ( Read Datas ).
GetIOinTagCom = "AGB Joystick: Port 2."
Case "FE"
' keyboard Input port A0 =0 and PORT=FEh
GetIOinTagCom = "Keyboard Port."
End Select
End Function


Private Function GetIOoutTagCom(IoOUT As String) As String

GetIOoutTagCom = "User port."

Select Case IoOUT
'// PORT 0
'/////////////////////////////////////////////////////////////////////////////
Case "00"
 GetIOoutTagCom = "PORT 0/AGB(Registers)"

'// PORT 1
'/////////////////////////////////////////////////////////////////////////////
Case "01"
 GetIOoutTagCom = "PORT 1"
   
'// PORT 2: AGB SOUND CARD.
'/////////////////////////////////////////////////////////////////////////////
Case "01"
 GetIOoutTagCom = "AGB SOUND CARD.(DATA)"

  
' // VTR SOUND CARD.
' // Port DFh : Command Register (// DFh - Jupiter Ace Sound Card & Zon-X sound Card.)
' // Port 0Fh : Datas. ('// 0Fh - Zon-X sound Card.)
Case "DF"
 GetIOoutTagCom = "VTR /Zon-X SOUND CARD.(Registers)"

Case "0F"
 GetIOoutTagCom = "VTR /Zon-X SOUND CARD.(DATA)"
 
' // LARKEN DISK DRIVE CONTROLER.
' // Port 41h : Datas
' // Port 43h : NC
' // Port 45h : Commands
' // Port 57h : Card control (Drive0/Drive1)

'// 41h - Larken Disk Drive
Case "41"
 GetIOoutTagCom = "Larken DSK DATA [41h]"
     
'// 45h - Larken Disk Drive
Case "45"
 GetIOoutTagCom = "Larken DSK Commands [45h]"

'// 57h - Larken Disk Drive (87)
Case "57"
 GetIOoutTagCom = "Larken DSK Control [57h]"

'// 69h - Larken Disk Drive
Case "69"
 GetIOoutTagCom = "Larken DSK Output [69h]"

'// PORT 3Fh - Fuller Box Sound Card
'/////////////////////////////////////////////////////////////////////////////
'// 3Fh - 8 E/S Card
Case "3F"
 GetIOoutTagCom = "8 E-S CARD/Fuller/SPO256 Sound card (Registers)"
    
'// PORT 5Fh- Fuller Box Sound Card
'/////////////////////////////////////////////////////////////////////////////
Case "5F"
 GetIOoutTagCom = "Fuller Sound card.(DATA)"
    
'// PORT 73h - D8251 for TS2050 Sound Card
'/////////////////////////////////////////////////////////////////////////////
Case "73"
 GetIOoutTagCom = ""
    
'// PORT 77h - D8251 for TS2050 Sound Card (write countrol)
'/////////////////////////////////////////////////////////////////////////////
Case "77"
 GetIOoutTagCom = ""
    
'// PORT C7h - D8255 Sound Card (Port A)
'/////////////////////////////////////////////////////////////////////////////
Case "C7"
 GetIOoutTagCom = "D8255 Sound Card (Port A)"
    
 '// PORT CFh - D8255 Sound Card (Port B)
'/////////////////////////////////////////////////////////////////////////////
Case "CF"
 GetIOoutTagCom = "D8255 Sound Card (Port B)"
    
 '// PORT D7h - D8255 Sound Card (Port C)
'/////////////////////////////////////////////////////////////////////////////
Case "D7"
 GetIOoutTagCom = "D8255 Sound Card (Port C)"
    
'// PORT DDh - Ace Jupiter sound card.
'/////////////////////////////////////////////////////////////////////////////
Case "DD"
 GetIOoutTagCom = "Ace Jupiter sound card"
 
'// PORT FBh - ZX Printer Port.
'/////////////////////////////////////////////////////////////////////////////
Case "FB"
   GetIOoutTagCom = "ZxPrinter port"
   
'// PORT BFh
'/////////////////////////////////////////////////////////////////////////////
Case "BF"
   GetIOoutTagCom = "CBM1541 disk interface"
   
'Port FDh Write (ZX81 only) NMI generator.
Case "FD"
 GetIOoutTagCom = "ZX81 NMI GENERATOR"

'// PORT FEh - NMI generator output.
'/////////////////////////////////////////////////////////////////////////////
Case "FE"
 GetIOoutTagCom = "ZX81 NMI GENERATOR"

'// PORT FFh - TV synchr./ Tape ouput. ( ULA - PIN16)
'/////////////////////////////////////////////////////////////////////////////
Case "FF"
   GetIOoutTagCom = "Zx81 Display/Tape port"
   
End Select

End Function

Function Get_RST28(RSTOppCode As Byte) As String
Select Case RSTOppCode
Case 0
Get_RST28 = "Null"
Case 1
Get_RST28 = "Exchange"
Case 2
Get_RST28 = "Delete"
Case 3
Get_RST28 = "Subtract"
Case 4
Get_RST28 = "Multiply"
Case 5
Get_RST28 = "Division"
Case 6
Get_RST28 = "Exp."
Case 7
Get_RST28 = "Or"
Case 8
Get_RST28 = "And"
Case &HF
Get_RST28 = "Addition"
Case &H18
Get_RST28 = "Negate"
Case &H19
Get_RST28 = "Code"
Case &H1A
Get_RST28 = "Val"
Case &H1B
Get_RST28 = "Len"
Case &H1C
Get_RST28 = "Sin"
Case &H1D
Get_RST28 = "Cos"
Case &H1E
Get_RST28 = "Tan"
Case &H1F
Get_RST28 = "Asn"
Case &H20
Get_RST28 = "Acs"
Case &H21
Get_RST28 = "Atn"
Case &H22
Get_RST28 = "Ln"
Case &H23
Get_RST28 = "Exp"
Case &H24
Get_RST28 = "Int"
Case &H25
Get_RST28 = "Sqr"
Case &H26
Get_RST28 = "Sgn"
Case &H27
Get_RST28 = "Abs"
Case &H28
Get_RST28 = "Peek"
Case &H29
Get_RST28 = "Usr"
Case &H2A
Get_RST28 = "Str$"
Case &H2B
Get_RST28 = "Chr$"
Case &H2C
Get_RST28 = "Not"
Case &H34
Get_RST28 = "End"
Case &HC0
Get_RST28 = "Store M#0"
Case &HC1
Get_RST28 = "Store M#1"
Case &HC2
Get_RST28 = "Store M#2"
Case &HC3
Get_RST28 = "Store M#3"
Case &HC4
Get_RST28 = "Store M#4"
Case &HE0
Get_RST28 = "Get M#0"
Case &HE1
Get_RST28 = "Get M#1"
Case &HE2
Get_RST28 = "Get M#2"
Case &HE3
Get_RST28 = "Get M#3"
Case &HE4
Get_RST28 = "Get M#4"
Case Else
Get_RST28 = "Unknown"
End Select
Get_RST28 = Get_RST28 + " CMD."
End Function

Function GetXi_Yi(opcode As Byte, Ireg As String) As String
Static strText As String

                   Select Case opcode
                        
                        Case &H0
                   strText = "LD B,RLC (" & Ireg & "+dd)"
                        Case &H1
                   strText = "LD C,RLC (" & Ireg & "+dd)"
                        Case &H2
                   strText = "LD D,RLC (" & Ireg & "+dd)"
                        Case &H3
                   strText = "LD E,RLC (" & Ireg & "+dd)"
                        Case &H4
                   strText = "LD H,RLC (" & Ireg & "+dd)"
                        Case &H5
                   strText = "LD L,RLC (" & Ireg & "+dd)"
                        Case &H6
                   strText = "RLC (" & Ireg & "+dd)"
                        Case &H7
                   strText = "LD A,RLC (" & Ireg & "+dd)"
                        Case &H8
                   strText = "LD B,RRC (" & Ireg & "+dd)"
                        Case &H9
                   strText = "LD C,RRC (" & Ireg & "+dd)"
                        Case &HA
                   strText = "LD D,RRC (" & Ireg & "+dd)"
                        Case &HB
                   strText = "LD E,RRC (" & Ireg & "+dd)"
                        Case &HC
                   strText = "LD H,RRC (" & Ireg & "+dd)"
                        Case &HD
                   strText = "LD L,RRC (" & Ireg & "+dd)"
                        Case &HE
                   strText = "RRC (" & Ireg & "+dd)"
                        Case &HF
                   strText = "LD A,RRC (" & Ireg & "+dd)"
                        Case &H10
                   strText = "LD B,RL (" & Ireg & "+dd)"
                        Case &H11
                   strText = "LD C,RL (" & Ireg & "+dd)"
                        Case &H12
                   strText = "LD D,RL (" & Ireg & "+dd)"
                        Case &H13
                   strText = "LD E,RL (" & Ireg & "+dd)"
                        Case &H14
                   strText = "LD H,RL (" & Ireg & "+dd)"
                        Case &H15
                   strText = "LD L,RL (" & Ireg & "+dd)"
                        Case &H16
                   strText = "RL (" & Ireg & "+dd)"
                        Case &H17
                   strText = "LD A,RL (" & Ireg & "+dd)"
                        Case &H18
                   strText = "LD B,RR (" & Ireg & "+dd)"
                        Case &H19
                   strText = "LD C,RR (" & Ireg & "+dd)"
                        Case &H1A
                   strText = "LD D,RR (" & Ireg & "+dd)"
                        Case &H1B
                   strText = "LD E,RR (" & Ireg & "+dd)"
                        Case &H1C
                   strText = "LD H,RR (" & Ireg & "+dd)"
                        Case &H1D
                   strText = "LD L,RR (" & Ireg & "+dd)"
                        Case &H1E
                   strText = "RR (" & Ireg & "+dd)"
                        Case &H1F
                   strText = "LD A,RR (" & Ireg & "+dd)"
                        Case &H20
                   strText = "LD B,SLA (" & Ireg & "+dd)"
                        Case &H21
                   strText = "LD C,SLA (" & Ireg & "+dd)"
                        Case &H22
                   strText = "LD D,SLA (" & Ireg & "+dd)"
                        Case &H23
                   strText = "LD E,SLA (" & Ireg & "+dd)"
                        Case &H24
                   strText = "LD H,SLA (" & Ireg & "+dd)"
                        Case &H25
                   strText = "LD L,SLA (" & Ireg & "+dd)"
                        Case &H26
                   strText = "SLA (" & Ireg & "+dd)"
                        Case &H27
                   strText = "LD A,SLA (" & Ireg & "+dd)"
                        Case &H28
                   strText = "LD B,SRA (" & Ireg & "+dd)"
                        Case &H29
                   strText = "LD C,SRA (" & Ireg & "+dd)"
                        Case &H2A
                   strText = "LD D,SRA (" & Ireg & "+dd)"
                        Case &H2B
                   strText = "LD E,SRA (" & Ireg & "+dd)"
                        Case &H2C
                   strText = "LD H,SRA (" & Ireg & "+dd)"
                        Case &H2D
                   strText = "LD L,SRA (" & Ireg & "+dd)"
                        Case &H2E
                   strText = "SRA (" & Ireg & "+dd)"
                        Case &H2F
                   strText = "LD A,SRA (" & Ireg & "+dd)"
                        Case &H30
                   strText = "LD B,SLL (" & Ireg & "+dd)"
                        Case &H31
                   strText = "LD C,SLL (" & Ireg & "+dd)"
                        Case &H32
                   strText = "LD D,SLL (" & Ireg & "+dd)"
                        Case &H33
                   strText = "LD E,SLL (" & Ireg & "+dd)"
                        Case &H34
                   strText = "LD H,SLL (" & Ireg & "+dd)"
                        Case &H35
                   strText = "LD L,SLL (" & Ireg & "+dd)"
                        Case &H36
                   strText = "SLL (" & Ireg & "+dd)"
                        Case &H37
                   strText = "LD A,SLL (" & Ireg & "+dd)"
                        Case &H38
                   strText = "LD B,SRL (" & Ireg & "+dd)"
                        Case &H39
                   strText = "LD C,SRL (" & Ireg & "+dd)"
                        Case &H3A
                   strText = "LD D,SRL (" & Ireg & "+dd)"
                        Case &H3B
                   strText = "LD E,SRL (" & Ireg & "+dd)"
                        Case &H3C
                   strText = "LD H,SRL (" & Ireg & "+dd)"
                        Case &H3D
                   strText = "LD L,SRL (" & Ireg & "+dd)"
                        Case &H3E
                   strText = "SRL (" & Ireg & "+dd)"
                        Case &H3F
                   strText = "LD A,SRL (" & Ireg & "+dd)"
                        Case &H40, &H41, &H42, &H43, &H44, &H45, &H46, &H47
                   strText = "BIT 0,(" & Ireg & "+dd)"
                        Case &H48, &H49, &H4A, &H4B, &H4C, &H4D, &H4E, &H4F
                   strText = "BIT 1,(" & Ireg & "+dd)"
                        Case &H50, &H51, &H52, &H53, &H54, &H55, &H56, &H57
                   strText = "BIT 2,(" & Ireg & "+dd)"
                        Case &H58, &H59, &H5A, &H5B, &H5C, &H5D, &H5E, &H5F
                   strText = "BIT 3,(" & Ireg & "+dd)"
                        Case &H60, &H61, &H62, &H63, &H64, &H65, &H66, &H67
                   strText = "BIT 4,(" & Ireg & "+dd)"
                        Case &H68, &H69, &H6A, &H6B, &H6C, &H6D, &H6E, &H6F
                   strText = "BIT 5,(" & Ireg & "+dd)"
                        Case &H70, &H71, &H72, &H73, &H74, &H75, &H76, &H77
                   strText = "BIT 6,(" & Ireg & "+dd)"
                        Case &H78, &H79, &H7A, &H7B, &H7C, &H7D, &H7E, &H7F
                   strText = "BIT 7,(" & Ireg & "+dd)"
                        Case &H80
                   strText = "LD B,RES 0,(" & Ireg & "+dd)"
                        Case &H81
                   strText = "LD C,RES 0,(" & Ireg & "+dd)"
                        Case &H82
                   strText = "LD D,RES 0,(" & Ireg & "+dd)"
                        Case &H83
                   strText = "LD E,RES 0,(" & Ireg & "+dd)"
                        Case &H84
                   strText = "LD H,RES 0,(" & Ireg & "+dd)"
                        Case &H85
                   strText = "LD L,RES 0,(" & Ireg & "+dd)"
                        Case &H86
                   strText = "RES 0,(" & Ireg & "+dd)"
                        Case &H87
                   strText = "LD A,RES 0,(" & Ireg & "+dd)"
                        Case &H88
                   strText = "LD B,RES 1,(" & Ireg & "+dd)"
                        Case &H89
                   strText = "LD C,RES 1,(" & Ireg & "+dd)"
                        Case &H8A
                   strText = "LD D,RES 1,(" & Ireg & "+dd)"
                        Case &H8B
                   strText = "LD E,RES 1,(" & Ireg & "+dd)"
                        Case &H8C
                   strText = "LD H,RES 1,(" & Ireg & "+dd)"
                        Case &H8D
                   strText = "LD L,RES 1,(" & Ireg & "+dd)"
                        Case &H8E
                   strText = "RES 1,(" & Ireg & "+dd)"
                        Case &H8F
                   strText = "LD A,RES 1,(" & Ireg & "+dd)"
                        Case &H90
                   strText = "LD B,RES 2,(" & Ireg & "+dd)"
                        Case &H91
                   strText = "LD C,RES 2,(" & Ireg & "+dd)"
                        Case &H92
                   strText = "LD D,RES 2,(" & Ireg & "+dd)"
                        Case &H93
                   strText = "LD E,RES 2,(" & Ireg & "+dd)"
                        Case &H94
                   strText = "LD H,RES 2,(" & Ireg & "+dd)"
                        Case &H95
                   strText = "LD L,RES 2,(" & Ireg & "+dd)"
                        Case &H96
                   strText = "RES 2,(" & Ireg & "+dd)"
                        Case &H97
                   strText = "LD A,RES 2,(" & Ireg & "+dd)"
                        Case &H98
                   strText = "LD B,RES 3,(" & Ireg & "+dd)"
                        Case &H99
                   strText = "LD C,RES 3,(" & Ireg & "+dd)"
                        Case &H9A
                   strText = "LD D,RES 3,(" & Ireg & "+dd)"
                        Case &H9B
                   strText = "LD E,RES 3,(" & Ireg & "+dd)"
                        Case &H9C
                   strText = "LD H,RES 3,(" & Ireg & "+dd)"
                        Case &H9D
                   strText = "LD L,RES 3,(" & Ireg & "+dd)"
                        Case &H9E
                   strText = "RES 3,(" & Ireg & "+dd)"
                        Case &H9F
                   strText = "LD A,RES 3,(" & Ireg & "+dd)"
                        Case &HA0
                   strText = "LD B,RES 4,(" & Ireg & "+dd)"
                        Case &HA1
                   strText = "LD C,RES 4,(" & Ireg & "+dd)"
                        Case &HA2
                   strText = "LD D,RES 4,(" & Ireg & "+dd)"
                        Case &HA3
                   strText = "LD E,RES 4,(" & Ireg & "+dd)"
                        Case &HA4
                   strText = "LD H,RES 4,(" & Ireg & "+dd)"
                        Case &HA5
                   strText = "LD L,RES 4,(" & Ireg & "+dd)"
                        Case &HA6
                   strText = "RES 4,(" & Ireg & "+dd)"
                        Case &HA7
                   strText = "LD A,RES 4,(" & Ireg & "+dd)"
                        Case &HA8
                   strText = "LD B,RES 5,(" & Ireg & "+dd)"
                        Case &HA9
                   strText = "LD C,RES 5,(" & Ireg & "+dd)"
                        Case &HAA
                   strText = "LD D,RES 5,(" & Ireg & "+dd)"
                        Case &HAB
                   strText = "LD E,RES 5,(" & Ireg & "+dd)"
                        Case &HAC
                   strText = "LD H,RES 5,(" & Ireg & "+dd)"
                        Case &HAD
                   strText = "LD L,RES 5,(" & Ireg & "+dd)"
                        Case &HAE
                   strText = "RES 5,(" & Ireg & "+dd)"
                        Case &HAF
                   strText = "LD A,RES 5,(" & Ireg & "+dd)"
                        Case &HB0
                   strText = "LD B,RES 6,(" & Ireg & "+dd)"
                        Case &HB1
                   strText = "LD C,RES 6,(" & Ireg & "+dd)"
                        Case &HB2
                   strText = "LD D,RES 6,(" & Ireg & "+dd)"
                        Case &HB3
                   strText = "LD E,RES 6,(" & Ireg & "+dd)"
                        Case &HB4
                   strText = "LD H,RES 6,(" & Ireg & "+dd)"
                        Case &HB5
                   strText = "LD L,RES 6,(" & Ireg & "+dd)"
                        Case &HB6
                   strText = "RES 6,(" & Ireg & "+dd)"
                        Case &HB7
                   strText = "LD A,RES 6,(" & Ireg & "+dd)"
                        Case &HB8
                   strText = "LD B,RES 7,(" & Ireg & "+dd)"
                        Case &HB9
                   strText = "LD C,RES 7,(" & Ireg & "+dd)"
                        Case &HBA
                   strText = "LD D,RES 7,(" & Ireg & "+dd)"
                        Case &HBB
                   strText = "LD E,RES 7,(" & Ireg & "+dd)"
                        Case &HBC
                   strText = "LD H,RES 7,(" & Ireg & "+dd)"
                        Case &HBD
                   strText = "LD L,RES 7,(" & Ireg & "+dd)"
                        Case &HBE
                   strText = "RES 7,(" & Ireg & "+dd)"
                        Case &HBF
                   strText = "LD A,RES 7,(" & Ireg & "+dd)"
                        Case &HC0
                   strText = "LD B,SET 0,(" & Ireg & "+dd)"
                        Case &HC1
                   strText = "LD C,SET 0,(" & Ireg & "+dd)"
                        Case &HC2
                   strText = "LD D,SET 0,(" & Ireg & "+dd)"
                        Case &HC3
                   strText = "LD E,SET 0,(" & Ireg & "+dd)"
                        Case &HC4
                   strText = "LD H,SET 0,(" & Ireg & "+dd)"
                        Case &HC5
                   strText = "LD L,SET 0,(" & Ireg & "+dd)"
                        Case &HC6
                   strText = "SET 0,(" & Ireg & "+dd)"
                        Case &HC7
                   strText = "LD A,SET 0,(" & Ireg & "+dd)"
                        Case &HC8
                   strText = "LD B,SET 1,(" & Ireg & "+dd)"
                        Case &HC9
                   strText = "LD C,SET 1,(" & Ireg & "+dd)"
                        Case &HCA
                   strText = "LD D,SET 1,(" & Ireg & "+dd)"
                        Case &HCB
                   strText = "LD E,SET 1,(" & Ireg & "+dd)"
                        Case &HCC
                   strText = "LD H,SET 1,(" & Ireg & "+dd)"
                        Case &HCD
                   strText = "LD L,SET 1,(" & Ireg & "+dd)"
                        Case &HCE
                   strText = "SET 1,(" & Ireg & "+dd)"
                        Case &HCF
                   strText = "LD A,SET 1,(" & Ireg & "+dd)"
                        Case &HD0
                   strText = "LD B,SET 2,(" & Ireg & "+dd)"
                        Case &HD1
                   strText = "LD C,SET 2,(" & Ireg & "+dd)"
                        Case &HD2
                   strText = "LD D,SET 2,(" & Ireg & "+dd)"
                        Case &HD3
                   strText = "LD E,SET 2,(" & Ireg & "+dd)"
                        Case &HD4
                   strText = "LD H,SET 2,(" & Ireg & "+dd)"
                        Case &HD5
                   strText = "LD L,SET 2,(" & Ireg & "+dd)"
                        Case &HD6
                   strText = "SET 2,(" & Ireg & "+dd)"
                        Case &HD7
                   strText = "LD A,SET 2,(" & Ireg & "+dd)"
                        Case &HD8
                   strText = "LD B,SET 3,(" & Ireg & "+dd)"
                        Case &HD9
                   strText = "LD C,SET 3,(" & Ireg & "+dd)"
                        Case &HDA
                   strText = "LD D,SET 3,(" & Ireg & "+dd)"
                        Case &HDB
                   strText = "LD E,SET 3,(" & Ireg & "+dd)"
                        Case &HDC
                   strText = "LD H,SET 3,(" & Ireg & "+dd)"
                        Case &HDD
                   strText = "LD L,SET 3,(" & Ireg & "+dd)"
                        Case &HDE
                   strText = "SET 3,(" & Ireg & "+dd)"
                        Case &HDF
                   strText = "LD A,SET 3,(" & Ireg & "+dd)"
                        Case &HE0
                   strText = "LD B,SET 4,(" & Ireg & "+dd)"
                        Case &HE1
                   strText = "LD C,SET 4,(" & Ireg & "+dd)"
                        Case &HE2
                   strText = "LD D,SET 4,(" & Ireg & "+dd)"
                        Case &HE3
                   strText = "LD E,SET 4,(" & Ireg & "+dd)"
                        Case &HE4
                   strText = "LD H,SET 4,(" & Ireg & "+dd)"
                        Case &HE5
                   strText = "LD L,SET 4,(" & Ireg & "+dd)"
                        Case &HE6
                   strText = "SET 4,(" & Ireg & "+dd)"
                        Case &HE7
                   strText = "LD A,SET 4,(" & Ireg & "+dd)"
                        Case &HE8
                   strText = "LD B,SET 5,(" & Ireg & "+dd)"
                        Case &HE9
                   strText = "LD C,SET 5,(" & Ireg & "+dd)"
                        Case &HEA
                   strText = "LD D,SET 5,(" & Ireg & "+dd)"
                        Case &HEB
                   strText = "LD E,SET 5,(" & Ireg & "+dd)"
                        Case &HEC
                   strText = "LD H,SET 5,(" & Ireg & "+dd)"
                        Case &HED
                   strText = "LD L,SET 5,(" & Ireg & "+dd)"
                        Case &HEE
                   strText = "SET 5,(" & Ireg & "+dd)"
                        Case &HEF
                   strText = "LD A,SET 5,(" & Ireg & "+dd)"
                        Case &HF0
                   strText = "LD B,SET 6,(" & Ireg & "+dd)"
                        Case &HF1
                   strText = "LD C,SET 6,(" & Ireg & "+dd)"
                        Case &HF2
                   strText = "LD D,SET 6,(" & Ireg & "+dd)"
                        Case &HF3
                   strText = "LD E,SET 6,(" & Ireg & "+dd)"
                        Case &HF4
                   strText = "LD H,SET 6,(" & Ireg & "+dd)"
                        Case &HF5
                   strText = "LD L,SET 6,(" & Ireg & "+dd)"
                        Case &HF6
                   strText = "SET 6,(" & Ireg & "+dd)"
                        Case &HF7
                   strText = "LD A,SET 6,(" & Ireg & "+dd)"
                        Case &HF8
                   strText = "LD B,SET 7,(" & Ireg & "+dd)"
                        Case &HF9
                   strText = "LD C,SET 7,(" & Ireg & "+dd)"
                        Case &HFA
                   strText = "LD D,SET 7,(" & Ireg & "+dd)"
                        Case &HFB
                   strText = "LD E,SET 7,(" & Ireg & "+dd)"
                        Case &HFC
                   strText = "LD H,SET 7,(" & Ireg & "+dd)"
                        Case &HFD
                   strText = "LD L,SET 7,(" & Ireg & "+dd)"
                        Case &HFE
                   strText = "SET 7,(" & Ireg & "+dd)"
                        Case &HFF
                   strText = "LD A,SET 7,(" & Ireg & "+dd)"
                End Select

                GetXi_Yi = strText
End Function
