Attribute VB_Name = "ModDisk_Driver"
' *******************************************************************************
' VB81 XuR
' ModDisk_Driver.BAS - Added by XavSnap. (2007)
' *******************************************************************************



'// Larken Dos Disk Driver.
'// Model Shugart SA455 - 150K 5.25 inches
'// 158,720 bytes - 80 tracks - 1984 Bytes per sectors
'//
'// Load Disk Ram buffer 2K in 12288 to 14336
'//

'// Mageco Dos Disk Driver.
'// Model ... - 150K 3.5 inches
'//  - ?80 tracks? - ?1984? Bytes per sectors
'//
'//??? Load Disk Ram buffer 2K in 12288 to 14336 ???
'//

Sub Read_Track_Buffer(Track As Integer)

On Error Resume Next
If Dir(Drive_Files(ActiveDrive)) = "" Or _
 UCase(Right(Drive_Files(ActiveDrive), 5)) = "*.IMG" Then Exit Sub
 
If bLarken Then
    '// Unformated disk ...
    If Disk_Buffer(140) <> &HFF Then
        MsgBox "Unformated Disk ! ", vbCritical, "I/O error."
        pokeb 14335, &HFA ' Directory stop tag.
        regPC = &H392E ' Jump to Larken CRC error.
        Exit Sub
        End If

        '// Simule a "CRC ERR" if any disks images are mount or if the drive if disabled.
        If Disk_Stat(ActiveDrive) = 0 Or Drive_Files(ActiveDrive) = "" Then
        ClrMemory MEM(&H3040), 1984  ' Reset buffer
        pokeb 14335, &HFA ' Directory stop tag.
        regPC = &H392E ' Jump to Larken CRC error.
        Exit Sub
        End If
        
On Error GoTo Read_Err
CopyMemory MEM(&H3040), Disk_Buffer(CLng(Track) * 1984), 1984

End If

Exit Sub
Read_Err:
MsgBox "Disk image corrupt." & vblrcr & "At track #" & Track, vbCritical, "I/O error."
End Sub

' Mageco Electronic
' Disk driver
Function Read_Mageco_Byte() As Byte
'On Error Resume Next

If Trim(Dir(Drive_Files(ActiveDrive))) = "" Or _
 UCase(Right(Drive_Files(ActiveDrive), 5)) = "*.IMG" Then Exit Function
 Dim hFile As Integer, ByteOFFSET As Long
 hFile = FreeFile
 If (Drive_Files(ActiveDrive)) = "" Then Exit Function
 
 If Mageco_CMD.Track > 80 Or Mageco_CMD.Track < 0 Then Exit Function
Open Drive_Files(ActiveDrive) For Binary Access Read As hFile
ByteOFFSET = (CLng(Mageco_CMD.Track) * 3067) + CLng(Mageco_CMD.Step) + 1
Get #hFile, ByteOFFSET, Read_Mageco_Byte
Close hFile

Mageco_CMD.Step = Mageco_CMD.Step + 1
MEM(&H2078) = (MEM(&H2078) Xor 1)
End Function

Function Write_Mageco_Byte(data As Byte) As Byte
'On Error Resume Next
If Trim(Dir(Drive_Files(ActiveDrive))) = "" Or _
 UCase(Right(Drive_Files(ActiveDrive), 5)) = "*.IMG" Then Exit Function
 Dim hFile As Integer, ByteOFFSET As Long
 hFile = FreeFile
 If (Drive_Files(ActiveDrive)) = "" Then Exit Function
 
 If Mageco_CMD.Track > 80 Or Mageco_CMD.Track < 0 Then Exit Function
Open Drive_Files(ActiveDrive) For Binary Access Write As hFile
ByteOFFSET = (CLng(Mageco_CMD.Track) * 3067) + CLng(Mageco_CMD.Step) + 1
'Debug.Print " Track: "; Mageco_CMD.Track; "/"; Mageco_CMD.Step;
Put #hFile, ByteOFFSET, data
Close hFile

Mageco_CMD.Step = Mageco_CMD.Step + 1
MEM(&H2078) = (MEM(&H2078) Xor 1)
End Function

'//
'// Save Disk Ram buffer 2K in 12288 to 14336
'//
Sub Save_Track_Buffer(Track As Integer)
'On Error Resume Next
Dim attribut As Integer
If Drive_Files(ActiveDrive) = "" Or Dir(Drive_Files(ActiveDrive)) = "" Or _
 UCase(Right(Drive_Files(ActiveDrive), 5)) = "*.IMG" Then Exit Sub
 
If bLarken Then
    '// Simule a "PROT ER" if the image file have a read-only attribut.
    attribut = GetAttr(Drive_Files(ActiveDrive)) And vbReadOnly
    If attribut = vbReadOnly Then
        ClrMemory MEM(&H3040), 1984 ' Reset buffer
        pokeb 14335, &HFA ' Directory stop tag.
        regPC = &H3D7F
        Exit Sub
    End If

    '// Simule a "CRC ERR" if any disks images are mount or if the drive if disabled.
    If Disk_Stat(ActiveDrive) = 0 Or Drive_Files(ActiveDrive) = "" Then
        ClrMemory MEM(&H3040), 1984  ' Reset buffer
        pokeb 14335, &HFA ' Directory stop tag.
        regPC = &H392E ' Jump to Larken CRC error.
        Exit Sub
    End If


On Error GoTo Read_Err
'// Update disk buffer.
CopyMemory Disk_Buffer(CLng(Track) * 1984), MEM(&H3040), 1984

'// Auto-update disk image.
If bDSK_Update Then
    Dim ln As Long
    Dim hFile As Integer
    Dim Track_buffer(0 To 1983) As Byte 'save buffer in a Temp array

        '// Get track memory bloc.
        CopyMemory Track_buffer(0), MEM(&H3040), 1984

    hFile = FreeFile

    Open Drive_Files(ActiveDrive) For Binary Access Write Lock Write As #hFile
    Put #hFile, (CLng(Track) * 1984) + 1, Track_buffer
    Close #hFile
End If
End If
Exit Sub

Read_Err:
MsgBox "Disk image corrupt." & vblrcr & "At track #" & Track, vbCritical, "I/O error."
Close #hFile
End Sub

'//
'// Load Disk image.
'//
Sub Load_Disk()
On Error Resume Next
If Drive_Files(ActiveDrive) = "" Or Dir(Drive_Files(ActiveDrive)) = "" Or _
 UCase(Right(Drive_Files(ActiveDrive), 5)) = "*.IMG" Or bMageco Then Exit Sub

Dim ln As Long
Dim hFile As Integer

hFile = FreeFile

     Open Drive_Files(ActiveDrive) For Binary Access Read Lock Read As #hFile
         ln = LOF(hFile)
         ReDim Disk_Buffer(0 To ln - 1) As Byte
         Get #hFile, 1, Disk_Buffer
    Close #hFile
    
End Sub

'//
'// Save Disk image.
'//
Sub Save_Disk()
On Error Resume Next
If Drive_Files(ActiveDrive) = "" Or Dir(Drive_Files(ActiveDrive)) = "" Or _
 UCase(Right(Drive_Files(ActiveDrive), 5)) = "*.IMG" Or bMageco Then Exit Sub
 

Dim ln As Long
Dim hFile As Integer

hFile = FreeFile
On Error GoTo err_prot
     Open Drive_Files(ActiveDrive) For Binary Access Write Lock Write As #hFile
     Put #hFile, 1, Disk_Buffer
    Close #hFile
    Exit Sub
err_prot:
    Close #hFile
End Sub

'//
'// Save both Disks images. (Quit VB81)
'// ( When user don't eject or change disks images)
'//
Sub Save_AllDisks()
Dim a
For a = 0 To 1
If Drive_Files(a) = "" Or Dir(Drive_Files(a)) = "" Or _
 UCase(Right(a, 5)) = "*.IMG" Or Disk_Stat(a) = 0 Or bMageco Then GoTo no_disk

Dim ln As Long
Dim hFile As Integer

hFile = FreeFile
On Error GoTo err_prot

     Open Drive_Files(a) For Binary Access Write Lock Write As #hFile
     Put #hFile, 1, Disk_Buffer
    Close #hFile
no_disk:
 Next
 
err_prot:
    Close #hFile

End Sub

Sub LarkenHack()

    ' // Larken Rom Hack.
    '
    ' // Patch the 'LoadBuffer' EPROM routine with an illegal operation, which we
    ' // trap in the Z80 emulation so the file can be saved to disk instead of
    ' // the ROM trying to read the track on disk image.
    MEM(&H38DB) = &HCD '
    MEM(&H38DC) = &H2B ' // Call $F2B ; Call Slow mode.
    MEM(&H38DD) = &HF  '
    MEM(&H38DE) = &HED ' // ED FE    ; the illegal Z80 op we use for Load the Larken Buffer.
    MEM(&H38DF) = &HFE ' //
    MEM(&H38E0) = &HC9 ' // RET      ; return to last master runtime

    ' // Patch the 'SaveBuffer' EPROM routine with an illegal operation, which we
    ' // trap in the Z80 emulation so the file can be saved to disk instead of
    ' // the ROM trying to read the track on disk image.
    MEM(&H3A0D) = &HCD '
    MEM(&H3A0E) = &H2B ' // Call $F2B ; Call Slow mode.
    MEM(&H3A0F) = &HF  '
    MEM(&H3A10) = &HED ' // ED FF    ; the illegal Z80 op we use for Save the Larken Buffer.
    MEM(&H3A11) = &HFF ' //
    MEM(&H3A12) = &HC9 ' // RET      ; return to last master runtime



End Sub

