Attribute VB_Name = "ModListView_util"
' *******************************************************************************
' VB81 XuR
' ModListView_util.bas - Added by XavSnap. (2007)
' *******************************************************************************

' From Randy Birch
' http://ewbi.blogs.com/develops/2003/10/resizing_listvi.html
' Google.

Private Type RECT
    Left As Long
    top As Long
    Right As Long
    Bottom As Long
End Type

Private Declare Function SendMessage _
                Lib "user32" _
                Alias "SendMessageA" _
                (ByVal hwnd As Long, _
                 ByVal wMsg As Long, _
                 ByVal wParam As Long, _
                 lParam As Any) As Long
                 
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, _
                                                                  ByVal nCount As Long, lpRect As RECT, _
                                                                  ByVal wFormat As Long) As Long
Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long

Private Const LB_SETHORIZONTALEXTENT = &H194
Private Const DT_CALCRECT = &H400
Private Const SM_CXVSCROLL = 2
Private Const SET_COLUMN_WIDTH = 4126



 Sub AutosizeColumns(ByVal TargetListView As ListView)

  Const AUTOSIZE_USEHEADER  As Long = -2

  Dim lngColumn As Long

  
  For lngColumn = 0 To (TargetListView.ColumnHeaders.count - 1)
   
    Call SendMessage(TargetListView.hwnd, _
                     SET_COLUMN_WIDTH, _
                     lngColumn, _
                     ByVal AUTOSIZE_USEHEADER)
        
  Next lngColumn

End Sub

' Manual resize. (calculate text width and set column header to max lenght)
' from start to end list for a specific column.
' SetColumWith window.hdc, object , #column , Fist Raw , Last Raw
' OPTIONAL = default colum#1 , raw#1 , last raw.

Public Sub SetColumWidth(ByVal hdc As Long, MaListe As ListView, Optional Column As Integer = 0, Optional First_Index = 1, Optional Last_Index = -1)

If MaListe.ListItems.count = 0 Then Exit Sub
    
    Dim compteur As Long, Nlargeur As Long, LargText As Long, sysScrollWidth As Long
    Dim rcText As RECT, NbSpace As Integer
           
    If Last_Index = -1 Then Last_Index = MaListe.ListItems.count
    
    If First_Index >= Last_Index Then First_Index = Last_Index
    
    sysScrollWidth = GetSystemMetrics(SM_CXVSCROLL)
    For compteur = First_Index To Last_Index
           DrawText hdc, MaListe.ListItems.Item(compteur), -1&, rcText, DT_CALCRECT
           LargText = rcText.Right + sysScrollWidth
           
' Warning: This methode seem to swap space detection ! (a space lenght is null)
'          we must add space character to get his lenght.
'
NbSpace = CharCounter(MaListe.ListItems.Item(compteur), Chr(32))

           If NbSpace > 0 Then
           DrawText hdc, SPChar(NbSpace, "_"), -1&, rcText, DT_CALCRECT
           LargText = LargText + rcText.Right
           End If
' end of space traitement.
        
           If LargText >= Nlargeur Then
                Nlargeur = LargText + 30
           End If
    Next compteur

    Call SendMessage(MaListe.hwnd, _
                     SET_COLUMN_WIDTH, _
                     Column, _
                     ByVal Nlargeur)
   
End Sub


Sub ListView_BK_Col(MaListe As ListView, Back_Color As Long)
'general

Const LVM_SETTEXTBKCOLOR = (&H1000 + 38)

'((hwnd), LVM_SETTEXTBKCOLOR, 0, (LPARAM)(COLORREF)(clrTextBk))
    Call SendMessage(MaListe.hwnd, _
                     LVM_SETTEXTBKCOLOR, _
                     0, _
                     ByVal Back_Color)

End Sub
Sub ListView_Fore_Col(MaListe As ListView, Fore_Color As Long)
'general
'      For Each obj In ctl.ColumnHeaders
'                obj.text = LoadResString(CInt(obj.Tag))
'            Next
            
Dim obj2 As Variant
Dim obj As Variant
'MaListe.ListItems.Item.ListSubItems.Item.
For Each obj In MaListe.ListItems
             If Left(obj.text, 1) <> "_" Then obj.ForeColor = Fore_Color Else obj.ForeColor = &HFFFFFF
             For Each obj2 In obj.ListSubItems
             obj2.ForeColor = Fore_Color
Next
Next

MaListe.Refresh
End Sub
Function CharCounter(char As String, ref_char As String) As Integer
'Enum all ref_char in a char string.
'CharCounter("*xxx*x**xx","*") => return = 4
'CharCounter("*xxx*x**xx","x") => return = 6
'CharCounter("*xxx*x**xx","+") => return = 0 (!!!) COOOooool!
'
Dim Cnt As Integer
Dim a As Integer

a = 1
Cnt = 0
Do While a <= Len(char)
If InStr(a, char, ref_char, vbBinaryCompare) <> 0 Then Cnt = Cnt + 1: a = InStr(a, char, ref_char) + 1 Else Exit Do
Loop

CharCounter = Cnt
End Function

Function SPChar(number As Integer, char As String) As String

Dim a As Integer
a = 0
tmpchar = ""

Do While a < number
    tmpchar = tmpchar + char: a = a + 1
Loop

SPChar = tmpchar
End Function

Sub ListView_Back_Col(MaListe As ListView, Back_Color As Long)
'general

Const LVM_SETTEXTBKCOLOR = (&H1000 + 38)

'((hwnd), LVM_SETTEXTBKCOLOR, 0, (LPARAM)(COLORREF)(clrTextBk))
    Call SendMessage(MaListe.hwnd, _
                     LVM_SETTEXTBKCOLOR, _
                     1, _
                     ByVal Back_Color)

End Sub

Public Function GetFontwidth(Txtbox As PictureBox) As Long
    Dim rcText As RECT, NbSpace As Integer
     Txtbox.Font = FrmForth.Mnemonics.Font
     Txtbox.FontSize = FrmForth.Mnemonics.FontSize
     Txtbox.Cls
     Txtbox.Print "123456789o123456789o123456789o123456789o123456789i123456789o123456789o123456789o123456789o123456789*123456789o123456789o123456789o123456789o123456789i123456789o123456789o123456789o123456789o123456789*"
          
           DrawText Txtbox.hdc, "0", -1, rcText, DT_CALCRECT
           GetFontwidth = rcText.Right
      
End Function
