Attribute VB_Name = "ModPrinter"
' *******************************************************************************
' VB81 XuR
' ModPrinter.BAS - Added by XavSnap. (2007)
' *******************************************************************************

' Printer def. (32x24): 258 (3,44 Inches) x 192 (2,56 Inches)

'  Port FBh Read - Printer Status
'  Bit  Expl.
'  0      Data Request(0 = Busy, 1 = Ready / DRQ)
'  1-5    Not used
'  6      Printer Detect(0 = Okay, 1 = None)
'  7      Printer Online(0 = Nope, 1 = Ready / Online)

 
'  Port FBh Write - Printer Output
'  Bit  Expl.
'  0-6  ??? Somewhat one or more bits for linefeed and/or else...
'  7      Pixel Output(0 = White, 1 = Black)


Sub Init_Printer()

Dim a
Stylus_X = 0
Stylus_Y = 0
iCounter = 1
PrinterCnt = 0

' Init Printer buffer
ReDim PrinterBuffer(257) ' 258 bytes.

FrmPrinter.SelCol.Move FrmPrinter.DotColor(0).Left, FrmPrinter.DotColor(0).top - 1, 9, 18
Set FrmPrinter.Paper = Nothing

FrmPrinter.Paper.Height = Screen.TwipsPerPixelY * 2
FrmPrinter.Paper.Width = Screen.TwipsPerPixelX * 259
FrmMultiCols.ClsPicture
FrmMultiCols.Refresh_Title

If Printer_Art = True Then
FrmPrinter.Dither.Picture = FrmPrinter.Prn_IMG.ListImages.Item("D_ON").Picture
Else
FrmPrinter.Dither.Picture = FrmPrinter.Prn_IMG.ListImages.Item("D_OFF").Picture
End If

' Sylus On
ReDim Stylus_Art_Bl(1 To 12)
For a = 15 To 125 Step 10
Stylus_Art_Bl(iCounter) = RGB(a, a, a)
iCounter = iCounter + 1
Next

' Stylus OFF
iCounter = 1
ReDim Stylus_Art_Wh(1 To 11)
For a = 255 To 245 Step -1
Stylus_Art_Wh(iCounter) = RGB(a, a, a)
iCounter = iCounter + 1
Next

If FrmPrinter Is Nothing Then Load FrmPrinter

FrmPrinter.VScroll.max = 0



'-------------------------------------------------
'dc = GenerateDC(Bitmaphandle)


'Check if the bitmap is 8-bit
'GetObjectAPI Bitmaphandle, Len(PRTBm), PRTBm

'Debug.Print PRTBm.bmiHeader.biHeight

' Note:
' The printer buffer matrix (FrmPrinter.BuffPic)
' was filled with a 8 bytes blank picture to
' retrieve the BMI header. (256x1xwhitex256coulors-System Pal)
' Don't change or delete it!
'If PRTBm.bmBitsPixel <> 8 Then 'not a usable format
'    MsgBox "Must be an 8-bit bitmap"
'    Unload Me
'    Exit Sub
'End If

'Create the gray color table, based on the original table
'CreateColorTables

'draw the picture
'BitBlt FrmPrinter.Paper.hdc, 0, 0, BitmapWidth, BitmapHeight, dc, 0, 0, vbSrcCopy
'-------------------------------------------------
'FrmPrinter.Refresh

End Sub

Public Sub PlotToPrinter(Stylus As Boolean)


Stylus_X = Stylus_X + 1

If Stylus_X = 258 Then Call AddPrtLine: Exit Sub ' FrmPrinter.Paper.Refresh: Exit Sub ' Set FrmPrinter.Paper.Picture = FrmPrinter.Paper.Image: FrmPrinter.Paper.Refresh: Exit Sub


'Following printer in progress (scroll bar locked!)
'FrmPrinter.VScroll.Value = FrmPrinter.Paper.Height

If Stylus_X >= 0 Then
If Printer_Art Then
    If Stylus Then
     PrinterBuffer(Stylus_X) = Stylus_Art_Bl(Int(12 * Rnd) + 1)
    Else
     PrinterBuffer(Stylus_X) = Stylus_Art_Wh(Int(11 * Rnd) + 1)
    End If
Else
    If Stylus Then
    PrinterBuffer(Stylus_X) = Stylus_Art_Bl(1)
    Else
    PrinterBuffer(Stylus_X) = Stylus_Art_Wh(1)
    End If
End If
End If

End Sub

Sub Refresh_Leds(pState As Integer)

Select Case pState
Case 0
FrmPrinter.Prn_State.Picture = FrmPrinter.Prn_IMG.ListImages.Item("L000").Picture

Case 100
FrmPrinter.Prn_State.Picture = FrmPrinter.Prn_IMG.ListImages.Item("L100").Picture

Case 101
FrmPrinter.Prn_State.Picture = FrmPrinter.Prn_IMG.ListImages.Item("L101").Picture

Case 110
FrmPrinter.Prn_State.Picture = FrmPrinter.Prn_IMG.ListImages.Item("L110").Picture

Case 111
FrmPrinter.Prn_State.Picture = FrmPrinter.Prn_IMG.ListImages.Item("L111").Picture
End Select

DoEvents
'FrmPrinter.Prn_State.Refresh
End Sub

Private Sub CreateColorTables()
Dim i As Long
Dim TempValue As Long

For i = LBound(GrayTable) To UBound(GrayTable)
        
    'Create Gray Color table
    'Add the values together
    TempValue = OriginalTable(i).rgbBlue
    TempValue = TempValue + OriginalTable(i).rgbGreen
    TempValue = TempValue + OriginalTable(i).rgbRed
    
    'Get the medium value
    TempValue = TempValue / 3
    
    'Set the color in the gray table
    GrayTable(i).rgbBlue = TempValue
    GrayTable(i).rgbGreen = TempValue
    GrayTable(i).rgbRed = TempValue
        
    'Create the rest of the color tables
    'Red Table
    RedTable(i).rgbBlue = 0
    RedTable(i).rgbGreen = 0
    RedTable(i).rgbRed = OriginalTable(i).rgbRed
    
    'Green Table
    GreenTable(i).rgbBlue = 0
    GreenTable(i).rgbRed = 0
    GreenTable(i).rgbGreen = OriginalTable(i).rgbGreen
    
    'Blue table
    BlueTable(i).rgbBlue = OriginalTable(i).rgbBlue
    BlueTable(i).rgbGreen = 0
    BlueTable(i).rgbRed = 0
    
    'invert table
    InvertTable(i).rgbBlue = 255 - OriginalTable(i).rgbBlue
    InvertTable(i).rgbGreen = 255 - OriginalTable(i).rgbGreen
    InvertTable(i).rgbRed = 255 - OriginalTable(i).rgbRed

Next i
    
End Sub

Private Sub AddPrtLine()

    'Refresh_Leds 101
    Stylus_X = 0
    If G_Card = eHiResMEMOTECH And (intI And 1) Then Stylus_X = -1

  ' Create a new line to be printed.

  'Refresh Printed line.
  With FrmPrinter.Paper
          
          .Height = (CDbl(Stylus_Y) * CDbl(Screen.TwipsPerPixelY)) + 50

          .AutoRedraw = True

  ' Paste Byte buffer in the printer picture.

             For cmp = 0 To 257
                 FrmPrinter.Paper.PSet ((cmp - 2) * CDbl(Screen.TwipsPerPixelX), CLng(Stylus_Y) * CDbl(Screen.TwipsPerPixelY)), CLng(PrinterBuffer(cmp))
             Next cmp
             FrmPrinter.Paper.Refresh
          .AutoRedraw = False
 
         '    FrmPrinter.Paper.Picture = FrmPrinter.Paper.Image
     '        FrmPrinter.Paper.Refresh
   End With
   Stylus_Y = Stylus_Y + 1

     ' Init Printer buffer
     '   ReDim PrinterBuffer(257) ' 258 bytes.
     
If FrmPrinter.Visible Then
    If FrmPrinter.VScroll.max < &H7FFF Then
        FrmPrinter.VScroll.max = (FrmPrinter.Paper.Height \ 8) \ Screen.TwipsPerPixelY
    Else
        Debug.Print "err"
    End If
End If
 
    If FrmMultiCols.Visible Then Call FrmMultiCols.draw: DoEvents
End Sub
