Attribute VB_Name = "ModSBB_Format"
Option Explicit

' *******************************************************************************
'  VB81 XuR added by XavSnap. (2008)
' *******************************************************************************
'//sbb origin

Const eSBB_test = "H"
Const eSBB_Screen = "S"
Const eSBB_Tape = "T"
Const eSBB_cas = "C"
Const eSBB_rom = "R"
Const eSBB_Binary = "B"



'//block type zx
Const zx_program = "0"     '// - program (basic)
Const zx_char_array = "1"  '// - character array
Const zx_num_array = "2"   '// - numeric array
Const zx_bytes = "3"       '// - code (bytes)
Const zx_tap_hdlss = "4"   '//  - headerless block
Const zx_tzx_hdlss = "5"   '//  - headerless block tzx
Const zx_48k_snap = "6"   '//  6 snapshot 48k
Const zx_128k_snap = "7"  '//  7 snapshot 128k
Const zx_16k_page = "8"   '//  8 pagina 16k
Const zx_complete = "9"   '//  8 pagina 16k


'//block type  cpc
Const cpc_basic = "-"       '//basic
Const cpc_ascii = "A"       '//ascii
Const cpc_binary = "B"      '//binario
Const cpc_protected = "P"   '//protegido
Const cpc_64k_snap = "S"    '//snapshot

'//block type  msx
'Const msx_token = Chr$(&HD3) '//basic
'Const msx_bytes = Chr$(&HD0) '//memory dump  cas
'Const msx_ascii = Chr$(&HEA) '//datafile
'Const msx_bin = Chr$(&HFE)   '//memory dump  dsk

'//block type  zx81
Const ZX81_program = "p"      '//programm
Const ZX81_snap = "s"         '//snapshot

Type SBB_Header ' 32 BYTES.
    Sbb As String * 2 ' "SB"
    version As Byte   ' &H21/&H22 Release 2.1 / 2.2
    Machine As String * 4 ' "ZX" ;  "CPC" ; "MSX" Or "81"
    Model As Byte
    
    ' ------------ ZX81 ------------
    '1="1k-ZX81"
    '2="2k-TS1000"
    '3= "16k ram pack"
    '4= "48k ram pack"
    '5= "64k ram pack"
    
    'Others (info!)
    
    ' ------------ Spectrum ------------
    '1="48k"
    '2= "128k"
    '3= "+2a"
    ' ---------- AMSTRAD CPC -----------
    '1="464";
    '2=return "6128"
    '3=  "664"
    ' ------------   MSX   ------------
    '1="16k"
    '2= "32k"
    '3=  "64k"
    
    Extra_info  As String * 7 'Ready For Future Uses
    Ei_di As Byte ' Enable disable interrupts between blocks
    Nombre As String * 16 ' Tape name
    Locate As Byte ' Most Significative Byte for the address of loading routine
    Origin As String * 1 ' sbb was built from tap, bin , sna ...
    N_blocks As Byte ' number of blocks
    Poke_ffff(1) As Byte ' msx pagination (if 0, Poke -1 is not modified)
    Clear_sp(1) As Byte ' clear or SP (if 0, SP is not modified)
    Usr_pc(1) As Byte ' execution address after loading all blocs(if 0, it is not an executable )
End Type

' Old header.
Type SBB_Blocs_Header
 blockname As String * 16
    ini As Integer
    Size As Integer
    param3 As Integer
    exec As Integer
    Type As String * 1
    chksum As Byte
End Type

Type SBB_Bloc_Header ' 28 BYTES.
 blockname As String * 16 ' description
 Size(1) As Byte ' Number of bytes for data
 param3(1) As Byte ' Aux parameter
 block_type As String * 1 ' type
 h_chksum As Byte ' checksum for header of block =((ini-1) XOR jump XOR exec)
 ini(1) As Byte ' start memory address for data
 Jump  As Byte ' 0xC3 or 0xCD for an executable block , 0x01 or 0xc9 in other case
 exec(1) As Byte ' execution address for block. If zero, it is not an executable block
 d_chksum As Byte ' checksum for datas
End Type

Sub Enum_SBBfiles(Filename As String)
Dim m_iLen, m_iFile, Offset As Long, cmp, ErrTag As Integer
Dim SBB_Header As SBB_Header
Dim SBB_Bloc_Header As SBB_Bloc_Header
Dim Name As String * 8
Dim lenght As Long, Zxcnt As Long
Dim ZxN As Byte
Dim data(4) As Byte

ReDim Enum_T81(0 To 0)
ReDim VT_NameZX(0)


cmp = -1

     m_iFile = FreeFile
     Offset = 5
      
     Open Filename For Binary Access Read Lock Write As #m_iFile
     Get #m_iFile, 1, SBB_Header
     Debug.Print SBB_Header.N_blocks
     If SBB_Header.Sbb <> "SB" Then ErrTag = 1: GoTo ErrJmp
     If SBB_Header.version < &H21 Then ErrTag = 2: GoTo ErrJmp
     If Cut_o_arg(SBB_Header.Machine) <> "81" Then ErrTag = 3: GoTo ErrJmp
     
     Offset = Len(SBB_Header)
     m_iLen = LOF(m_iFile)
     Do While Offset < m_iLen + 1

         Get #m_iFile, Offset, SBB_Bloc_Header
         Get #m_iFile, , data

         Name = Cut_o_arg(SBB_Bloc_Header.blockname)
         lenght = Get_UINT(SBB_Bloc_Header.Size)
         
         If Offset > m_iLen Then Exit Do
         
     If SBB_Bloc_Header.block_type = ZX81_program Then
         cmp = cmp + 1
         ReDim Preserve Enum_T81(0 To cmp)
         ReDim Preserve VT_NameZX(cmp)
          
       VT_NameZX(cmp).Nom_Fichier = Cut_attr(UCase(Cut_o_arg(Name))) ' & IIf(SBB_Bloc_Header.block_type = ZX81_program, " (P FILE)", "") & IIf(SBB_Bloc_Header.block_type = ZX81_snap, " (Z81 FILE)", "") & IIf(SBB_Bloc_Header.block_type = zx_bytes, " (Binary FILE)", "") & IIf(SBB_Bloc_Header.block_type = zx_tzx_hdlss, " (TZX FILE)", "")

' Check redondant name.
Dim rd As Integer
For rd = 0 To cmp - 1
If VT_NameZX(rd).Nom_Fichier = VT_NameZX(cmp).Nom_Fichier Then VT_NameZX(cmp).Nom_Fichier = VT_NameZX(cmp).Nom_Fichier & cmp
Next
       
       VT_NameZX(cmp).Offset = Offset + Len(SBB_Bloc_Header)
       VT_NameZX(cmp).Taille = lenght
    End If
    
         Offset = Offset + Len(SBB_Bloc_Header) + lenght
         
         If Offset > m_iLen Then Exit Do
          Loop
          

ErrJmp:
     If ErrTag <> 0 Then
     Select Case ErrTag
     Case 1
            With FrmSelectDir.T81_Enum.ListItems
                  .Clear
                  .Add
                  .Item(.count) = "Wrong SBB file."
            End With

     Case 2
            With FrmSelectDir.T81_Enum.ListItems
                  .Clear
                  .Add
                  .Item(.count) = "Old release ( < 2.1 )"
            End With
            
     Case 3
     
       With FrmSelectDir.T81_Enum.ListItems
                  .Clear
                  .Add
                  .Item(.count) = IIf(Cut_o_arg(SBB_Header.Machine) = "ZX", "ZX Spectrum SBB file !", "") & IIf(Cut_o_arg(SBB_Header.Machine) = "CPC", "Amstrad CPC SBB file !", "") & IIf(Cut_o_arg(SBB_Header.Machine) = "MSX", "MSX SBB file !", "")
       End With
     
     End Select
     End If
       
     Close #m_iFile

End Sub
Sub Load_SBBFile(Filename As String, F81index As Long)

'/// Extract P files in a SBB file.

Dim m_iLen, m_iFile
Dim Name As String * 8
Dim lenght As String * 6
Dim P_header As P_header
Dim data As Byte
Dim a As Integer

m_iFile = FreeFile


If F81index < 0 Then F81index = 1: VT_Index = 1

     Open Filename For Binary Access Read Lock Write As #m_iFile
         m_iLen = LOF(m_iFile)
         
         ' If the end of printer buffer is 76h, the tape tag is ignored.
         Get #m_iFile, VT_NameZX(F81index).Offset + 83, data
         If data = &H76 Then a = 0: GoTo No_TAPE_TAG
         
         ' Ignore tape Name.
         For a = 0 To 30
         Get #m_iFile, VT_NameZX(F81index).Offset + a, data
         If data And &H80 Then Exit For
         Next
         a = a + 1
         
No_TAPE_TAG:
            Get #m_iFile, VT_NameZX(F81index).Offset + a, P_header
         
         Dim len_bas
         If UinttoS(P_header.D_FILE) > 16509 Then len_bas = UinttoS(P_header.D_FILE) - 16509
         
        
         ReDim Prog_ZXT81(0 To (VT_NameZX(F81index).Taille - 1 - a)) As Byte
         Get #m_iFile, (VT_NameZX(F81index).Offset + a), Prog_ZXT81()
Err_len:
     Close #m_iFile
     CopyMemory MEM(&H4009), Prog_ZXT81(0), VT_NameZX(F81index).Taille - a
'ChDir New_Path
 End Sub

Private Function Get_UINT(Value() As Byte) As Long
Get_UINT = Value(0) + (Value(1) * 256)
End Function

Private Function Set_UINT(Int_Arr() As Byte, Int_Lng As Long)
Int_Arr(1) = (Int_Lng \ 256)
Int_Arr(0) = Int_Lng - Int_Arr(1)
End Function

Function ChkSum8(datas() As Byte) As Byte
Dim Cnt As Long
Dim Sum As Long
For Cnt = LBound(datas) To UBound(datas)
Sum = (Sum And 255) + datas(Cnt)
Next
ChkSum8 = CByte(Sum And 255)
End Function
