VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "PrintInPDF"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
'  << Haru Free PDF Library 2.0.3 >> -- hpdf.h
'
'  URL http://libharu.org/
'
'  Copyright (c) 1999-2006 Takeshi Kanno
'
'  Permission to use, copy, modify, distribute and sell this software
'  and its documentation for any purpose is hereby granted without fee,
'  provided that the above copyright notice appear in all copies and
'  that both that copyright notice and this permission notice appear
'  in supporting documentation.
'  It is provided "as is" without express or implied warranty.
'
'

'----- type definition ------------------------------------------------------

'  HPDF_Point struct
Private Type HPDF_Point
    x As Single
    y As Single
End Type

Private Type HPDF_Rect
    Left        As Single
    bottom      As Single
    Right       As Single
    top         As Single
End Type

Private Type HPDF_Box
    Left        As Single
    bottom      As Single
    Right       As Single
    top         As Single
End Type

' HPDF_Date struct
Private Type HPDF_Date
    Year        As Long
    Month       As Long
    Day         As Long
    Hour        As Long
    minutes     As Long
    seconds     As Long
    ind         As Byte
    off_hour    As Long
    off_minutes As Long
End Type


Private Enum HPDF_InfoType
    ' date-time type parameters
    HPDF_INFO_CREATION_DATE = 0
    HPDF_INFO_MOD_DATE = 1

    ' string type parameters
    HPDF_INFO_AUTHOR = 2
    HPDF_INFO_CREATOR = 3
    HPDF_INFO_PRODUCER = 4
    HPDF_INFO_TITLE = 5
    HPDF_INFO_SUBJECT = 6
    HPDF_INFO_KEYWORDS = 7
    HPDF_INFO_EOF = 8
End Enum


Private Enum HPDF_EncryptMode
    HPDF_ENCRYPT_R2 = 2
    HPDF_ENCRYPT_R3 = 3
End Enum

'------ text width struct --------------------------------------------------
Private Type HPDF_TextWidth
    numchars    As Long
    ' don't use this value (it may be change in the feature).
    '   use numspace as alternated.
    numwords    As Long
    width       As Long
    numspace    As Long
End Type

'------ dash mode ----------------------------------------------------------
Private Type HPDF_DashMode
    ptn(8)      As Integer
    num_ptn     As Long
    phase       As Long
End Type


'----- HPDF_TransMatrix struct ---------------------------------------------
Private Type HPDF_TransMatrix
     a          As Single
     b          As Single
     c          As Single
     D          As Single
     x          As Single
     y          As Single
End Type


'---------------------------------------------------------------------------
Private Enum HPDF_ColorSpace
    HPDF_CS_DEVICE_GRAY = 0
    HPDF_CS_DEVICE_RGB = 1
    HPDF_CS_DEVICE_CMYK = 2
    HPDF_CS_CAL_GRAY = 3
    HPDF_CS_CAL_RGB = 4
    HPDF_CS_LAB = 5
    HPDF_CS_ICC_BASED = 6
    HPDF_CS_SEPARATION = 7
    HPDF_CS_DEVICE_N = 8
    HPDF_CS_INDEXED = 9
    HPDF_CS_PATTERN = 10
    HPDF_CS_EOF = 11
End Enum

'----- HPDF_RGBColor struct ------------------------------------------------
Private Type HPDF_RGBColor
       r        As Single
       g        As Single
       b        As Single
End Type

'----- HPDF_CMYKColor struct -----------------------------------------------
Private Type HPDF_CMYKColor
       c      As Single
       m      As Single
       y      As Single
       k      As Single
End Type


'------ The line cap style -------------------------------------------------
Private Enum HPDF_LineCap
    HPDF_BUTT_END = 0
    HPDF_ROUND_END = 1
    HPDF_PROJECTING_SCUARE_END = 2
    HPDF_LINECAP_EOF = 3
End Enum

'------ The line join style -------------------------------------------------
Private Enum HPDF_LineJoin
    HPDF_MITER_JOIN = 0
    HPDF_ROUND_JOIN = 1
    HPDF_BEVEL_JOIN = 2
    HPDF_LINEJOIN_EOF = 3
End Enum

'------ The text rendering mode ---------------------------------------------
Private Enum HPDF_TextRenderingMode
    HPDF_FILL = 0
    HPDF_STROKE = 1
    HPDF_FILL_THEN_STROKE = 2
    HPDF_INVISIBLE = 3
    HPDF_FILL_CLIPPING = 4
    HPDF_STROKE_CLIPPING = 5
    HPDF_FILL_STROKE_CLIPPING = 6
    HPDF_CLIPPING = 7
    HPDF_RENDERING_MODE_EOF = 8
End Enum


Private Enum HPDF_WritingMode
    HPDF_WMODE_HORIZONTAL = 0
    HPDF_WMODE_VERTICAL = 1
    HPDF_WMODE_EOF = 2
End Enum


Private Enum HPDF_PageLayout
    HPDF_PAGE_LAYOUT_SINGLE = 0
    HPDF_PAGE_LAYOUT_ONE_COLUMN = 1
    HPDF_PAGE_LAYOUT_TWO_COLUMN_LEFT = 2
    HPDF_PAGE_LAYOUT_TWO_COLUMN_RIGHT = 3
    HPDF_PAGE_LAYOUT_EOF = 4
End Enum


Private Enum HPDF_PageMode
    HPDF_PAGE_MODE_USE_NONE = 0
    HPDF_PAGE_MODE_USE_OUTLINE = 1
    HPDF_PAGE_MODE_USE_THUMBS = 2
    HPDF_PAGE_MODE_FULL_SCREEN = 3
    HPDF_PAGE_MODE_USE_ATTACHMENTS = 4
    HPDF_PAGE_MODE_EOF = 5
End Enum


Private Enum HPDF_PageNumStyle
    HPDF_PAGE_NUM_STYLE_DECIMAL = 0
    HPDF_PAGE_NUM_STYLE_UPPER_ROMAN = 1
    HPDF_PAGE_NUM_STYLE_LOWER_ROMAN = 2
    HPDF_PAGE_NUM_STYLE_UPPER_LETTERS = 3
    HPDF_PAGE_NUM_STYLE_LOWER_LETTERS = 4
    HPDF_PAGE_NUM_STYLE_EOF = 5
End Enum


Private Enum HPDF_DestinationType
    HPDF_XYZ = 0
    HPDF_FIT = 1
    HPDF_FIT_H = 2
    HPDF_FIT_V = 3
    HPDF_FIT_R = 4
    HPDF_FIT_B = 5
    HPDF_FIT_BH = 6
    HPDF_FIT_BV = 7
    HPDF_DST_EOF = 8
End Enum


Private Enum HPDF_AnnotType
    HPDF_ANNOT_TEXT_NOTES = 1
    HPDF_ANNOT_LINK = 2
    HPDF_ANNOT_SOUND = 3
    HPDF_ANNOT_FREE_TEXT = 4
    HPDF_ANNOT_STAMP = 5
    HPDF_ANNOT_SQUARE = 6
    HPDF_ANNOT_CIRCLE = 7
    HPDF_ANNOT_STRIKE_OUT = 8
    HPDF_ANNOT_HIGHTLIGHT = 9
    HPDF_ANNOT_UNDERLINE = 10
    HPDF_ANNOT_INK = 11
    HPDF_ANNOT_FILE_ATTACHMENT = 12
    HPDF_ANNOT_POPUP = 13
End Enum


Private Enum HPDF_AnnotFlgs
    HPDF_ANNOT_INVISIBLE = 1
    HPDF_ANNOT_HIDDEN = 2
    HPDF_ANNOT_PRINT = 3
    HPDF_ANNOT_NOZOOM = 4
    HPDF_ANNOT_NOROTATE = 5
    HPDF_ANNOT_NOVIEW = 6
    HPDF_ANNOT_READONLY = 7
End Enum


Private Enum HPDF_AnnotHighlightMode
    HPDF_ANNOT_NO_HIGHTLIGHT = 0
    HPDF_ANNOT_INVERT_BOX = 1
    HPDF_ANNOT_INVERT_BORDER = 2
    HPDF_ANNOT_DOWN_APPEARANCE = 3
    HPDF_ANNOT_HIGHTLIGHT_MODE_EOF = 4
End Enum


Private Enum HPDF_AnnotIcon
    HPDF_ANNOT_ICON_COMMENT = 0
    HPDF_ANNOT_ICON_KEY = 1
    HPDF_ANNOT_ICON_NOTE = 2
    HPDF_ANNOT_ICON_HELP = 3
    HPDF_ANNOT_ICON_NEW_PARAGRAPH = 4
    HPDF_ANNOT_ICON_PARAGRAPH = 5
    HPDF_ANNOT_ICON_INSERT = 6
    HPDF_ANNOT_ICON_EOF = 7
End Enum


'------ border stype --------------------------------------------------------
Private Enum HPDF_BSSubtype
    HPDF_BS_SOLID = 1
    HPDF_BS_DASHED = 2
    HPDF_BS_BEVELED = 3
    HPDF_BS_INSET = 4
    HPDF_BS_UNDERLINED = 5
End Enum


Private Enum HPDF_PageSizes
    HPDF_PAGE_SIZE_LETTER = 0
    HPDF_PAGE_SIZE_LEGAL = 1
    HPDF_PAGE_SIZE_A3 = 2
    HPDF_PAGE_SIZE_A4 = 3
    HPDF_PAGE_SIZE_A5 = 4
    HPDF_PAGE_SIZE_B4 = 5
    HPDF_PAGE_SIZE_B5 = 6
    HPDF_PAGE_SIZE_EXECUTIVE = 7
    HPDF_PAGE_SIZE_US4x6 = 8
    HPDF_PAGE_SIZE_US4x8 = 9
    HPDF_PAGE_SIZE_US5x7 = 10
    HPDF_PAGE_SIZE_COMM10 = 11
    HPDF_PAGE_SIZE_EOF = 12
End Enum


Private Enum HPDF_PageDirection
    HPDF_PAGE_PORTRAIT = 0
    HPDF_PAGE_LANDSCAPE = 1
End Enum


Private Enum HPDF_EncoderType
    HPDF_ENCODER_TYPE_SINGLE_BYTE = 1
    HPDF_ENCODER_TYPE_DOUBLE_BYTE = 2
    HPDF_ENCODER_TYPE_UNINITIALIZED = 3
    HPDF_ENCODER_UNKNOWN = 4
End Enum


Private Enum HPDF_ByteType
    HPDF_BYTE_TYPE_SINGLE = 0
    HPDF_BYTE_TYPE_LEAD = 1
    HPDF_BYTE_TYPE_TRIAL = 2
    HPDF_BYTE_TYPE_UNKNOWN = 3
End Enum


Private Enum HPDF_TextAlignment
    HPDF_TALIGN_LEFT = 0
    HPDF_TALIGN_RIGHT = 1
    HPDF_TALIGN_CENTER = 2
    HPDF_TALIGN_JUSTIFY = 3
End Enum


''----------------------------------------------------------------------------

Private Const HPDF_TRUE = 1
Private Const HPDF_FALSE = 0

Private Const HPDF_OK = 0
Private Const HPDF_NOERROR = 0

'----- default values -------------------------------------------------------

' buffer size which is required when we convert to character string.
Private Const HPDF_TMP_BUF_SIZ = 256
Private Const HPDF_SHORT_BUF_SIZ = 32
Private Const HPDF_REAL_LEN = 11
Private Const HPDF_INT_LEN = 11
Private Const HPDF_TEXT_DEFAULT_LEN = 256
Private Const HPDF_UNICODE_HEADER_LEN = 2
Private Const HPDF_DATE_TIME_STR_LEN = 23

' length of each item defined in PDF
Private Const HPDF_BYTE_OFFSET_LEN = 10
Private Const HPDF_OBJ_ID_LEN = 7
Private Const HPDF_GEN_NO_LEN = 5

' default value of Graphic State
Private Const HPDF_DEF_FONT = "Helvetica"
Private Const HPDF_DEF_PAGE_LAYOUT = HPDF_PAGE_LAYOUT_SINGLE
Private Const HPDF_DEF_PAGE_MODE = HPDF_PAGE_MODE_USE_NONE
Private Const HPDF_DEF_WORDSPACE = 0
Private Const HPDF_DEF_CHARSPACE = 0
Private Const HPDF_DEF_FONTSIZE = 10
Private Const HPDF_DEF_HSCALING = 100
Private Const HPDF_DEF_LEADING = 0
Private Const HPDF_DEF_RENDERING_MODE = HPDF_FILL
Private Const HPDF_DEF_RISE = 0
Private Const HPDF_DEF_RAISE = HPDF_DEF_RISE
Private Const HPDF_DEF_LINEWIDTH = 1
Private Const HPDF_DEF_LINECAP = HPDF_BUTT_END
Private Const HPDF_DEF_LINEJOIN = HPDF_MITER_JOIN
Private Const HPDF_DEF_MITERLIMIT = 10
Private Const HPDF_DEF_FLATNESS = 1
Private Const HPDF_DEF_PAGE_NUM = 1
Private Const HPDF_BS_DEF_WIDTH = 1

' defalt page-size
Private Const HPDF_DEF_PAGE_WIDTH = 595.276
Private Const HPDF_DEF_PAGE_HEIGHT = 841.89
Private Const HPDF_VERSION_TEXT = "2.0.5"

'---------------------------------------------------------------------------
'----- compression mode ----------------------------------------------------

Private Const HPDF_COMP_NONE = &H0
Private Const HPDF_COMP_TEXT = &H1
Private Const HPDF_COMP_IMAGE = &H2
Private Const HPDF_COMP_METADATA = &H4
Private Const HPDF_COMP_ALL = &HF
' Private const  HPDF_COMP_BEST_COMPRESS   =&H10
' Private const  HPDF_COMP_BEST_SPEED      =&H20
'
Private Const HPDF_COMP_MASK = &HFF


'----------------------------------------------------------------------------
'----- permission flags (only Revision 2 is supported)-----------------------

Private Const HPDF_ENABLE_READ = 0
Private Const HPDF_ENABLE_PRINT = 4
Private Const HPDF_ENABLE_EDIT_ALL = 8
Private Const HPDF_ENABLE_COPY = 16
Private Const HPDF_ENABLE_EDIT = 32


'----------------------------------------------------------------------------
'------ viewer preferences definitions --------------------------------------

Private Const HPDF_HIDE_TOOLBAR = 1
Private Const HPDF_HIDE_MENUBAR = 2
Private Const HPDF_HIDE_WINDOW_UI = 4
Private Const HPDF_FIT_WINDOW = 8
Private Const HPDF_CENTER_WINDOW = 16


'---------------------------------------------------------------------------
'------ limitation of object implementation (PDF1.4) -----------------------

Private Const HPDF_LIMIT_MAX_INT = 2147483647
Private Const HPDF_LIMIT_MIN_INT = -2147483647

Private Const HPDF_LIMIT_MAX_REAL = 32767
Private Const HPDF_LIMIT_MIN_REAL = -32767

Private Const HPDF_LIMIT_MAX_STRING_LEN = 65535
Private Const HPDF_LIMIT_MAX_NAME_LEN = 127

Private Const HPDF_LIMIT_MAX_ARRAY = 8191
Private Const HPDF_LIMIT_MAX_DICT_ELEMENT = 4095
Private Const HPDF_LIMIT_MAX_XREF_ELEMENT = 8388607
Private Const HPDF_LIMIT_MAX_GSTATE = 28
Private Const HPDF_LIMIT_MAX_DEVICE_N = 8
Private Const HPDF_LIMIT_MAX_DEVICE_N_V15 = 32
Private Const HPDF_LIMIT_MAX_CID = 65535
Private Const HPDF_MAX_GENERATION_NUM = 65535

Private Const HPDF_MIN_PAGE_HEIGHT = 3
Private Const HPDF_MIN_PAGE_WIDTH = 3
Private Const HPDF_MAX_PAGE_HEIGHT = 14400
Private Const HPDF_MAX_PAGE_WIDTH = 14400
Private Const HPDF_MIN_MAGNIFICATION_FACTOR = 8
Private Const HPDF_MAX_MAGNIFICATION_FACTOR = 3200

'---------------------------------------------------------------------------
'------ limitation of various properties -----------------------------------

Private Const HPDF_MIN_PAGE_SIZE = 3
Private Const HPDF_MAX_PAGE_SIZE = 14400
Private Const HPDF_MIN_HORIZONTALSCALING = 10
Private Const HPDF_MAX_HORIZONTALSCALING = 300
Private Const HPDF_MIN_WORDSPACE = -30
Private Const HPDF_MAX_WORDSPACE = 300
Private Const HPDF_MIN_CHARSPACE = -30
Private Const HPDF_MAX_CHARSPACE = 300
Private Const HPDF_MAX_FONTSIZE = 300
Private Const HPDF_MAX_ZOOMSIZE = 10
Private Const HPDF_MAX_LEADING = 300
Private Const HPDF_MAX_LINEWIDTH = 100
Private Const HPDF_MAX_DASH_PATTERN = 100

Private Const HPDF_MAX_JWW_NUM = 128

'----------------------------------------------------------------------------
'----- country code definition ----------------------------------------------

Private Const HPDF_COUNTRY_AF = "AF"    ' AFGHANISTAN
Private Const HPDF_COUNTRY_AL = "AL"    ' ALBANIA
Private Const HPDF_COUNTRY_DZ = "DZ"    ' ALGERIA
Private Const HPDF_COUNTRY_AS = "AS"    ' AMERICAN SAMOA
Private Const HPDF_COUNTRY_AD = "AD"    ' ANDORRA
Private Const HPDF_COUNTRY_AO = "AO"    ' ANGOLA
Private Const HPDF_COUNTRY_AI = "AI"    ' ANGUILLA
Private Const HPDF_COUNTRY_AQ = "AQ"    ' ANTARCTICA
Private Const HPDF_COUNTRY_AG = "AG"    ' ANTIGUA AND BARBUDA
Private Const HPDF_COUNTRY_AR = "AR"    ' ARGENTINA
Private Const HPDF_COUNTRY_AM = "AM"    ' ARMENIA
Private Const HPDF_COUNTRY_AW = "AW"    ' ARUBA
Private Const HPDF_COUNTRY_AU = "AU"    ' AUSTRALIA
Private Const HPDF_COUNTRY_AT = "AT"    ' AUSTRIA
Private Const HPDF_COUNTRY_AZ = "AZ"    ' AZERBAIJAN
Private Const HPDF_COUNTRY_BS = "BS"    ' BAHAMAS
Private Const HPDF_COUNTRY_BH = "BH"    ' BAHRAIN
Private Const HPDF_COUNTRY_BD = "BD"    ' BANGLADESH
Private Const HPDF_COUNTRY_BB = "BB"    ' BARBADOS
Private Const HPDF_COUNTRY_BY = "BY"    ' BELARUS
Private Const HPDF_COUNTRY_BE = "BE"    ' BELGIUM
Private Const HPDF_COUNTRY_BZ = "BZ"    ' BELIZE
Private Const HPDF_COUNTRY_BJ = "BJ"    ' BENIN
Private Const HPDF_COUNTRY_BM = "BM"    ' BERMUDA
Private Const HPDF_COUNTRY_BT = "BT"    ' BHUTAN
Private Const HPDF_COUNTRY_BO = "BO"    ' BOLIVIA
Private Const HPDF_COUNTRY_BA = "BA"    ' BOSNIA AND HERZEGOWINA
Private Const HPDF_COUNTRY_BW = "BW"    ' BOTSWANA
Private Const HPDF_COUNTRY_BV = "BV"    ' BOUVET ISLAND
Private Const HPDF_COUNTRY_BR = "BR"    ' BRAZIL
Private Const HPDF_COUNTRY_IO = "IO"    ' BRITISH INDIAN OCEAN TERRITORY
Private Const HPDF_COUNTRY_BN = "BN"    ' BRUNEI DARUSSALAM
Private Const HPDF_COUNTRY_BG = "BG"    ' BULGARIA
Private Const HPDF_COUNTRY_BF = "BF"    ' BURKINA FASO
Private Const HPDF_COUNTRY_BI = "BI"    ' BURUNDI
Private Const HPDF_COUNTRY_KH = "KH"    ' CAMBODIA
Private Const HPDF_COUNTRY_CM = "CM"    ' CAMEROON
Private Const HPDF_COUNTRY_CA = "CA"    ' CANADA
Private Const HPDF_COUNTRY_CV = "CV"    ' CAPE VERDE
Private Const HPDF_COUNTRY_KY = "KY"    ' CAYMAN ISLANDS
Private Const HPDF_COUNTRY_CF = "CF"    ' CENTRAL AFRICAN REPUBLIC
Private Const HPDF_COUNTRY_TD = "TD"    ' CHAD
Private Const HPDF_COUNTRY_CL = "CL"    ' CHILE
Private Const HPDF_COUNTRY_CN = "CN"    ' CHINA
Private Const HPDF_COUNTRY_CX = "CX"    ' CHRISTMAS ISLAND
Private Const HPDF_COUNTRY_CC = "CC"    ' COCOS (KEELING) ISLANDS
Private Const HPDF_COUNTRY_CO = "CO"    ' COLOMBIA
Private Const HPDF_COUNTRY_KM = "KM"    ' COMOROS
Private Const HPDF_COUNTRY_CG = "CG"    ' CONGO
Private Const HPDF_COUNTRY_CK = "CK"    ' COOK ISLANDS
Private Const HPDF_COUNTRY_CR = "CR"    ' COSTA RICA
Private Const HPDF_COUNTRY_CI = "CI"    ' COTE D'IVOIRE
Private Const HPDF_COUNTRY_HR = "HR"    ' CROATIA (local name: Hrvatska)
Private Const HPDF_COUNTRY_CU = "CU"    ' CUBA
Private Const HPDF_COUNTRY_CY = "CY"    ' CYPRUS
Private Const HPDF_COUNTRY_CZ = "CZ"    ' CZECH REPUBLIC
Private Const HPDF_COUNTRY_DK = "DK"    ' DENMARK
Private Const HPDF_COUNTRY_DJ = "DJ"    ' DJIBOUTI
Private Const HPDF_COUNTRY_DM = "DM"    ' DOMINICA
Private Const HPDF_COUNTRY_DO = "DO"    ' DOMINICAN REPUBLIC
Private Const HPDF_COUNTRY_TP = "TP"    ' EAST TIMOR
Private Const HPDF_COUNTRY_EC = "EC"    ' ECUADOR
Private Const HPDF_COUNTRY_EG = "EG"    ' EGYPT
Private Const HPDF_COUNTRY_SV = "SV"    ' EL SALVADOR
Private Const HPDF_COUNTRY_GQ = "GQ"    ' EQUATORIAL GUINEA
Private Const HPDF_COUNTRY_ER = "ER"    ' ERITREA
Private Const HPDF_COUNTRY_EE = "EE"    ' ESTONIA
Private Const HPDF_COUNTRY_ET = "ET"    ' ETHIOPIA
Private Const HPDF_COUNTRY_FK = "FK"   ' FALKLAND ISLANDS (MALVINAS)
Private Const HPDF_COUNTRY_FO = "FO"    ' FAROE ISLANDS
Private Const HPDF_COUNTRY_FJ = "FJ"    ' FIJI
Private Const HPDF_COUNTRY_FI = "FI"    ' FINLAND
Private Const HPDF_COUNTRY_FR = "FR"    ' FRANCE
Private Const HPDF_COUNTRY_FX = "FX"    ' FRANCE, METROPOLITAN
Private Const HPDF_COUNTRY_GF = "GF"    ' FRENCH GUIANA
Private Const HPDF_COUNTRY_PF = "PF"    ' FRENCH POLYNESIA
Private Const HPDF_COUNTRY_TF = "TF"    ' FRENCH SOUTHERN TERRITORIES
Private Const HPDF_COUNTRY_GA = "GA"    ' GABON
Private Const HPDF_COUNTRY_GM = "GM"    ' GAMBIA
Private Const HPDF_COUNTRY_GE = "GE"    ' GEORGIA
Private Const HPDF_COUNTRY_DE = "DE"    ' GERMANY
Private Const HPDF_COUNTRY_GH = "GH"    ' GHANA
Private Const HPDF_COUNTRY_GI = "GI"    ' GIBRALTAR
Private Const HPDF_COUNTRY_GR = "GR"    ' GREECE
Private Const HPDF_COUNTRY_GL = "GL"    ' GREENLAND
Private Const HPDF_COUNTRY_GD = "GD"    ' GRENADA
Private Const HPDF_COUNTRY_GP = "GP"    ' GUADELOUPE
Private Const HPDF_COUNTRY_GU = "GU"    ' GUAM
Private Const HPDF_COUNTRY_GT = "GT"    ' GUATEMALA
Private Const HPDF_COUNTRY_GN = "GN"    ' GUINEA
Private Const HPDF_COUNTRY_GW = "GW"    ' GUINEA-BISSAU
Private Const HPDF_COUNTRY_GY = "GY"    ' GUYANA
Private Const HPDF_COUNTRY_HT = "HT"    ' HAITI
Private Const HPDF_COUNTRY_HM = "HM"    ' HEARD AND MC DONALD ISLANDS
Private Const HPDF_COUNTRY_HN = "HN"    ' HONDURAS
Private Const HPDF_COUNTRY_HK = "HK"    ' HONG KONG
Private Const HPDF_COUNTRY_HU = "HU"    ' HUNGARY
Private Const HPDF_COUNTRY_IS = "IS"    ' ICELAND
Private Const HPDF_COUNTRY_IN = "IN"    ' INDIA
Private Const HPDF_COUNTRY_ID = "ID"    ' INDONESIA
Private Const HPDF_COUNTRY_IR = "IR"    ' IRAN (ISLAMIC REPUBLIC OF)
Private Const HPDF_COUNTRY_IQ = "IQ"    ' IRAQ
Private Const HPDF_COUNTRY_IE = "IE"    ' IRELAND
Private Const HPDF_COUNTRY_IL = "IL"    ' ISRAEL
Private Const HPDF_COUNTRY_IT = "IT"    ' ITALY
Private Const HPDF_COUNTRY_JM = "JM"    ' JAMAICA
Private Const HPDF_COUNTRY_JP = "JP"    ' JAPAN
Private Const HPDF_COUNTRY_JO = "JO"    ' JORDAN
Private Const HPDF_COUNTRY_KZ = "KZ"    ' KAZAKHSTAN
Private Const HPDF_COUNTRY_KE = "KE"    ' KENYA
Private Const HPDF_COUNTRY_KI = "KI"    ' KIRIBATI
Private Const HPDF_COUNTRY_KP = "KP"    ' KOREA, DEMOCRATIC PEOPLE'S REPUBLIC OF
Private Const HPDF_COUNTRY_KR = "KR"    ' KOREA, REPUBLIC OF
Private Const HPDF_COUNTRY_KW = "KW"    ' KUWAIT
Private Const HPDF_COUNTRY_KG = "KG"    ' KYRGYZSTAN
Private Const HPDF_COUNTRY_LA = "LA"    ' LAO PEOPLE'S DEMOCRATIC REPUBLIC
Private Const HPDF_COUNTRY_LV = "LV"    ' LATVIA
Private Const HPDF_COUNTRY_LB = "LB"    ' LEBANON
Private Const HPDF_COUNTRY_LS = "LS"    ' LESOTHO
Private Const HPDF_COUNTRY_LR = "LR"    ' LIBERIA
Private Const HPDF_COUNTRY_LY = "LY"    ' LIBYAN ARAB JAMAHIRIYA
Private Const HPDF_COUNTRY_LI = "LI"    ' LIECHTENSTEIN
Private Const HPDF_COUNTRY_LT = "LT"    ' LITHUANIA
Private Const HPDF_COUNTRY_LU = "LU"    ' LUXEMBOURG
Private Const HPDF_COUNTRY_MO = "MO"    ' MACAU
Private Const HPDF_COUNTRY_MK = "MK"    ' MACEDONIA, THE FORMER YUGOSLAV REPUBLIC OF
Private Const HPDF_COUNTRY_MG = "MG"    ' MADAGASCAR
Private Const HPDF_COUNTRY_MW = "MW"    ' MALAWI
Private Const HPDF_COUNTRY_MY = "MY"    ' MALAYSIA
Private Const HPDF_COUNTRY_MV = "MV"    ' MALDIVES
Private Const HPDF_COUNTRY_ML = "ML"    ' MALI
Private Const HPDF_COUNTRY_MT = "MT"    ' MALTA
Private Const HPDF_COUNTRY_MH = "MH"    ' MARSHALL ISLANDS
Private Const HPDF_COUNTRY_MQ = "MQ"    ' MARTINIQUE
Private Const HPDF_COUNTRY_MR = "MR"    ' MAURITANIA
Private Const HPDF_COUNTRY_MU = "MU"    ' MAURITIUS
Private Const HPDF_COUNTRY_YT = "YT"    ' MAYOTTE
Private Const HPDF_COUNTRY_MX = "MX"    ' MEXICO
Private Const HPDF_COUNTRY_FM = "FM"    ' MICRONESIA, FEDERATED STATES OF
Private Const HPDF_COUNTRY_MD = "MD"    ' MOLDOVA, REPUBLIC OF
Private Const HPDF_COUNTRY_MC = "MC"    ' MONACO
Private Const HPDF_COUNTRY_MN = "MN"    ' MONGOLIA
Private Const HPDF_COUNTRY_MS = "MS"    ' MONTSERRAT
Private Const HPDF_COUNTRY_MA = "MA"    ' MOROCCO
Private Const HPDF_COUNTRY_MZ = "MZ"    ' MOZAMBIQUE
Private Const HPDF_COUNTRY_MM = "MM"    ' MYANMAR
Private Const HPDF_COUNTRY_NA = "NA"    ' NAMIBIA
Private Const HPDF_COUNTRY_NR = "NR"    ' NAURU
Private Const HPDF_COUNTRY_NP = "NP"    ' NEPAL
Private Const HPDF_COUNTRY_NL = "NL"    ' NETHERLANDS
Private Const HPDF_COUNTRY_AN = "AN"    ' NETHERLANDS ANTILLES
Private Const HPDF_COUNTRY_NC = "NC"    ' NEW CALEDONIA
Private Const HPDF_COUNTRY_NZ = "NZ"    ' NEW ZEALAND
Private Const HPDF_COUNTRY_NI = "NI"    ' NICARAGUA
Private Const HPDF_COUNTRY_NE = "NE"    ' NIGER
Private Const HPDF_COUNTRY_NG = "NG"    ' NIGERIA
Private Const HPDF_COUNTRY_NU = "NU"    ' NIUE
Private Const HPDF_COUNTRY_NF = "NF"    ' NORFOLK ISLAND
Private Const HPDF_COUNTRY_MP = "MP"    ' NORTHERN MARIANA ISLANDS
Private Const HPDF_COUNTRY_NO = "NO"    ' NORWAY
Private Const HPDF_COUNTRY_OM = "OM"    ' OMAN
Private Const HPDF_COUNTRY_PK = "PK"    ' PAKISTAN
Private Const HPDF_COUNTRY_PW = "PW"    ' PALAU
Private Const HPDF_COUNTRY_PA = "PA"    ' PANAMA
Private Const HPDF_COUNTRY_PG = "PG"    ' PAPUA NEW GUINEA
Private Const HPDF_COUNTRY_PY = "PY"    ' PARAGUAY
Private Const HPDF_COUNTRY_PE = "PE"    ' PERU
Private Const HPDF_COUNTRY_PH = "PH"    ' PHILIPPINES
Private Const HPDF_COUNTRY_PN = "PN"    ' PITCAIRN
Private Const HPDF_COUNTRY_PL = "PL"    ' POLAND
Private Const HPDF_COUNTRY_PT = "PT"    ' PORTUGAL
Private Const HPDF_COUNTRY_PR = "PR"    ' PUERTO RICO
Private Const HPDF_COUNTRY_QA = "QA"    ' QATAR
Private Const HPDF_COUNTRY_RE = "RE"    ' REUNION
Private Const HPDF_COUNTRY_RO = "RO"    ' ROMANIA
Private Const HPDF_COUNTRY_RU = "RU"    ' RUSSIAN FEDERATION
Private Const HPDF_COUNTRY_RW = "RW"    ' RWANDA
Private Const HPDF_COUNTRY_KN = "KN"    ' SAINT KITTS AND NEVIS
Private Const HPDF_COUNTRY_LC = "LC"    ' SAINT LUCIA
Private Const HPDF_COUNTRY_VC = "VC"    ' SAINT VINCENT AND THE GRENADINES
Private Const HPDF_COUNTRY_WS = "WS"    ' SAMOA
Private Const HPDF_COUNTRY_SM = "SM"    ' SAN MARINO
Private Const HPDF_COUNTRY_ST = "ST"    ' SAO TOME AND PRINCIPE
Private Const HPDF_COUNTRY_SA = "SA"    ' SAUDI ARABIA
Private Const HPDF_COUNTRY_SN = "SN"    ' SENEGAL
Private Const HPDF_COUNTRY_SC = "SC"    ' SEYCHELLES
Private Const HPDF_COUNTRY_SL = "SL"    ' SIERRA LEONE
Private Const HPDF_COUNTRY_SG = "SG"    ' SINGAPORE
Private Const HPDF_COUNTRY_SK = "SK"    ' SLOVAKIA (Slovak REPUBLIC)
Private Const HPDF_COUNTRY_SI = "SI"    ' SLOVENIA
Private Const HPDF_COUNTRY_SB = "SB"    ' SOLOMON ISLANDS
Private Const HPDF_COUNTRY_SO = "SO"    ' SOMALIA
Private Const HPDF_COUNTRY_ZA = "ZA"    ' SOUTH AFRICA
Private Const HPDF_COUNTRY_ES = "ES"    ' SPAIN
Private Const HPDF_COUNTRY_LK = "LK"    ' SRI LANKA
Private Const HPDF_COUNTRY_SH = "SH"    ' ST. HELENA
Private Const HPDF_COUNTRY_PM = "PM"    ' ST. PIERRE AND MIQUELON
Private Const HPDF_COUNTRY_SD = "SD"    ' SUDAN
Private Const HPDF_COUNTRY_SR = "SR"    ' SURINAME
Private Const HPDF_COUNTRY_SJ = "SJ"    ' SVALBARD AND JAN MAYEN ISLANDS
Private Const HPDF_COUNTRY_SZ = "SZ"    ' SWAZILAND
Private Const HPDF_COUNTRY_SE = "SE"    ' SWEDEN
Private Const HPDF_COUNTRY_CH = "CH"    ' SWITZERLAND
Private Const HPDF_COUNTRY_SY = "SY"    ' SYRIAN ARAB REPUBLIC
Private Const HPDF_COUNTRY_TW = "TW"    ' TAIWAN
Private Const HPDF_COUNTRY_TJ = "TJ"    ' TAJIKISTAN
Private Const HPDF_COUNTRY_TZ = "TZ"    ' TANZANIA, UNITED REPUBLIC OF
Private Const HPDF_COUNTRY_TH = "TH"    ' THAILAND
Private Const HPDF_COUNTRY_TG = "TG"    ' TOGO
Private Const HPDF_COUNTRY_TK = "TK"    ' TOKELAU
Private Const HPDF_COUNTRY_TO = "TO"    ' TONGA
Private Const HPDF_COUNTRY_TT = "TT"    ' TRINIDAD AND TOBAGO
Private Const HPDF_COUNTRY_TN = "TN"    ' TUNISIA
Private Const HPDF_COUNTRY_TR = "TR"    ' TURKEY
Private Const HPDF_COUNTRY_TM = "TM"    ' TURKMENISTAN
Private Const HPDF_COUNTRY_TC = "TC"    ' TURKS AND CAICOS ISLANDS
Private Const HPDF_COUNTRY_TV = "TV"    ' TUVALU
Private Const HPDF_COUNTRY_UG = "UG"    ' UGANDA
Private Const HPDF_COUNTRY_UA = "UA"    ' UKRAINE
Private Const HPDF_COUNTRY_AE = "AE"    ' UNITED ARAB EMIRATES
Private Const HPDF_COUNTRY_GB = "GB"    ' UNITED KINGDOM
Private Const HPDF_COUNTRY_US = "US"    ' UNITED STATES
Private Const HPDF_COUNTRY_UM = "UM"    ' UNITED STATES MINOR OUTLYING ISLANDS
Private Const HPDF_COUNTRY_UY = "UY"    ' URUGUAY
Private Const HPDF_COUNTRY_UZ = "UZ"    ' UZBEKISTAN
Private Const HPDF_COUNTRY_VU = "VU"    ' VANUATU
Private Const HPDF_COUNTRY_VA = "VA"    ' VATICAN CITY STATE (HOLY SEE)
Private Const HPDF_COUNTRY_VE = "VE"    ' VENEZUELA
Private Const HPDF_COUNTRY_VN = "VN"    ' VIET NAM
Private Const HPDF_COUNTRY_VG = "VG"    ' VIRGIN ISLANDS (BRITISH)
Private Const HPDF_COUNTRY_VI = "VI"    ' VIRGIN ISLANDS (U.S.)
Private Const HPDF_COUNTRY_WF = "WF"    ' WALLIS AND FUTUNA ISLANDS
Private Const HPDF_COUNTRY_EH = "EH"    ' WESTERN SAHARA
Private Const HPDF_COUNTRY_YE = "YE"    ' YEMEN
Private Const HPDF_COUNTRY_YU = "YU"    ' YUGOSLAVIA
Private Const HPDF_COUNTRY_ZR = "ZR"    ' ZAIRE
Private Const HPDF_COUNTRY_ZM = "ZM"    ' ZAMBIA
Private Const HPDF_COUNTRY_ZW = "ZW"    ' ZIMBABWE

'----------------------------------------------------------------------------
'----- lang code definition -------------------------------------------------

Private Const HPDF_LANG_AA = "aa"       ' Afar
Private Const HPDF_LANG_AB = "ab"       ' Abkhazian
Private Const HPDF_LANG_AF = "af"       ' Afrikaans
Private Const HPDF_LANG_AM = "am"       ' Amharic
Private Const HPDF_LANG_AR = "ar"       ' Arabic
Private Const HPDF_LANG_AS = "as"       ' Assamese
Private Const HPDF_LANG_AY = "ay"       ' Aymara
Private Const HPDF_LANG_AZ = "az"       ' Azerbaijani
Private Const HPDF_LANG_BA = "ba"       ' Bashkir
Private Const HPDF_LANG_BE = "be"       ' Byelorussian
Private Const HPDF_LANG_BG = "bg"       ' Bulgarian
Private Const HPDF_LANG_BH = "bh"       ' Bihari
Private Const HPDF_LANG_BI = "bi"       ' Bislama
Private Const HPDF_LANG_BN = "bn"       ' Bengali Bangla
Private Const HPDF_LANG_BO = "bo"       ' Tibetan
Private Const HPDF_LANG_BR = "br"       ' Breton
Private Const HPDF_LANG_CA = "ca"       ' Catalan
Private Const HPDF_LANG_CO = "co"       ' Corsican
Private Const HPDF_LANG_CS = "cs"       ' Czech
Private Const HPDF_LANG_CY = "cy"       ' Welsh
Private Const HPDF_LANG_DA = "da"       ' Danish
Private Const HPDF_LANG_DE = "de"       ' German
Private Const HPDF_LANG_DZ = "dz"       ' Bhutani
Private Const HPDF_LANG_EL = "el"       ' Greek
Private Const HPDF_LANG_EN = "en"       ' English
Private Const HPDF_LANG_EO = "eo"       ' Esperanto
Private Const HPDF_LANG_ES = "es"       ' Spanish
Private Const HPDF_LANG_ET = "et"       ' Estonian
Private Const HPDF_LANG_EU = "eu"       ' Basque
Private Const HPDF_LANG_FA = "fa"       ' Persian
Private Const HPDF_LANG_FI = "fi"       ' Finnish
Private Const HPDF_LANG_FJ = "fj"       ' Fiji
Private Const HPDF_LANG_FO = "fo"       ' Faeroese
Private Const HPDF_LANG_FR = "fr"       ' French
Private Const HPDF_LANG_FY = "fy"       ' Frisian
Private Const HPDF_LANG_GA = "ga"       ' Irish
Private Const HPDF_LANG_GD = "gd"       ' Scots Gaelic
Private Const HPDF_LANG_GL = "gl"       ' Galician
Private Const HPDF_LANG_GN = "gn"       ' Guarani
Private Const HPDF_LANG_GU = "gu"       ' Gujarati
Private Const HPDF_LANG_HA = "ha"       ' Hausa
Private Const HPDF_LANG_HI = "hi"       ' Hindi
Private Const HPDF_LANG_HR = "hr"       ' Croatian
Private Const HPDF_LANG_HU = "hu"       ' Hungarian
Private Const HPDF_LANG_HY = "hy"       ' Armenian
Private Const HPDF_LANG_IA = "ia"       ' Interlingua
Private Const HPDF_LANG_IE = "ie"       ' Interlingue
Private Const HPDF_LANG_IK = "ik"       ' Inupiak
Private Const HPDF_LANG_IN = "in"       ' Indonesian
Private Const HPDF_LANG_IS = "is"       ' Icelandic
Private Const HPDF_LANG_IT = "it"       ' Italian
Private Const HPDF_LANG_IW = "iw"       ' Hebrew
Private Const HPDF_LANG_JA = "ja"       ' Japanese
Private Const HPDF_LANG_JI = "ji"       ' Yiddish
Private Const HPDF_LANG_JW = "jw"       ' Javanese
Private Const HPDF_LANG_KA = "ka"       ' Georgian
Private Const HPDF_LANG_KK = "kk"       ' Kazakh
Private Const HPDF_LANG_KL = "kl"       ' Greenlandic
Private Const HPDF_LANG_KM = "km"       ' Cambodian
Private Const HPDF_LANG_KN = "kn"       ' Kannada
Private Const HPDF_LANG_KO = "ko"       ' Korean
Private Const HPDF_LANG_KS = "ks"       ' Kashmiri
Private Const HPDF_LANG_KU = "ku"       ' Kurdish
Private Const HPDF_LANG_KY = "ky"       ' Kirghiz
Private Const HPDF_LANG_LA = "la"       ' Latin
Private Const HPDF_LANG_LN = "ln"       ' Lingala
Private Const HPDF_LANG_LO = "lo"       ' Laothian
Private Const HPDF_LANG_LT = "lt"       ' Lithuanian
Private Const HPDF_LANG_LV = "lv"       ' Latvian,Lettish
Private Const HPDF_LANG_MG = "mg"       ' Malagasy
Private Const HPDF_LANG_MI = "mi"       ' Maori
Private Const HPDF_LANG_MK = "mk"       ' Macedonian
Private Const HPDF_LANG_ML = "ml"       ' Malayalam
Private Const HPDF_LANG_MN = "mn"       ' Mongolian
Private Const HPDF_LANG_MO = "mo"       ' Moldavian
Private Const HPDF_LANG_MR = "mr"       ' Marathi
Private Const HPDF_LANG_MS = "ms"       ' Malay
Private Const HPDF_LANG_MT = "mt"       ' Maltese
Private Const HPDF_LANG_MY = "my"       ' Burmese
Private Const HPDF_LANG_NA = "na"       ' Nauru
Private Const HPDF_LANG_NE = "ne"       ' Nepali
Private Const HPDF_LANG_NL = "nl"       ' Dutch
Private Const HPDF_LANG_NO = "no"       ' Norwegian
Private Const HPDF_LANG_OC = "oc"       ' Occitan
Private Const HPDF_LANG_OM = "om"       ' (Afan)Oromo
Private Const HPDF_LANG_OR = "or"       ' Oriya
Private Const HPDF_LANG_PA = "pa"       ' Punjabi
Private Const HPDF_LANG_PL = "pl"       ' Polish
Private Const HPDF_LANG_PS = "ps"       ' Pashto,Pushto
Private Const HPDF_LANG_PT = "pt"       ' Portuguese
Private Const HPDF_LANG_QU = "qu"       ' Quechua
Private Const HPDF_LANG_RM = "rm"       ' Rhaeto-Romance
Private Const HPDF_LANG_RN = "rn"       ' Kirundi
Private Const HPDF_LANG_RO = "ro"       ' Romanian
Private Const HPDF_LANG_RU = "ru"       ' Russian
Private Const HPDF_LANG_RW = "rw"       ' Kinyarwanda
Private Const HPDF_LANG_SA = "sa"       ' Sanskrit
Private Const HPDF_LANG_SD = "sd"       ' Sindhi
Private Const HPDF_LANG_SG = "sg"       ' Sangro
Private Const HPDF_LANG_SH = "sh"       ' Serbo-Croatian
Private Const HPDF_LANG_SI = "si"       ' Singhalese
Private Const HPDF_LANG_SK = "sk"       ' Slovak
Private Const HPDF_LANG_SL = "sl"       ' Slovenian
Private Const HPDF_LANG_SM = "sm"       ' Samoan
Private Const HPDF_LANG_SN = "sn"       ' Shona
Private Const HPDF_LANG_SO = "so"       ' Somali
Private Const HPDF_LANG_SQ = "sq"       ' Albanian
Private Const HPDF_LANG_SR = "sr"       ' Serbian
Private Const HPDF_LANG_SS = "ss"       ' Siswati
Private Const HPDF_LANG_ST = "st"       ' Sesotho
Private Const HPDF_LANG_SU = "su"       ' Sundanese
Private Const HPDF_LANG_SV = "sv"       ' Swedish
Private Const HPDF_LANG_SW = "sw"       ' Swahili
Private Const HPDF_LANG_TA = "ta"       ' Tamil
Private Const HPDF_LANG_TE = "te"       ' Tegulu
Private Const HPDF_LANG_TG = "tg"       ' Tajik
Private Const HPDF_LANG_TH = "th"       ' Thai
Private Const HPDF_LANG_TI = "ti"       ' Tigrinya
Private Const HPDF_LANG_TK = "tk"       ' Turkmen
Private Const HPDF_LANG_TL = "tl"       ' Tagalog
Private Const HPDF_LANG_TN = "tn"       ' Setswanato Tonga
Private Const HPDF_LANG_TR = "tr"       ' Turkish
Private Const HPDF_LANG_TS = "ts"       ' Tsonga
Private Const HPDF_LANG_TT = "tt"       ' Tatar
Private Const HPDF_LANG_TW = "tw"       ' Twi
Private Const HPDF_LANG_UK = "uk"       ' Ukrainian
Private Const HPDF_LANG_UR = "ur"       ' Urdu
Private Const HPDF_LANG_UZ = "uz"       ' Uzbek
Private Const HPDF_LANG_VI = "vi"       ' Vietnamese
Private Const HPDF_LANG_VO = "vo"       ' Volapuk
Private Const HPDF_LANG_WO = "wo"       ' Wolof
Private Const HPDF_LANG_XH = "xh"       ' Xhosa
Private Const HPDF_LANG_YO = "yo"       ' Yoruba
Private Const HPDF_LANG_ZH = "zh"       ' Chinese
Private Const HPDF_LANG_ZU = "zu"       ' Zulu


'----------------------------------------------------------------------------
'----- Graphis mode ---------------------------------------------------------

Private Const HPDF_GMODE_PAGE_DESCRIPTION = &H1
Private Const HPDF_GMODE_PATH_OBJECT = &H2
Private Const HPDF_GMODE_TEXT_OBJECT = &H4
Private Const HPDF_GMODE_CLIPPING_PATH = &H8
Private Const HPDF_GMODE_SHADING = &H10
Private Const HPDF_GMODE_INLINE_IMAGE = &H20
Private Const HPDF_GMODE_EXTERNAL_OBJECT = &H40



Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)

Private Declare Function HPDF_GetVersion Lib "libhpdf.dll" () As String
Private Declare Function HPDF_NewEx Lib "libhpdf.dll" (ByVal user_error_fn As Long, ByVal user_alloc_fn As Long, ByVal user_free_fn As Long, ByVal mem_pool_buf_size As Long, ByVal user_data As Any) As Long
Private Declare Function HPDF_New Lib "libhpdf.dll" (ByVal user_error_fn As Long, ByVal user_data As Any) As Long
Private Declare Function HPDF_SetErrorHandler Lib "libhpdf.dll" (ByVal pdf As Long, ByVal user_error_fn As Long) As Long
Private Declare Sub HPDF_Free Lib "libhpdf.dll" (ByVal pdf As Long)
Private Declare Function HPDF_NewDoc Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Sub HPDF_FreeDoc Lib "libhpdf.dll" (ByVal pdf As Long)
Private Declare Function HPDF_HasDoc Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_FreeDocAll Lib "libhpdf.dll" (ByVal pdf As Long)
Private Declare Function HPDF_SaveToStream Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_GetStreamSize Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_ReadFromStream Lib "libhpdf.dll" (ByVal pdf As Long, ByRef byt_buf As Long, ByRef lng_size As Long) As Long
Private Declare Function HPDF_ResetStream Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_SaveToFile Lib "libhpdf.dll" (ByVal pdf As Long, ByVal file_name As String) As Long
Private Declare Function HPDF_GetError Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_GetErrorDetail Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_ResetError Lib "libhpdf.dll" (ByVal pdf As Long)
Private Declare Function HPDF_SetPagesConfiguration Lib "libhpdf.dll" (ByVal pdf As Long, ByVal page_per_pages As Long) As Long
Private Declare Function HPDF_GetPageByIndex Lib "libhpdf.dll" (ByVal pdf As Long, ByVal index As Long) As Long
'---------------------------------------------------------------------------
'---------------------------------------------------------------------------
Private Declare Function HPDF_GetPageLayout Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_SetPageLayout Lib "libhpdf.dll" (ByVal pdf As Long, ByVal Layout As Long) As Long
Private Declare Function HPDF_GetPageMode Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_SetPageMode Lib "libhpdf.dll" (ByVal pdf As Long, ByVal page_mode As Long) As Long
Private Declare Function HPDF_GetViewerPreference Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_SetViewerPreference Lib "libhpdf.dll" (ByVal pdf As Long, ByVal value As Long) As Long
Private Declare Function HPDF_SetOpenAction Lib "libhpdf.dll" (ByVal pdf As Long, ByVal open_action As Long) As Long
'---------------------------------------------------------------------------
'----- page handling -------------------------------------------------------
Private Declare Function HPDF_GetCurrentPage Lib "libhpdf.dll" (pdf As Long) As Long
Private Declare Function HPDF_AddPage Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_InsertPage Lib "libhpdf.dll" (pdf As Long, Page As Long) As Long
Private Declare Function HPDF_Page_SetWidth Lib "libhpdf.dll" (Page As Long, value As Single) As Long
Private Declare Function HPDF_Page_SetHeight Lib "libhpdf.dll" (Page As Long, value As Single) As Long
Private Declare Function HPDF_Page_SetSize Lib "libhpdf.dll" (Page As Long, ByVal Size As Long, direction As Long) As Long
Private Declare Function HPDF_Page_SetRotate Lib "libhpdf.dll" (ByVal Page As Long, ByVal angle As Integer) As Long
'---------------------------------------------------------------------------
'----- font handling -------------------------------------------------------
Private Declare Function HPDF_GetFont Lib "libhpdf.dll" (ByVal pdf As Long, ByVal font_name As String, ByVal encoding_name As String) As Long
Private Declare Function HPDF_LoadType1FontFromFile Lib "libhpdf.dll" (ByVal pdf As Long, ByVal afm_file_name As String, ByVal data_file_name As String) As String
Private Declare Function HPDF_LoadTTFontFromFile Lib "libhpdf.dll" (ByVal pdf As Long, ByVal file_name As String, ByVal embedding As Long) As String
Private Declare Function HPDF_LoadTTFontFromFile2 Lib "libhpdf.dll" (ByVal pdf As Long, ByVal file_name As String, ByVal index As Long, ByVal embedding As Long) As String
Private Declare Function HPDF_AddPageLabel Lib "libhpdf.dll" (ByVal pdf As Long, ByVal page_num As Long, ByVal style As Long, ByVal first_page As Long, ByVal prefix As String) As Long
Private Declare Function HPDF_UseJPFonts Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_UseKRFonts Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_UseCNSFonts Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_UseCNTFonts Lib "libhpdf.dll" (ByVal pdf As Long) As Long
'--------------------------------------------------------------------------
'----- outline ------------------------------------------------------------
Private Declare Function HPDF_CreateOutline Lib "libhpdf.dll" (ByVal pdf As Long, parent As Long, ByVal title As String, encoder As Long) As Long
Private Declare Function HPDF_Outline_SetOpened Lib "libhpdf.dll" (outline As Long, ByVal opened As Long) As Long
Private Declare Function HPDF_Outline_SetDestination Lib "libhpdf.dll" (outline As Long, dst As Long) As Long
'--------------------------------------------------------------------------
'----- destination --------------------------------------------------------
Private Declare Function HPDF_Page_CreateDestination Lib "libhpdf.dll" (ByVal Page As Long) As Long
Private Declare Function HPDF_Destination_SetXYZ Lib "libhpdf.dll" (dst As Long, ByVal Left As Single, ByVal top As Single, ByVal zoom As Single) As Long
Private Declare Function HPDF_Destination_SetFit Lib "libhpdf.dll" (dst As Long) As Long
Private Declare Function HPDF_Destination_SetFitH Lib "libhpdf.dll" (dst As Long, ByVal top As Single) As Long
Private Declare Function HPDF_Destination_SetFitV Lib "libhpdf.dll" (dst As Long, ByVal Left As Single) As Long
Private Declare Function HPDF_Destination_SetFitR Lib "libhpdf.dll" (dst As Long, ByVal Left As Single, ByVal bottom As Single, ByVal Right As Single, ByVal top As Single) As Long
Private Declare Function HPDF_Destination_SetFitB Lib "libhpdf.dll" (dst As Long) As Long
Private Declare Function HPDF_Destination_SetFitBH Lib "libhpdf.dll" (dst As Long, ByVal top As Single) As Long
Private Declare Function HPDF_Destination_SetFitBV Lib "libhpdf.dll" (dst As Long, ByVal Left As Single) As Long
'--------------------------------------------------------------------------
'----- encoder ------------------------------------------------------------
Private Declare Function HPDF_GetEncoder Lib "libhpdf.dll" (ByVal pdf As Long, ByVal encoding_name As String) As Long
Private Declare Function HPDF_GetCurrentEncoder Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_SetCurrentEncoder Lib "libhpdf.dll" (ByVal pdf As Long, ByVal encoding_name As String) As Long
Private Declare Function HPDF_Encoder_GetType Lib "libhpdf.dll" (encoder As Long) As Long
Private Declare Function HPDF_Encoder_GetByteType Lib "libhpdf.dll" (encoder As Long, ByVal text As String, ByVal index As Long) As Byte
Private Declare Function HPDF_Encoder_GetUnicode Lib "libhpdf.dll" (encoder As Long, ByVal code As Integer) As Integer
Private Declare Function HPDF_Encoder_GetWritingMode Lib "libhpdf.dll" (encoder As Long) As Long
Private Declare Function HPDF_UseJPEncodings Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_UseKREncodings Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_UseCNSEncodings Lib "libhpdf.dll" (ByVal pdf As Long) As Long
Private Declare Function HPDF_UseCNTEncodings Lib "libhpdf.dll" (ByVal pdf As Long) As Long
'--------------------------------------------------------------------------
'----- annotation ---------------------------------------------------------
Private Declare Function HPDF_Page_CreateTextAnnot Lib "libhpdf.dll" (ByVal Page As Long, rect As HPDF_Rect, ByVal text As String, ByVal encoder As Long) As Long
Private Declare Function HPDF_Page_CreateLinkAnnot Lib "libhpdf.dll" (ByVal Page As Long, rect As HPDF_Rect, ByVal dst As Long) As Long
Private Declare Function HPDF_Page_CreateURILinkAnnot Lib "libhpdf.dll" (ByVal Page As Long, ByVal rect As HPDF_Rect, ByVal uri As String) As Long
Private Declare Function HPDF_LinkAnnot_SetHighlightMode Lib "libhpdf.dll" (ByVal annot As Long, mode As HPDF_AnnotHighlightMode) As Long
Private Declare Function HPDF_LinkAnnot_SetBorderStyle Lib "libhpdf.dll" (ByVal annot As Long, ByVal width As Single, ByVal dash_on As Integer, ByVal dash_off As Integer) As Long
Private Declare Function HPDF_TextAnnot_SetIcon Lib "libhpdf.dll" (ByVal annot As Long, ByVal icon As HPDF_AnnotIcon) As Long
Private Declare Function HPDF_TextAnnot_SetOpened Lib "libhpdf.dll" (ByVal annot As Long, ByVal opened As Long) As Long
'--------------------------------------------------------------------------
'----- image data ---------------------------------------------------------
Private Declare Function HPDF_LoadPngImageFromFile Lib "libhpdf.dll" (ByVal pdf As Long, ByVal FileName As String) As Long
Private Declare Function HPDF_LoadPngImageFromFile2 Lib "libhpdf.dll" (ByVal pdf As Long, ByVal FileName As String) As Long
Private Declare Function HPDF_LoadJpegImageFromFile Lib "libhpdf.dll" (ByVal pdf As Long, ByVal FileName As String) As Long
Private Declare Function HPDF_LoadRawImageFromFile Lib "libhpdf.dll" (ByVal pdf As Long, ByVal FileName As String, ByVal width As Long, ByVal height As Long, ByVal color_space As HPDF_ColorSpace) As Long
Private Declare Function HPDF_LoadRawImageFromMem Lib "libhpdf.dll" (ByVal pdf As Long, ByRef buf As Byte, ByVal width As Long, ByVal height As Long, ByVal color_space As HPDF_ColorSpace, ByVal bits_per_component As Long) As Long
Private Declare Function HPDF_Image_GetSize Lib "libhpdf.dll" (ByVal image As Long) As Long
Private Declare Function HPDF_Image_GetWidth Lib "libhpdf.dll" (ByVal image As Long) As Long
Private Declare Function HPDF_Image_GetHeight Lib "libhpdf.dll" (ByVal image As Long) As Long
Private Declare Function HPDF_Image_GetBitsPerComponent Lib "libhpdf.dll" (ByVal image As Long) As Long
Private Declare Function HPDF_Image_GetColorSpace Lib "libhpdf.dll" (ByVal image As Long) As String
Private Declare Function HPDF_Image_SetColorMask Lib "libhpdf.dll" (ByVal image As Long, ByVal rmin As Long, ByVal rmax As Long, ByVal gmin As Long, ByVal gmax As Long, ByVal bmin As Long, ByVal bmax As Long) As Long
Private Declare Function HPDF_Image_SetMaskImage Lib "libhpdf.dll" (ByVal image As Long, ByVal mask_image As Long) As Long
'--------------------------------------------------------------------------
'----- info dictionary ----------------------------------------------------
Private Declare Function HPDF_SetInfoAttr Lib "libhpdf.dll" (ByVal pdf As Long, type0 As HPDF_InfoType, ByRef value As Long) As Long
Private Declare Function HPDF_GetInfoAttr Lib "libhpdf.dll" (ByVal pdf As Long, type0 As HPDF_InfoType) As String
Private Declare Function HPDF_SetInfoDateAttr Lib "libhpdf.dll" (ByVal pdf As Long, type0 As HPDF_InfoType, value As HPDF_Date) As Long
'--------------------------------------------------------------------------
'----- encryption ---------------------------------------------------------
Private Declare Function HPDF_SetPassword Lib "libhpdf.dll" (ByVal pdf As Long, ByVal owner_passwd As String, ByVal user_passwd As String) As Long
Private Declare Function HPDF_SetPermission Lib "libhpdf.dll" (ByVal pdf As Long, ByVal permission As Long) As Long
Private Declare Function HPDF_SetEncryptionMode Lib "libhpdf.dll" (ByVal pdf As Long, mode As HPDF_EncryptMode, ByVal key_len As Long) As Long
'--------------------------------------------------------------------------
'----- compression --------------------------------------------------------
Private Declare Function HPDF_SetCompressionMode Lib "libhpdf.dll" (ByVal pdf As Long, ByVal mode As Long) As Long
'--------------------------------------------------------------------------
'--------------------------------------------------------------------------
Private Declare Function HPDF_Font_GetFontName Lib "libhpdf.dll" (ByVal font As Long) As String
Private Declare Function HPDF_Font_GetEncodingName Lib "libhpdf.dll" (ByVal font As Long) As String
Private Declare Function HPDF_Font_GetUnicodeWidth Lib "libhpdf.dll" (ByVal font As Long, code As Long) As Long
Private Declare Function HPDF_Font_GetBBox Lib "libhpdf.dll" (ByVal font As Long) As HPDF_Box
Private Declare Function HPDF_Font_GetAscent Lib "libhpdf.dll" (ByVal font As Long) As Long
Private Declare Function HPDF_Font_GetDescent Lib "libhpdf.dll" (ByVal font As Long) As Long
Private Declare Function HPDF_Font_GetXHeight Lib "libhpdf.dll" (ByVal font As Long) As Long
Private Declare Function HPDF_Font_GetCapHeight Lib "libhpdf.dll" (ByVal font As Long) As Long
Private Declare Function HPDF_Font_TextWidth Lib "libhpdf.dll" (ByVal font As Long, ByVal text As Byte, ByRef Length As Long) As Single
Private Declare Function HPDF_Font_MeasureText Lib "libhpdf.dll" (ByVal font As Long, ByVal text As Byte, ByVal Length As Long, ByVal width As Single, ByVal font_size As Single, ByVal char_space As Single, ByVal word_space As Single, ByVal wordwrap As Long, ByVal real_width As Single) As Long
'--------------------------------------------------------------------------
'--------------------------------------------------------------------------
Private Declare Function HPDF_Page_TextWidth Lib "libhpdf.dll" (ByVal Page As Long, ByVal text As String) As Single
Private Declare Function HPDF_Page_MeasureText Lib "libhpdf.dll" (ByVal Page As Long, ByVal text As String, ByVal width As Single, ByVal wordwrap As Long, ByVal real_width As Single) As Long
Private Declare Function HPDF_Page_GetWidth Lib "libhpdf.dll" (ByVal Page As Long) As Single
Private Declare Function HPDF_Page_GetHeight Lib "libhpdf.dll" (ByVal Page As Long) As Single
Private Declare Function HPDF_Page_GetGMode Lib "libhpdf.dll" (ByVal Page As Long) As Integer
Private Declare Function HPDF_Page_GetCurrentPos Lib "libhpdf.dll" (ByVal Page As Long) As HPDF_Point
Private Declare Function HPDF_Page_GetCurrentTextPos Lib "libhpdf.dll" (ByVal Page As Long) As HPDF_Point
Private Declare Function HPDF_Page_GetCurrentFont Lib "libhpdf.dll" (ByVal Page As Long) As Long
Private Declare Function HPDF_Page_GetCurrentFontSize Lib "libhpdf.dll" (ByVal Page As Long) As Single
Private Declare Function HPDF_Page_GetTransMatrix Lib "libhpdf.dll" (ByVal Page As Long) As HPDF_TransMatrix
Private Declare Function HPDF_Page_GetLineWidth Lib "libhpdf.dll" (ByVal Page As Long) As Single
Private Declare Function HPDF_Page_GetLineCap Lib "libhpdf.dll" (ByVal Page As Long) As HPDF_LineCap
Private Declare Function HPDF_Page_GetLineJoin Lib "libhpdf.dll" (ByVal Page As Long) As HPDF_LineJoin
Private Declare Function HPDF_Page_GetMiterLimit Lib "libhpdf.dll" (ByVal Page As Long) As Single
Private Declare Function HPDF_Page_GetDash Lib "libhpdf.dll" (ByVal Page As Long) As HPDF_DashMode
Private Declare Function HPDF_Page_GetFlat Lib "libhpdf.dll" (ByVal Page As Long) As Single
Private Declare Function HPDF_Page_GetCharSpace Lib "libhpdf.dll" (ByVal Page As Long) As Single
Private Declare Function HPDF_Page_GetWordSpace Lib "libhpdf.dll" (ByVal Page As Long) As Single
Private Declare Function HPDF_Page_GetHorizontalScalling Lib "libhpdf.dll" (ByVal Page As Long) As Single
Private Declare Function HPDF_Page_GetTextLeading Lib "libhpdf.dll" (ByVal Page As Long) As Single
Private Declare Function HPDF_Page_GetTextRenderingMode Lib "libhpdf.dll" (ByVal Page As Long) As HPDF_TextRenderingMode
' This function is obsolete. Use HPDF_Page_GetTextRise.  */
Private Declare Function HPDF_Page_GetTextRaise Lib "libhpdf.dll" (ByVal Page As Long) As Single
Private Declare Function HPDF_Page_GetTextRise Lib "libhpdf.dll" (ByVal Page As Long) As Single
Private Declare Function HPDF_Page_GetRGBFill Lib "libhpdf.dll" (ByVal Page As Long) As HPDF_RGBColor
Private Declare Function HPDF_Page_GetRGBStroke Lib "libhpdf.dll" (ByVal Page As Long) As HPDF_RGBColor
Private Declare Function HPDF_Page_GetCMYKFill Lib "libhpdf.dll" (ByVal Page As Long) As HPDF_CMYKColor
Private Declare Function HPDF_Page_GetCMYKStroke Lib "libhpdf.dll" (ByVal Page As Long) As HPDF_CMYKColor
Private Declare Function HPDF_Page_GetGrayFill Lib "libhpdf.dll" (ByVal Page As Long) As Single
Private Declare Function HPDF_Page_GetGrayStroke Lib "libhpdf.dll" (ByVal Page As Long) As Single
Private Declare Function HPDF_Page_GetStrokingColorSpace Lib "libhpdf.dll" (ByVal Page As Long) As HPDF_ColorSpace
Private Declare Function HPDF_Page_GetFillingColorSpace Lib "libhpdf.dll" (ByVal Page As Long) As HPDF_ColorSpace
Private Declare Function HPDF_Page_GetTextMatrix Lib "libhpdf.dll" (ByVal Page As Long) As HPDF_TransMatrix
Private Declare Function HPDF_Page_GetGStateDepth Lib "libhpdf.dll" (ByVal Page As Long) As Long
'--------------------------------------------------------------------------
'----- GRAPHICS OPERATORS -------------------------------------------------
'--- General graphics state ---------------------------------------------
' w */
Private Declare Function HPDF_Page_SetLineWidth Lib "libhpdf.dll" (ByVal Page As Long, ByVal line_width As Single) As Long
' J */
Private Declare Function HPDF_Page_SetLineCap Lib "libhpdf.dll" (ByVal Page As Long, ByVal line_cap As HPDF_LineCap) As Long
' j */
Private Declare Function HPDF_Page_SetLineJoin Lib "libhpdf.dll" (ByVal Page As Long, ByVal line_join As HPDF_LineJoin) As Long
' M */
Private Declare Function HPDF_Page_SetMiterLimit Lib "libhpdf.dll" (ByVal Page As Long, ByVal miter_limit As Single) As Long
' d */
Private Declare Function HPDF_Page_SetDash Lib "libhpdf.dll" (ByVal Page As Long, ByRef dash_ptn As Long, ByVal num_param As Long, ByVal phase As Long) As Long
' ri --not implemented yet */
' i */
Private Declare Function HPDF_Page_SetFlat Lib "libhpdf.dll" (ByVal Page As Long, ByVal flatness As Single) As Long
' gs --not implemented yet */
'--- Special graphic state operator --------------------------------------
' q */
Private Declare Function HPDF_Page_GSave Lib "libhpdf.dll" (ByVal Page As Long) As Long
' Q */
Private Declare Function HPDF_Page_GRestore Lib "libhpdf.dll" (ByVal Page As Long) As Long
' cm */
Private Declare Function HPDF_Page_Concat Lib "libhpdf.dll" (ByVal Page As Long, ByVal a As Single, ByVal b As Single, ByVal c As Single, ByVal D As Single, ByVal x As Single, ByVal y As Single) As Long
'--- Path construction operator ------------------------------------------
' m */
Private Declare Function HPDF_Page_MoveTo Lib "libhpdf.dll" (ByVal Page As Long, ByVal x As Single, ByVal y As Single) As Long
' l */
Private Declare Function HPDF_Page_LineTo Lib "libhpdf.dll" (ByVal Page As Long, ByVal x As Single, ByVal y As Single) As Long
' c */
Private Declare Function HPDF_Page_CurveTo Lib "libhpdf.dll" (ByVal Page As Long, ByVal x1 As Single, ByVal y1 As Single, ByVal x2 As Single, ByVal y2 As Single, ByVal x3 As Single, ByVal y3 As Single) As Long
' v */
Private Declare Function HPDF_Page_CurveTo2 Lib "libhpdf.dll" (ByVal Page As Long, ByVal x2 As Single, ByVal y2 As Single, ByVal x3 As Single, ByVal y3 As Single) As Long
' y */
Private Declare Function HPDF_Page_CurveTo3 Lib "libhpdf.dll" (ByVal Page As Long, ByVal x1 As Single, ByVal y1 As Single, ByVal x3 As Single, ByVal y3 As Single) As Long
' h */
Private Declare Function HPDF_Page_ClosePath Lib "libhpdf.dll" (ByVal Page As Long) As Long
' re */
Private Declare Function HPDF_Page_Rectangle Lib "libhpdf.dll" (ByVal Page As Long, ByVal x As Single, ByVal y As Single, ByVal width As Single, ByVal height As Single) As Long
'--- Path painting operator ---------------------------------------------
' S */
Private Declare Function HPDF_Page_Stroke Lib "libhpdf.dll" (ByVal Page As Long) As Long
' s */
Private Declare Function HPDF_Page_ClosePathStroke Lib "libhpdf.dll" (ByVal Page As Long) As Long
' f */
Private Declare Function HPDF_Page_Fill Lib "libhpdf.dll" (ByVal Page As Long) As Long
' f* */
Private Declare Function HPDF_Page_Eofill Lib "libhpdf.dll" (ByVal Page As Long) As Long
' B */
Private Declare Function HPDF_Page_FillStroke Lib "libhpdf.dll" (ByVal Page As Long) As Long
' B* */
Private Declare Function HPDF_Page_EofillStroke Lib "libhpdf.dll" (ByVal Page As Long) As Long
' b */
Private Declare Function HPDF_Page_ClosePathFillStroke Lib "libhpdf.dll" (ByVal Page As Long) As Long
' b* */
Private Declare Function HPDF_Page_ClosePathEofillStroke Lib "libhpdf.dll" (ByVal Page As Long) As Long
' n */
Private Declare Function HPDF_Page_EndPath Lib "libhpdf.dll" (ByVal Page As Long) As Long
'--- Clipping paths operator --------------------------------------------
' W */
Private Declare Function HPDF_Page_Clip Lib "libhpdf.dll" (ByVal Page As Long) As Long
' W* */
Private Declare Function HPDF_Page_Eoclip Lib "libhpdf.dll" (ByVal Page As Long) As Long
'--- Text object operator -----------------------------------------------
' BT */
Private Declare Function HPDF_Page_BeginText Lib "libhpdf.dll" (ByVal Page As Long) As Long
' ET */
Private Declare Function HPDF_Page_EndText Lib "libhpdf.dll" (ByVal Page As Long) As Long
'--- Text state ---------------------------------------------------------
' Tc */
Private Declare Function HPDF_Page_SetCharSpace Lib "libhpdf.dll" (ByVal Page As Long, ByVal value As Single) As Long
' Tw */
Private Declare Function HPDF_Page_SetWordSpace Lib "libhpdf.dll" (ByVal Page As Long, ByVal value As Single) As Long
' Tz */
Private Declare Function HPDF_Page_SetHorizontalScalling Lib "libhpdf.dll" (ByVal Page As Long, ByVal value As Single) As Long
' TL */
Private Declare Function HPDF_Page_SetTextLeading Lib "libhpdf.dll" (ByVal Page As Long, ByVal value As Single) As Long
' Tf */
Private Declare Function HPDF_Page_SetFontAndSize Lib "libhpdf.dll" (ByVal Page As Long, ByVal font As Long, ByVal Size As Single) As Long
' Tr */
Private Declare Function HPDF_Page_SetTextRenderingMode Lib "libhpdf.dll" (ByVal Page As Long, ByVal mode As HPDF_TextRenderingMode) As Long
' Ts */
Private Declare Function HPDF_Page_SetTextRise Lib "libhpdf.dll" (ByVal Page As Long, ByVal value As Single) As Long
' This function is obsolete. Use HPDF_Page_SetTextRise.  */
Private Declare Function HPDF_Page_SetTextRaise Lib "libhpdf.dll" (ByVal Page As Long, ByVal value As Single) As Long
'--- Text positioning ---------------------------------------------------
' Td */
Private Declare Function HPDF_Page_MoveTextPos Lib "libhpdf.dll" (ByVal Page As Long, ByVal x As Single, ByVal y As Single) As Long
' TD */
Private Declare Function HPDF_Page_MoveTextPos2 Lib "libhpdf.dll" (ByVal Page As Long, ByVal x As Single, ByVal y As Single) As Long
' Tm */
Private Declare Function HPDF_Page_SetTextMatrix Lib "libhpdf.dll" (ByVal Page As Long, ByVal a As Single, ByVal b As Single, ByVal c As Single, ByVal D As Single, ByVal x As Single, ByVal y As Single) As Long
' T* */
Private Declare Function HPDF_Page_MoveToNextLine Lib "libhpdf.dll" (ByVal Page As Long) As Long
'--- Text showing -------------------------------------------------------
' Tj */
Private Declare Function HPDF_Page_ShowText Lib "libhpdf.dll" (ByVal Page As Long, ByVal text As String) As Long
' TJ */
' ' */
Private Declare Function HPDF_Page_ShowTextNextLine Lib "libhpdf.dll" (ByVal Page As Long, ByVal text As String) As Long
' " */
Private Declare Function HPDF_Page_ShowTextNextLineEx Lib "libhpdf.dll" (ByVal Page As Long, ByVal word_space As Single, ByVal char_space As Single, ByVal text As String) As Long
'--- Color showing ------------------------------------------------------

' cs --not implemented yet */
' CS --not implemented yet */
' sc --not implemented yet */
' scn --not implemented yet */
' SC --not implemented yet */
' SCN --not implemented yet */

' g */
Private Declare Function HPDF_Page_SetGrayFill Lib "libhpdf.dll" (ByVal Page As Long, ByVal gray As Single) As Long
' G */
Private Declare Function HPDF_Page_SetGrayStroke Lib "libhpdf.dll" (ByVal Page As Long, ByVal gray As Single) As Long
' rg */
Private Declare Function HPDF_Page_SetRGBFill Lib "libhpdf.dll" (ByVal Page As Long, ByVal r As Single, ByVal g As Single, ByVal b As Single) As Long
' RG */
Private Declare Function HPDF_Page_SetRGBStroke Lib "libhpdf.dll" (ByVal Page As Long, ByVal r As Single, ByVal g As Single, ByVal b As Single) As Long
' k */
Private Declare Function HPDF_Page_SetCMYKFill Lib "libhpdf.dll" (ByVal Page As Long, ByVal c As Single, ByVal m As Single, ByVal y As Single, ByVal k As Single) As Long
' K */
Private Declare Function HPDF_Page_SetCMYKStroke Lib "libhpdf.dll" (ByVal Page As Long, ByVal c As Single, ByVal m As Single, ByVal y As Single, ByVal k As Single) As Long
'--- Shading patterns ---------------------------------------------------
' sh --not implemented yet */
'--- In-line images -----------------------------------------------------
' BI --not implemented yet */
' ID --not implemented yet */
' EI --not implemented yet */
'--- XObjects -----------------------------------------------------------
' Do */
Private Declare Function HPDF_Page_ExecuteXObject Lib "libhpdf.dll" (ByVal Page As Long, Obj As Long) As Long
'--- Marked content -----------------------------------------------------
' BMC --not implemented yet */
' BDC --not implemented yet */
' EMC --not implemented yet */
' MP --not implemented yet */
' DP --not implemented yet */
'--- Compatibility ------------------------------------------------------
' BX --not implemented yet */
' EX --not implemented yet */
Private Declare Function HPDF_Page_DrawImage Lib "libhpdf.dll" (ByVal Page As Long, ByVal image As Long, ByVal x As Single, ByVal y As Single, ByVal width As Single, ByVal height As Single) As Long
Private Declare Function HPDF_Page_Circle Lib "libhpdf.dll" (ByVal Page As Long, ByVal x As Single, ByVal y As Single, ByVal ray As Single) As Long
Private Declare Function HPDF_Page_Ellipse Lib "libhpdf.dll" (ByVal Page As Long, ByVal x As Single, ByVal y As Single, ByVal xray As Single, ByVal yray As Single) As Long
Private Declare Function HPDF_Page_Arc Lib "libhpdf.dll" (ByVal Page As Long, ByVal x As Single, ByVal y As Single, ByVal ray As Single, ByVal ang1 As Single, ByVal ang2 As Single) As Long
Private Declare Function HPDF_Page_TextOut Lib "libhpdf.dll" (ByVal Page As Long, ByVal xpos As Single, ByVal ypos As Single, ByVal text As String) As Long
Private Declare Function HPDF_Page_TextRect Lib "libhpdf.dll" (ByVal Page As Long, ByVal Left As Single, ByVal top As Single, ByVal Right As Single, ByVal bottom As Single, ByVal text As String, ByVal align As Long, ByRef Length As Long) As Long


'Private variable declarations

Private bmSize As Long
Private bmBits() As Byte
Private Cpath As String

'API declarations
Private Declare Function GetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, ByRef lpBits As Any) As Long
Private Declare Function SetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, ByRef lpBits As Any) As Long




Public Sub CreatePDF(ByVal PictureDPF As PictureBox, _
ByVal Fname As String, _
Optional ByVal x As Long = 0, _
Optional ByVal y As Long = 0)
    

    Dim pdf         As Long
    Dim font        As Long
    Dim Page        As Long
    Dim image       As Long


    If Left(LCase(Fname), 3) <> "pdf" Then Fname = Fname + ".PDF"
    
    'fname = App.Path & IIf(Right(App.Path, 1) = "\", "", "\") & fname
    
    'pdf = HPDF_New(AddressOf error_handler, ByVal vbNullString)
    
    pdf = HPDF_New(vbNull, vbNullString)
    
    If pdf = 0 Then
        'printf ("error: cannot create PdfDoc object\n")
        Exit Sub
    End If

    ' set compression mode
    Call HPDF_SetCompressionMode(pdf, HPDF_COMP_ALL)
    Call HPDF_UseJPEncodings(pdf)
 

    ' add a new page object.
    Page = HPDF_AddPage(pdf)
    Hpdf_PaintPicture pdf, Page, PictureDPF, x, y

   
    ' save the document to a file
    Call HPDF_SaveToFile(pdf, ByVal Fname)

    ' clean up
    Call HPDF_Free(pdf)

End Sub

Public Sub CreatePngPDF(ByVal picture As PictureBox, _
ByVal Fname As String, _
Optional ByVal x As Long = 0, _
Optional ByVal y As Long = 0, _
Optional ByVal NbPage = 1)
    

    Dim pdf         As Long
    Dim font        As Long
    Dim Page        As Long
    Dim image       As Long
    Dim Cnt         As Long
    
    Dim TmpFile As String
    
TmpFile = App.path & "\tmp.png"


    
    
    'pdf = HPDF_New(AddressOf error_handler, ByVal vbNullString)
    
    pdf = HPDF_New(vbNull, vbNullString)
    
    If pdf = 0 Then
        'printf ("error: cannot create PdfDoc object\n")
        Exit Sub
    End If

    ' set compression mode
    Call HPDF_SetCompressionMode(pdf, HPDF_COMP_ALL)
    Call HPDF_UseJPEncodings(pdf)
 
If NbPage = 1 Then

            PicSaveLoad.SavePicture picture, TmpFile, fmtPNG
            DoEvents
            
        Cnt = 0
        Do While Dir(TmpFile) = "" And Cnt < 32000
        Cnt = Cnt + 0.5
        Loop
        
        ' add a new page object.
        Page = HPDF_AddPage(pdf)
        image = HPDF_LoadPngImageFromFile(pdf, TmpFile)
        Call HPDF_Page_DrawImage(Page, image, 0, 0, HPDF_Page_GetWidth(Page), HPDF_Page_GetHeight(Page))
        
        Kill (TmpFile)
        
 Else
        For t = 0 To NbPage - 1
             
             Page_Footer = "Page " & t + 1
             FrmMultiCols.ClsPicture
             FrmMultiCols.Refresh_Title
             FrmMultiCols.draw (t + 1)
             FrmMultiCols.Refresh_page
            
           
             DoEvents
             PicSaveLoad.SavePicture FrmMultiCols.Page(0), TmpFile, fmtPNG
            DoEvents
            
        Cnt = 0
        Do While Dir(TmpFile) = "" And Cnt < 32000
        Cnt = Cnt + 0.5
        Loop
        
        ' add a new page object.
        Page = HPDF_AddPage(pdf)
        image = HPDF_LoadPngImageFromFile(pdf, TmpFile)
        Call HPDF_Page_DrawImage(Page, image, 0, 0, HPDF_Page_GetWidth(Page), HPDF_Page_GetHeight(Page))
        
        If Dir(TmpFile) <> "" Then Kill (TmpFile)
        Next t
 
 End If
 
 
    ' save the document to a file
    Call HPDF_SaveToFile(pdf, ByVal Fname)

    ' clean up
    Call HPDF_Free(pdf)
    

    reset

End Sub
Private Sub Hpdf_PaintPicture(pdf As Long, Page As Long, myPictureBox As PictureBox, LocX As Long, LocY As Long)
    
    Static bmWidth As Long
    Static bmHeight As Long
    
    Dim image As Long
    
    'Get picture's Width and Height
    bmWidth = myPictureBox.ScaleWidth
    bmHeight = myPictureBox.ScaleHeight
       
    'ReDefine Bit array to hold all pixels from picture box
    ReDim Bits(0 To 3, 0 To bmWidth - 1, 0 To bmHeight - 1) As Byte
 
    'Store size of bitmap in total pixels
    bmSize = bmWidth * bmHeight
 
    'Grab picture's pixels and load to Bit array
    GetBitmapBits myPictureBox.image, bmSize * 4, Bits(0, 0, 0)
  
    ReDim bitstmp((bmSize * 3) - 1) As Byte
    
a = 0
 For y = 0 To bmHeight - 1
    For x = 0 To bmWidth - 1
        bitstmp(a) = Bits(2, x, y)
        bitstmp(a + 1) = Bits(1, x, y)
        bitstmp(a + 2) = Bits(0, x, y)
        a = a + 3
    Next
 Next
 
 image = HPDF_LoadRawImageFromMem(pdf, bitstmp(0), bmWidth, bmHeight, HPDF_CS_DEVICE_RGB, 8)
 
 ' draw grid to the page
 'Call Print_Grid(pdf, page)
 
 Call HPDF_Page_DrawImage(Page, image, LocX, LocY, bmWidth, bmHeight)

End Sub

Private Function Show_Description(ByVal Page As Long, ByVal x As Single, ByVal y As Single, ByVal text As String) As Long
    Dim fsize           As Single
    Dim font            As Long
    Dim c               As HPDF_RGBColor
    fsize = HPDF_Page_GetCurrentFontSize(Page)
    font = HPDF_Page_GetCurrentFont(Page)
    c = HPDF_Page_GetRGBFill(Page)
    Call HPDF_Page_BeginText(Page)
    Call HPDF_Page_SetRGBFill(Page, 0, 0, 0)
    Call HPDF_Page_SetTextRenderingMode(Page, HPDF_FILL)
    Call HPDF_Page_SetFontAndSize(Page, font, 10)
    Call HPDF_Page_TextOut(Page, x, y - 12, ByVal text)
    Call HPDF_Page_EndText(Page)
    Call HPDF_Page_SetFontAndSize(Page, font, fsize)
    Call HPDF_Page_SetRGBFill(Page, c.r, c.g, c.b)
End Function

Private Sub Print_Grid(ByVal pdf As Long, ByVal Page As Long)
         
         Dim sTemp1  As String
         Dim height As Long
         Dim width As Long
         Dim font As Long
         Dim y As Long
         Dim x As Long
         Dim buf     As String * 12
         
         height = HPDF_Page_GetHeight(Page)
         width = HPDF_Page_GetWidth(Page)
         
             ' create default-font
    sTemp1 = "Helvetica" '& Chr(0)
    font = HPDF_GetFont(pdf, ByVal sTemp1, ByVal vbNullString)
         
         font = HPDF_GetFont(pdf, ByVal "Helvetica", ByVal vbNullString)
         
         Call HPDF_Page_SetFontAndSize(Page, font, 5)
         Call HPDF_Page_SetGrayFill(Page, 0.5)
         Call HPDF_Page_SetGrayStroke(Page, 0.8)
         
         y = 0
         
         Do While (y < height)
             If ((y Mod 10) = 0) Then
                 Call HPDF_Page_SetLineWidth(Page, 0.5)
             ElseIf (HPDF_Page_GetLineWidth(Page) <> 0.25) Then
                 Call HPDF_Page_SetLineWidth(Page, 0.25)
             End If
             
             Call HPDF_Page_MoveTo(Page, 0, y)
             Call HPDF_Page_LineTo(Page, width, y)
             Call HPDF_Page_Stroke(Page)
             If (((y Mod 10) = 0) And (y > 0)) Then
                 Call HPDF_Page_SetGrayStroke(Page, 0.5)
                 Call HPDF_Page_MoveTo(Page, 0, y)
                 Call HPDF_Page_LineTo(Page, 5, y)
                 Call HPDF_Page_Stroke(Page)
                 Call HPDF_Page_SetGrayStroke(Page, 0.8)
             End If
             
             y = (y + 5)
             
         Loop
         
         x = 0
         
         Do While (x < width)
             If ((x Mod 10) = 0) Then
                 Call HPDF_Page_SetLineWidth(Page, 0.5)
             ElseIf (HPDF_Page_GetLineWidth(Page) <> 0.25) Then
                 Call HPDF_Page_SetLineWidth(Page, 0.25)
             End If
             
             Call HPDF_Page_MoveTo(Page, x, 0)
             Call HPDF_Page_LineTo(Page, x, height)
             Call HPDF_Page_Stroke(Page)
             If (((x Mod 50) = 0) And (x > 0)) Then
                 Call HPDF_Page_SetGrayStroke(Page, 0.5)
                 Call HPDF_Page_MoveTo(Page, x, 0)
                 Call HPDF_Page_LineTo(Page, x, 5)
                 Call HPDF_Page_Stroke(Page)
                 Call HPDF_Page_MoveTo(Page, x, height)
                 Call HPDF_Page_LineTo(Page, x, (height - 5))
                 Call HPDF_Page_Stroke(Page)
                 Call HPDF_Page_SetGrayStroke(Page, 0.8)
             End If
             
             x = (x + 5)
             
         Loop
         
         y = 0
         
         Do While (y < height)
             If (((y Mod 10) = 0) And (y > 0)) Then
                ' Dim buf As String * 12

                 Call HPDF_Page_BeginText(Page)
                 Call HPDF_Page_MoveTextPos(Page, 5, (y - 2))
                 

                 'snprintf(buf, 12, "%u", y)
                 buf = y
                 Call HPDF_Page_ShowText(Page, buf)
                 Call HPDF_Page_EndText(Page)
             End If
             
             y = (y + 5)
             
         Loop
         
         x = 0
         
         Do While (x < width)
             If (((x Mod 50) = 0) And (x > 0)) Then
                 

                 Call HPDF_Page_BeginText(Page)
                 Call HPDF_Page_MoveTextPos(Page, x, 5)
                 

                 '_snprintf(buf, 12, "%u", x)
                 buf = x
                 Call HPDF_Page_ShowText(Page, buf)
                 Call HPDF_Page_EndText(Page)
                 Call HPDF_Page_BeginText(Page)
                 Call HPDF_Page_MoveTextPos(Page, x, (height - 10))
                 Call HPDF_Page_ShowText(Page, x)
                 Call HPDF_Page_EndText(Page)
             End If
             
             x = (x + 5)
             
         Loop
         
         Call HPDF_Page_SetGrayFill(Page, 0)
         Call HPDF_Page_SetGrayStroke(Page, 0)
End Sub
     
Private Function DrawGrid(ByVal argc As Long, ByVal Star As String, ByVal Unknown As Long) As Integer
         Dim pdf As Long
         Dim Page As Long
         Dim Fname As String
        

         Fname = "GridDemo.pdf"
         pdf = HPDF_New(ByVal vbNullString, ByVal vbNullString)
         If Not pdf Then
             'printf ("error: cannot create PdfDoc object" & vbLf)
             'Return 1
         End If
         
      '   If setjmp(env) Then HPDF_Free (pdf)

         
         Page = HPDF_AddPage(pdf)
         Call HPDF_Page_SetHeight(Page, 600)
         Call HPDF_Page_SetWidth(Page, 400)
       '  print_grid(pdf, page)
         Call HPDF_SaveToFile(pdf, Fname)
         Call HPDF_Free(pdf)
       '  Return 0
     End Function



Private Function show_stripe_pattern(ByVal Page As Long, ByVal x As Single, ByVal y As Single)
    Dim iy As Long
    Do While (iy < 50)
        Call HPDF_Page_SetRGBStroke(Page, 0#, 0#, 0.5)
        Call HPDF_Page_SetLineWidth(Page, 1)
        Call HPDF_Page_MoveTo(Page, x, y + iy)
        Call HPDF_Page_LineTo(Page, x + HPDF_Page_TextWidth(Page, "ABCabc123"), y + iy)
        Call HPDF_Page_Stroke(Page)
        iy = iy + 3
    Loop
    Call HPDF_Page_SetLineWidth(Page, 2.5)
End Function

Public Sub error_handler(ByVal error_no As Long, ByVal detail_no As Long, ByVal user_data As String)
    Debug.Print "ERROR: error_no=" & error_no & ", detail_no="; detail_no, user_data
    'longjmp(env, 1)
End Sub


Private Sub Class_Initialize()
Cpath = CurDir
ChDir (App.path)
End Sub

Private Sub Class_Terminate()
ChDir (Cpath)
End Sub
