VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ZXpand"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' *******************************************************************************
'  VB81 XuR added by XavSnap. (2011)
' *******************************************************************************

'
' For VB81 XUR project(XavSnap)
'

' Class "ZXpand_emu.dll" library From SirMorrisBig 20/05/2011

Option Explicit

Private hInstance As Long
Private hFname As String
Private hConfig As hZXPAND_Config
Private hTimer As Long

Private Type ZXPAND_Config
   CFG_BIT_LOW As Long ' ZXPAND Ram location :[there is RAM at 8K, 16-40K] or [there is RAM at 16-48K]
   CFG_BIT_DISABLED As Long ' ZXPAND Rom Trigger on/off
End Type


Private Declare Function Zxpand_Create Lib "ZXpand_emu.dll" Alias "ZXpand_Create" (ByVal Fname As String) As Long
Private Declare Sub Zxpand_Destroy Lib "ZXpand_emu.dll" Alias "ZXpand_Destroy" (ByVal hInstance As Long)
Private Declare Sub Zxpand_update Lib "ZXpand_emu.dll" Alias "ZXpand_Update" (ByVal hInstance As Long, ByVal hTimer As Long)

Private Declare Sub Zxpand_io_Write Lib "ZXpand_emu.dll" Alias "ZXpand_IO_Write" (ByVal hInstance As Long, ByVal Hadd As Long, ByVal hData As Long)
Private Declare Function Zxpand_GetConfig Lib "ZXpand_emu.dll" Alias "ZXpand_GetConfig" (ByVal hInstance As Long, ByRef ZXPAND_Config As ZXPAND_Config) As Long
Private Declare Function Zxpand_io_Read Lib "ZXpand_emu.dll" Alias "ZXpand_IO_Read" (ByVal hInstance As Long, ByVal Hadd As Long) As Long



Private Sub Class_Initialize()
hInstance = -1
hFname = ""

' [there is RAM at 8K, 16-40K]
' else  [there is RAM at 16-48K]
hConfig.CFG_BIT_LOW = False
'[interface overlay ROM should be disabled]
hConfig.CFG_BIT_DISABLED = False

End Sub

Sub Create(Fname As String)
hFname = Fname
hInstance = Zxpand_Create(Fname)
End Sub

Sub Destroy()
Zxpand_Destroy (hInstance)
hInstance = 0
End Sub

Sub Write_IO(Add As Long, Data As Byte)
Zxpand_io_Write hInstance, Add, CLng(Data)
End Sub

Function Read_IO(Add As Long) As Byte
Read_IO = CByte(Zxpand_io_Read(hInstance, Add))
End Function

Sub Update(timer As Long)
Zxpand_update hInstance, timer
hTimer = timer
End Sub

Public Function GetCurrConfig(RAM8K As Boolean, ROMon As Boolean) As Boolean
Dim RetConfig As ZXPAND_Config

GetCurrConfig = CBool(Zxpand_GetConfig(hInstance, RetConfig))

 ROMon = CBool(RetConfig.CFG_BIT_DISABLED)
 RAM8K = CBool(RetConfig.CFG_BIT_LOW)

hConfig.CFG_BIT_DISABLED = ROMon
hConfig.CFG_BIT_LOW = RAM8K

End Function

Public Function Get_Name() As String
Get_Name = hFname
End Function

Public Function Get_Instance() As Long
Get_Instance = hInstance
End Function

Public Function Get_Timer() As Long
Get_Timer = hTimer
End Function

Public Function IsLinked() As Boolean
If hInstance > 0 Then IsLinked = True
End Function

Private Sub Class_Terminate()
If hInstance > 0 Then Zxpand_Destroy (hInstance)
End Sub
