VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cPrinter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

' *******************************************************************************
' VB81 XuR
' cPrinter.CLS - Added by XavSnap. (2008)
' *******************************************************************************

' Printer def. (32x24): 258 (3,44 Inches) x 192 (2,56 Inches)

'  Port FBh Read - Printer Status
'  Bit  Expl.
'  0      Data Request(0 = Busy, 1 = Ready / DRQ)
'  1-5    Not used
'  6      Printer Detect(0 = Okay, 1 = None)
'  7      Printer Online(0 = Nope, 1 = Ready / Online)

 
'  Port FBh Write - Printer Output
'  Bit  Expl.
'  0-6  ??? Somewhat one or more bits for linefeed and/or else...
'  7      Pixel Output(0 = White, 1 = Black)

Option Explicit

Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

Private PrinterBuffer() As Long

'Original colors
Private OriginalTable(1 To 256) As RGBQUAD
'color tables
Private GrayTable(1 To 256) As RGBQUAD
Private RedTable(1 To 256) As RGBQUAD
Private BlueTable(1 To 256) As RGBQUAD
Private GreenTable(1 To 256) As RGBQUAD
Private InvertTable(1 To 256) As RGBQUAD

Private Stylus_Art_Bl() As Long ' Printer Artefact Color table(Sylus On).
Private Stylus_Art_Wh() As Long ' Printer Artefact Color table(Sylus Off).
Private PrinterColors(1 To 256) As RGBQUAD ' Printer color table.


' Write registers.
' D2   motor:     FALSE=run      TRUE=stop
Private bMotor As Boolean
' D1   speed:     FALSE=fast    TRUE=slow
Private bSpeed As Boolean

'Read registers.
' D7   stylus:    FALSE=off paper   TRUE=on paper
Private bPaper As Boolean

Dim i, a, iCounter

Private Sub Class_initialize()



    ' Init. Gray scale for printer buffer.
    Dim CntColor
    For CntColor = 1 To 256
    PrinterColors(CntColor).rgbRed = CntColor - 1
    PrinterColors(CntColor).rgbGreen = CntColor - 1
    PrinterColors(CntColor).rgbBlue = CntColor - 1
    Next


iCounter = 1
' Sylus On
ReDim Stylus_Art_Bl(1 To 12)
For i = 15 To 125 Step 10
Stylus_Art_Bl(iCounter) = RGB(i, i, i)
iCounter = iCounter + 1
Next

' Stylus OFF
iCounter = 1
ReDim Stylus_Art_Wh(1 To 11)
For i = 255 To 245 Step -1
Stylus_Art_Wh(iCounter) = RGB(i, i, i)
iCounter = iCounter + 1
Next

' Init Printer buffer
ReDim PrinterBuffer(257) ' 258 bytes.
End Sub


Private Sub Class_Terminate()
'
End Sub




Sub Init_Printer()

If FrmPrinter Is Nothing Then Load FrmPrinter

Stylus_X = 0
Stylus_Y = 0

bMotor = True 'Motor Off
bSpeed = True 'Speed Slow
bPaper = True 'Stylus on the paper aera.

' Init Printer buffer
ReDim PrinterBuffer(257) ' 258 bytes.

FrmPrinter.SelCol.Move FrmPrinter.DotColor(0).Left, FrmPrinter.DotColor(0).top - 1, 9, 18
Set FrmPrinter.Paper = Nothing

FrmPrinter.Paper.Height = Screen.TwipsPerPixelY * 2
FrmPrinter.Paper.Width = Screen.TwipsPerPixelX * 259
Set FrmPrinter.Paper.Picture = FrmPrinter.Paper.Image
FrmPrinter.Paper.Refresh

FrmMultiCols.ClsPicture
FrmMultiCols.Refresh_Title

If Printer_Art Then
FrmPrinter.Dither.Picture = FrmPrinter.Prn_IMG.ListImages.Item("D_ON").Picture
Else
FrmPrinter.Dither.Picture = FrmPrinter.Prn_IMG.ListImages.Item("D_OFF").Picture
End If



FrmPrinter.VScroll.max = 0
End Sub

Public Sub Motor_On(cbMotor As Boolean)
' D2   motor:     FALSE=run      TRUE=stop
bMotor = cbMotor
End Sub

Public Sub Speed(cbSpeed As Boolean)
' D1   speed:     False=fast    TRUE=slow
bSpeed = cbSpeed
End Sub

Public Function Get_Motor() As Boolean
Get_Motor = bMotor
End Function

Public Function Get_Speed() As Boolean
Get_Speed = bSpeed
End Function

Public Function Get_Paper() As Boolean
Get_Paper = bPaper
End Function

Public Sub PlotToPrinter(Stylus As Boolean)

If Not bMotor Then Stylus_X = Stylus_X + 1
If Stylus_X > 258 Then bPaper = False Else bPaper = True

If G_Card = eHiResQS Then
If Stylus_X = 257 Then Call AddPrtLine: Exit Sub
Else
If Stylus_X = 258 Then Call AddPrtLine: Exit Sub ' FrmPrinter.Paper.Refresh: Exit Sub ' Set FrmPrinter.Paper.Picture = FrmPrinter.Paper.Image: FrmPrinter.Paper.Refresh: Exit Sub
End If

'Following printer in progress (scroll bar locked!)
'FrmPrinter.VScroll.Value = FrmPrinter.Paper.Height

If Stylus_X >= 0 Then
If Printer_Art Then
    If Stylus Then
     PrinterBuffer(Stylus_X) = Stylus_Art_Bl(Int(12 * Rnd) + 1)
    Else
     PrinterBuffer(Stylus_X) = Stylus_Art_Wh(Int(11 * Rnd) + 1)
    End If
Else
    If Stylus Then
    PrinterBuffer(Stylus_X) = Stylus_Art_Bl(1)
    Else
    PrinterBuffer(Stylus_X) = Stylus_Art_Wh(1)
    End If
End If
End If

End Sub

Sub Refresh_Leds(pState As Integer)

Select Case pState
Case 0
FrmPrinter.Prn_State.Picture = FrmPrinter.Prn_IMG.ListImages.Item("L000").Picture

Case 100
FrmPrinter.Prn_State.Picture = FrmPrinter.Prn_IMG.ListImages.Item("L100").Picture

Case 101
FrmPrinter.Prn_State.Picture = FrmPrinter.Prn_IMG.ListImages.Item("L101").Picture

Case 110
FrmPrinter.Prn_State.Picture = FrmPrinter.Prn_IMG.ListImages.Item("L110").Picture

Case 111
FrmPrinter.Prn_State.Picture = FrmPrinter.Prn_IMG.ListImages.Item("L111").Picture
End Select

DoEvents
'FrmPrinter.Prn_State.Refresh
End Sub

Private Sub CreateColorTables()
Dim i As Long
Dim TempValue As Long




For i = LBound(GrayTable) To UBound(GrayTable)
        
    'Create Gray Color table
    'Add the values together
    TempValue = OriginalTable(i).rgbBlue
    TempValue = TempValue + OriginalTable(i).rgbGreen
    TempValue = TempValue + OriginalTable(i).rgbRed
    
    'Get the medium value
    TempValue = TempValue / 3
    
    'Set the color in the gray table
    GrayTable(i).rgbBlue = TempValue
    GrayTable(i).rgbGreen = TempValue
    GrayTable(i).rgbRed = TempValue
        
    'Create the rest of the color tables
    'Red Table
    RedTable(i).rgbBlue = 0
    RedTable(i).rgbGreen = 0
    RedTable(i).rgbRed = OriginalTable(i).rgbRed
    
    'Green Table
    GreenTable(i).rgbBlue = 0
    GreenTable(i).rgbRed = 0
    GreenTable(i).rgbGreen = OriginalTable(i).rgbGreen
    
    'Blue table
    BlueTable(i).rgbBlue = OriginalTable(i).rgbBlue
    BlueTable(i).rgbGreen = 0
    BlueTable(i).rgbRed = 0
    
    'invert table
    InvertTable(i).rgbBlue = 255 - OriginalTable(i).rgbBlue
    InvertTable(i).rgbGreen = 255 - OriginalTable(i).rgbGreen
    InvertTable(i).rgbRed = 255 - OriginalTable(i).rgbRed

Next i
    
End Sub

Private Sub AddPrtLine()

    'Refresh_Leds 101
    Stylus_X = 0
    If G_Card = eHiResMEMOTECH And (intI And 1) Then Stylus_X = -1

  ' Create a new line to be printed.

  'Refresh Printed line.
  With FrmPrinter.Paper
          
          .Height = (CDbl(Stylus_Y) * CDbl(Screen.TwipsPerPixelY)) + 50

          .AutoRedraw = True

  ' Paste Byte buffer in the printer picture.

             For cmp = 0 To 257
                'FrmPrinter.Paper.Line (cmp - 2, Stylus_Y)-(cmp - 2, Stylus_Y), PrinterBuffer(cmp)
                SetPixel FrmPrinter.Paper.hdc, (cmp - 2), CLng(Stylus_Y), CLng(PrinterBuffer(cmp))
             Next cmp
             FrmPrinter.Paper.Refresh
          .AutoRedraw = False
 
         '    FrmPrinter.Paper.Picture = FrmPrinter.Paper.Image
     '        FrmPrinter.Paper.Refresh
   End With
   Stylus_Y = Stylus_Y + 1

     ' Init Printer buffer
     '   ReDim PrinterBuffer(257) ' 258 bytes.
     
If FrmPrinter.Visible Then
    If FrmPrinter.VScroll.max < &H7FFF Then
        FrmPrinter.VScroll.max = (FrmPrinter.Paper.Height \ 8) \ Screen.TwipsPerPixelY
    Else
        Debug.Print "err"
    End If
End If
 
    If FrmMultiCols.Visible Then Call FrmMultiCols.draw(FrmMultiCols.PageStrip.SelectedItem.index): DoEvents
End Sub
Sub S_copy()

Dim Y_Line As Long
Dim X_Line As Integer
Dim a, Offset
Offset = 0


' Debugg:
'
' Tested OK under :
' -> Memotech basic/grafic mode.
' -> G007 basic/grafic mode.
' -> Hi-res (Dens Revenge) grafic mode.
' -> Basic 32x24 standard mode.
' -> QG-HRG.

For Y_Line = 0 To 191
For X_Line = 0 To 31

        For a = 0 To 7
        If (gcBufferBits((Offset + X_Line)) And (2 ^ (a))) = 0 Then
            
             If Printer_Art Then
                 SetPixel FrmPrinter.Paper.hdc, (X_Line * 8) + (7 - a), Y_Line + Stylus_Y, Stylus_Art_Wh(Int(11 * Rnd) + 1)
             Else
                 SetPixel FrmPrinter.Paper.hdc, (X_Line * 8) + (7 - a), Y_Line + Stylus_Y, Stylus_Art_Wh(1)
             End If
        Else
             If Printer_Art Then
                SetPixel FrmPrinter.Paper.hdc, (X_Line * 8) + (7 - a), Y_Line + Stylus_Y, Stylus_Art_Bl(Int(12 * Rnd) + 1)
             Else
                SetPixel FrmPrinter.Paper.hdc, (X_Line * 8) + (7 - a), Y_Line + Stylus_Y, Stylus_Art_Bl(1)
            End If
        End If
        Next a
Next X_Line
Offset = Offset + 36 - IIf(lHiresLoc = 0, 0, 4) - IIf(G_Card = eHiResMEMOTECH And (Mem_Display And 2) = 2, 4, 0) - IIf((G007_Display = 1) And (intI > &H1E), 4, 0) - IIf((G_Card = eHiResQS) And QSHRG_Display, 4, 0)
Next Y_Line

 Stylus_Y = Stylus_Y + 192
 
End Sub

Sub Feed()
Dim Y_Line As Long
Dim X_Line As Integer

If Stylus_X > 1 Then
''''Stylus_X = 0
Stylus_Y = Stylus_Y - 1
With FrmPrinter.Paper
.Height = .Height - (Screen.TwipsPerPixelY)
End With
End If

If Printer_Art Then
For Y_Line = Stylus_Y To Stylus_Y + 8
For X_Line = 1 To 257
  ' PlotToPrinter False
   SetPixel FrmPrinter.Paper.hdc, X_Line, Y_Line, Stylus_Art_Wh(Int(11 * Rnd) + 1)
Next X_Line
Stylus_Y = Stylus_Y + 1
Next Y_Line
Else
Stylus_Y = Stylus_Y + 9
End If
End Sub

Sub Change_Colors(index As Integer)
If index < 3 Then
' Stylus OFF
iCounter = 1
ReDim Stylus_Art_Wh(1 To 11)
For a = 255 To 245 Step -1
Stylus_Art_Wh(iCounter) = RGB(a, a, a)
iCounter = iCounter + 1
Next
End If

iCounter = 1
Select Case index
Case 0
FrmPrinter.SelCol.Move FrmPrinter.DotColor(0).Left, FrmPrinter.DotColor(0).top - 1, 9, 18

' Sylus On
ReDim Stylus_Art_Bl(1 To 12)
For a = 15 To 125 Step 10
Stylus_Art_Bl(iCounter) = RGB(a, a, a)
iCounter = iCounter + 1
Next
Case 1
FrmPrinter.SelCol.Move FrmPrinter.DotColor(1).Left, FrmPrinter.DotColor(1).top - 1, 9, 18
' Sylus On
ReDim Stylus_Art_Bl(1 To 12)
For a = 15 To 125 Step 10
Stylus_Art_Bl(iCounter) = RGB(0, 0, 75 + a)
iCounter = iCounter + 1
Next
Case 2
FrmPrinter.SelCol.Move FrmPrinter.DotColor(2).Left, FrmPrinter.DotColor(2).top - 1, 9, 18
' Sylus On
ReDim Stylus_Art_Bl(1 To 12)
For a = 15 To 125 Step 10
Stylus_Art_Bl(iCounter) = RGB(125 + a, 0, 125)
iCounter = iCounter + 1
Next
Case 3
' Invert colors.
' Stylus OFF
FrmPrinter.SelCol.Move FrmPrinter.DotColor(3).Left, FrmPrinter.DotColor(3).top - 1, 17, 18
iCounter = 1
ReDim Stylus_Art_Bl(1 To 12)
For a = 255 To 244 Step -1
Stylus_Art_Bl(iCounter) = RGB(a, a, a)
iCounter = iCounter + 1
Next
' Sylus On
iCounter = 1
ReDim Stylus_Art_Wh(1 To 11)
For a = 15 To 115 Step 10
Stylus_Art_Wh(iCounter) = RGB(a, a, a)
iCounter = iCounter + 1
Next

End Select
End Sub


Sub S_Line(Prtstring As String)

Static Y_Line As Long
Static X_Line As Long
Static Cnt, ChrOffset

'FrmPrinter.Paper.ScaleMode = 3
'FrmPrinter.ScaleMode = 3

 Stylus_X = 0
 FrmPrinter.Paper.Height = FrmPrinter.Paper.Height + (Screen.TwipsPerPixelY * 8)

' Line
For Y_Line = 0 To 7
' Columns
For Cnt = 1 To Len(Prtstring)
ChrOffset = ASCIICharToZX(Mid(Prtstring, Cnt, 1))
For X_Line = 0 To 7

        If (MEM(7680 + ChrOffset * 8 + Y_Line) And (2 ^ (X_Line))) = 0 Then
             If Printer_Art Then
            SetPixel FrmPrinter.Paper.hdc, ((Cnt - 1) * 8) + (7 - X_Line), CSng(Y_Line + Stylus_Y), Stylus_Art_Wh(Int(11 * Rnd) + 1)
             Else
            SetPixel FrmPrinter.Paper.hdc, ((Cnt - 1) * 8) + (7 - X_Line), CSng(Y_Line + Stylus_Y), Stylus_Art_Wh(1)
             End If
        Else
             If Printer_Art Then
           SetPixel FrmPrinter.Paper.hdc, ((Cnt - 1) * 8) + (7 - X_Line), CSng(Y_Line + Stylus_Y), Stylus_Art_Bl(Int(12 * Rnd) + 1)
             Else
           SetPixel FrmPrinter.Paper.hdc, ((Cnt - 1) * 8) + (7 - X_Line), CSng(Y_Line + Stylus_Y), Stylus_Art_Bl(1)
            End If
        End If
       
Next X_Line
Next Cnt
Next Y_Line


 Stylus_Y = Stylus_Y + 8
 Stylus_X = 0

End Sub
