Attribute VB_Name = "modMain"
' /*******************************************************************************
'   modMain.bas within vb81.vbp
'
'   Public variable declarations, startup and initialization code,
'   and routines for loading the ROM and applying the required patches
'
'   Author: Chris Cowley <ccowley@grok.co.uk>
'
'   Copyright (C)2000-2002  Grok Developments Ltd.
'   http://www.grok.co.uk/
'
'   This program is free software; you can redistribute it and/or
'   modify it under the terms of the GNU General Public License
'   as published by the Free Software Foundation; either version 2
'   of the License, or (at your option) any later version.
'   This program is distributed in the hope that it will be useful,
'   but WITHOUT ANY WARRANTY; without even the implied warranty of
'   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'   GNU General Public License for more details.
'
'   You should have received a copy of the GNU General Public License
'   along with this program; if not, write to the Free Software
'   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' *******************************************************************************
' VB81 XuR Release.
' ModMain.BAS - Addeds by XavSnap. (2007-2020)
' *******************************************************************************

Option Base 0
Option Explicit

Public Const XuR_Release = "28-09-20"
' Actual release date    : Day/Month/Year

' DXsound 8 Setup
'Implements DirectXEvent8
'Public DsB() As DirectSoundSecondaryBuffer8 ' Used to play sound buffer.
'--------------------------------------------


Public Declare Function timeGetTime Lib "winmm.dll" () As Long
Public Declare Function timeBeginPeriod Lib "winmm.dll" (ByVal uPeriod As Long) As Long
Public Declare Function timeEndPeriod Lib "winmm.dll" (ByVal uPeriod As Long) As Long

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)
Public Declare Sub CopyMemoryStr Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, ByVal lpvSource As String, ByVal cbCopy As Long)
Public Declare Sub CopyMemoryToStr Lib "kernel32" Alias "RtlMoveMemory" (ByVal lpvDest As String, pvSource As Any, ByVal cbCopy As Long)
Public Declare Sub ClrMemory Lib "kernel32" Alias "RtlZeroMemory" (Destination As Any, ByVal Length As Long)
'Public Declare Sub RtlCopyMemory Lib "kernel32" (Destination As Any, source As Any, ByVal Length As Long)
    
'GDI Function
Public Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, ByVal PtX As Long, ByVal Pty As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long

'Image Processing with 8-bit bitmaps
'
'Public Declare Function GetDIBColorTable Lib "gdi32" (ByVal hdc As Long, ByVal un1 As Long, ByVal un2 As Long, pRGBQuad As RGBQUAD) As Long
'Public Declare Function SetDIBColorTable Lib "gdi32" (ByVal hdc As Long, ByVal un1 As Long, ByVal un2 As Long, pcRGBQuad As RGBQUAD) As Long

Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Public Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long

Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function GetTickCount Lib "kernel32" () As Long
Public Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Boolean

'****************************************
Public Declare Function GetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, lpBits As Any) As Long
Public Declare Function SetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, lpBits As Any) As Long
Public Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long

'****************************************
Public Type RGBQUAD
        rgbBlue As Byte
        rgbGreen As Byte
        rgbRed As Byte
        rgbReserved As Byte
End Type

Public Type eRomBlocs
    Enabled As Boolean
    RomIndex As Long
    RomOffset As Long
    RomName As String
    RomLen As Long
    User As Boolean ' Only load User's Roms, System can't be refreesh [ROMs tweeks (Larken or Zx81 Hack)]
End Type

Public Declare Sub InitCommonControls Lib "comctl32.dll" ()

Public Declare Function SetErrorMode Lib "kernel32" (ByVal wMode As Long) As Long
Public Const SEM_FAILCRITICALERRORS = &H1
Public Const SEM_NOGPFAULTERRORBOX = &H2
Public Const SEM_NOOPENFILEERRORBOX = &H8000

'Shell32 argument for Drag&drop P files.
Public Declare Function DragQueryFile Lib "shell32.dll" Alias "DragQueryFileA" (ByVal hDrop As Long, ByVal UINT As Long, ByVal lpStr As String, ByVal ch As Long) As Long
Public Declare Sub DragFinish Lib "shell32.dll" (ByVal hDrop As Long)
Public Declare Sub DragAcceptFiles Lib "shell32.dll" (ByVal hWnd As Long, ByVal fAccept As Long)
Public Const WM_DROPFILES = &H233

Global WinVer As Byte
Global DesktopPath As String

Public b16kRamPack As Boolean

Public bGraphTrig As Boolean

Public Enum Graphic_Card
    eNo_Card = 0
    eHiResMEMOTECH = 1
    eHiResG007 = 2
    eHiResQS = 3
    eHiResWRX = 4
    eCOLOUR16 = 5
    ePENTRON16 = 6
End Enum

Public Enum Graphic_WRX
    eNo_WRX = 0
    ePSEDO = 1 ' Rock-Crush ; Micro-mouse ; Rocket-Man (IX intercepted)
    eWRX16 = 2
End Enum

Public Enum Sound_Card
    esNo_Card = 0
    esOctaviaKit = 1
    esVtr = 2 ' VTR/ZONx sound card.
    esQuickSilva = 3 ' QuickSilva sound card.
    esAGB = 4 ' AGB sound card.
    esFuller = 5 ' FULLER sound card.
    esUSER = 6 ' USER defined.
    esSPO256 = 7 ' VTR/Mageco speech engine.
    esParrotSPO256 = 8 'Parrot speech engine.
End Enum


Public Enum eDrives
    Drive0 = 0
    Drive1 = 1
End Enum

Public Enum eDisTag
    show_hex_val = 0
    show_dec_val = 1
    show_str_val = 2
End Enum

Public Enum eKbd
    None = 0
    Fr = 1
    en = 2
    Du = 3
End Enum

Public Enum TextCompile
    eMemoryText = 0
    eTextMemory = 1
    eEditorText = 2
End Enum

' // ShellExecute is used for the clickable web URL in the "About..." dialog, not
' //the actual emulator itself
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Public Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
    
Public Const BITSPIXEL = 12
Public Const LOGPIXELSX = 88    '  Logical pixels/inch in X
Public Const LOGPIXELSY = 90    '  Logical pixels/inch in Y

Public VB81_Rom As String       '  ZX81's Rom name to load

Public glDisplayXMultiplier As Long
Public glDisplayYMultiplier As Long
Public bInit As Boolean
Public bForceDisplay As Boolean
Public bInv_Display As Boolean
Public bAutoRepeat As Boolean ' Autorepeat Keyboard.
Public bAutoType As Boolean
Public bKbd As eKbd ' PcKeyboard particularity.

Public Parity(256) As Long
Public bInputWait As Boolean
Public bBooting As Boolean
Public glInterruptTimer As Long
Public glTstatesPerInterrupt As Long
Public SpeedCoeff As Long

' // Main registers //
Public FreezeCPU As Boolean
Public regA As Long
Public regHL As Long
Public regB As Long
Public regC As Long
Public regDE As Long

' F register (AF register).
' ------------------------
' B7= fs  = Sign.               Positive=0 - Negative = 1 (P and N condition)
' B6= fz  = Zero.               OTHER   =0 - Zero     = 1
' B5= f5  = Not used.           ---------------------------------------------
' B4= fh  = Half-Carry.         Bit3 (or 11) ->bit4 (or 12) not changed = 0
'                               Bit3 (or 11) ->bit4 (or 12) changed = 1
' B3= F3  = Not used.           ---------------------------------------------
' B2= fpv = PARITY/overflow.    Parity odd=0/parity Even=1 or Add... bit6 to 7 overflow=1
' B1= fn  = Substract. (internal) The last instruction was a Substract or a addition ?
' B0= fc  = Carry.              Bit7 (or 16) to a fictive Bit8 (or 17) changed =1 else =0

Public fS As Long
Public fZ As Long
Public f5 As Long
Public fH As Long
Public f3 As Long
Public fPV As Long
Public fN As Long
Public fC As Long

' // Flag positions in AF.
Public Const F_C = 1
Public Const F_N = 2
Public Const F_PV = 4
Public Const F_3 = 8
Public Const F_H = 16
Public Const F_5 = 32
Public Const F_Z = 64
Public Const F_S = 128

' // Alternate registers //
Public regAF_ As Long
Public regHL_ As Long
Public regBC_ As Long
Public regDE_ As Long

' // Index registers  - ID used as temp for ix/iy //
Public regIX As Long
Public regIY As Long
Public regID As Long

' // Stack pointer and program counter
Public regSP As Long
Public regPC As Long

' // Interrupt registers and flip-flops and refresh registers //
Public intI As Long
Public intR As Long
Public intRTemp As Long
Public intIFF1 As Boolean
Public intIFF2 As Boolean
Public intIM As Long
Public intHRG As Long ' PSEUDO-HRG IM2

' // Memory //
Public MEM(65536) As Byte

' // Selected Ram Pack
Public SRamPack As Integer

' // Ram Pack enum.
Public Type eRamPack
     Name As String
     Top_Ram As Long ' Top of the memory to mirror address.
End Type

' Selected limite of Ram.
Public SRamLim As Long

' ROM allocation segments.
Public eRomalloc(31) As eRomBlocs ' 2Kb Used by a rom. (32x2k=64K)
Public SelRom As Boolean ' Settings windows trigger to Get a Bios Rom (false) or a user static Rom(true)
Public SelRomFile As String ' Call back the selected Rom in the Audi frame.


' Top of the memory to mirror address.
Public RamPack(0 To 4) As eRamPack

' // Lookup tables for speed division
Public glMemAddrDiv256(81919) As Long
Public glMemAddrDiv2(81919) As Long
 
' // Screen things
Public sLastScreen(850) As Long

' // Hires Support
Public lHiresLoc As Long ' // location in ZX81's memory of the hi-res displayfile

''Public cLastHiResScreen(0 To 191, 0 To 31) As Long ''
Public cLastHiResScreen(0 To 191, 0 To 33) As Long
Public G_Card As Graphic_Card
Public Memhrg(0 To 1024) As Byte  ' HRG memory Buffer. (Memotech card and QS-HRG)
Public bQSChargen As Boolean ' Qs UDG Trigger.
Public bAGBChargen As Boolean ' AGB UDG Trigger.
Public bQS_ON As Boolean ' Qs active UDG.
Public bAGB_ON As Boolean ' Qs active UDG.
Public MemUDG(0 To 1023) ' Qs/AGB UDG Buffer.
Public UDGmemSeg As Byte 'UDG factory memory segment.
Public Mem_Display As Byte ' Memotech HRG display ( IN A,5F ) 0=BASIC/2=memory buffer or 3=INVERTED+Memory buffer
Public HrgMemo_PageOff As Long ' Memotech HRG address Page.
Public G007_Display As Byte ' G007 HRG display 0=BASIC/1=GRAPHIC Black 2=GRAPHIC White or 3=INVERTED
Public QSHRG_Display As Byte ' QuickSilva HRG Display
Public Display_WRX As Graphic_WRX ' WRX HRG Display

Public bLpen As Boolean ' VTR/Mageco Light-Pen trigger.
Public LpenX As Integer ' X value from the Light-Pen.
Public LpenY As Integer ' Y value from the Light-Pen.

Public bMemotext As Boolean
Public bMemotextSw As Boolean


' Printers.
Public PrinterCfg As Byte ' Printer configuration.
' 0 = ZxPrinter.
' 1 = Memotech I/F output.
' 2 = Centronics

Public gCentronic As Boolean

' Memotech RS232 output.
Public gSerialIF As Boolean

' // Interrupts/Screen refreshing
Public interruptCounter As Long
Public Const refreshRate = 1

' // Keypresses
Public keyB_SPC As Long
Public keyH_ENT As Long
Public keyY_P As Long
Public key6_0 As Long
Public key1_5 As Long
Public keyQ_T As Long
Public keyA_G As Long
Public keyCAPS_V As Long

Type eKbZX
keyB_SPC As Long
keyH_ENT As Long
keyY_P As Long
key6_0 As Long
key1_5 As Long
keyQ_T As Long
keyA_G As Long
keyCAPS_V As Long
End Type

'Redefine cursors.
Public Type TCursors
K5 As eKbZX
K6 As eKbZX
K7 As eKbZX
K8 As eKbZX
End Type

Public eCursors As TCursors
'Public cWin As New clsWin

Public Kempston As KempstonJoy

' // Display colors
Public colors(3) As Long
Public bHideInFastMode As Boolean
Public bDisplayShown As Boolean
Public bScrCapture As Boolean ' 0=32x24 capture : True : 34x24 Capture.
Public bScrCaptureDir As Boolean ' In current directory.
Public bAutoCapture As Boolean ' Auto-cature name while F11 pressing.("screenshoot" folder)
Public ScreenFmt As Byte ' BMP/GIF/JPEG/PNG
Public JpegQuality As Byte

' // Other settings
Public bAllowWritesToROM As Boolean

' // 8255 PPI Interface.
Public bPPI8255 As Boolean ' IO PPI Card trigger.
Public EEprom_ADDr As Long ' Rom address on the PPI, PC:Hword. PB:Lword.
Public Prt_Trigger As Boolean  ' Printer validation trigger : Strobe->Acknowlage.

Public bI8O8 As Boolean ' 8 Input / 8 Output card.
Public bI8O8io As Boolean ' 8 Input / 8 Output card. (io adresse)
Public vI8O8_IN As Byte  ' 8 Input / 8 Output card.
Public vI8O8_OUT As Byte ' 8 Input / 8 Output card.

' Wilf Rigter's 32Kb Ram+IO (50000 to 50015)X2 In case of
' Read: RD memory order (PEEK) or Write: WR memory order (POKE).
Public bI16O16 As Boolean ' 16 Input / 16 Output card.
Public vI16O16_IN(15) As Boolean  ' 16 Input / 16 Output card.
Public vI16O16_OUT(15) As Boolean ' 16 Input / 16 Output card.

' // Global P file Buffer
Public Prog_ZX() As Byte
Public Prog_ZXT81() As Byte
Public Wav_Buffer() As Byte
Public Wav_Top As Long

' // Global WAV file Buffer
Public Bytes_array() As Byte ' Byte Array (memory segment)


' // Virtual Tape Specification.
Public VT_NameZX() As T81 ' Loaded File array name.
' .Nom_Fichier : File name. (French???)
' .Taille : File Lenght.
' .offset : File offset data.
Public VT_NameMs As String ' Loaded File array (full) name. (Exemple.T81 or .Tzx)
Public VT_Index As Integer ' Index of used file.(0 to n files... Zx Active file)

'/// T81 format.

Public Enum_T81() As T81

Type T81
          Nom_Fichier As String
          Taille      As Long
          Offset      As Long
End Type


'// ******************** S O U N D ***********************

Public gbSoundEnabled As Long
Public glSoundRegister As Long  ' // Contains currently indexed AY-3-8912 sound register
Public glBufNum As Long         ' // ID of the last Wave buffer used

' // Sound enum
Public S_Card As Sound_Card ' None/SoundKit.

' // SPO256 Handle.
Public bSPO As Boolean

'// Sound Kit Card.
Public SndKit_SMP(0 To 3) As Byte ' Sound matrix to create a Sound signal.

Public gbTZXPlaying As Boolean
Public glBeeperVal As Long ' Beep sound.(SAVE)

'/// Wav Specifications:
Public Enum eSamples
   Real_Snd = 0
   Eighty_One = 1
   ZxD = 2
   ZxTape = 3
   fast_load = 4
End Enum

Global SoundCard As Byte ' Sound card enum.
Public bSND_ok As Boolean ' Initalisation error trigger. True=No Sound False=Play sounds.
Public bSND_Display As Boolean ' Display sound debuger frame.

Public Sample As eSamples


' AY-3 User Card.
Type pAYUSER
ComType As Byte ' 0=No sound. 1=IN/OUT. 2=POKE/PEEK.
CommandReg As Long '<&hFF (IN/OUT)
DatasReg As Long '<&hFF (IN/OUT)
End Type

Public AY_User As pAYUSER

Public gbEmulateAYSound As Boolean

Public glEarBit As Byte

'Zx81 FONT installed on my computer?
Public Zx81FNT As String

' // Global Printer trigger
Public cPrinter As cPrinter
Public Stylus_Y As Long
Public Stylus_X As Long
Public Printer_Stat As Boolean
Public Printer_Art  As Boolean ' Printer Artefact  switch.
Public Page_Title As String  'Printer Multi-Colums display (Title)
Public Page_Footer As String  'Printer Multi-Colums display (Page number)
Public DC As Long ' Printer buffer DC


' // Global HACK trigger
Public Copy_Hack As Boolean    ' Hack rom to allow a 32x24 screen Copy
Public Save_to_WAV As Boolean  ' Disable rom Hack to intercept FF& Output sounds.
Public Load_WAV As Boolean     ' Disable rom Hack to intercept FF& Input sounds.
Public bEAR_input As Boolean   ' Wav pulse : trigger to intercept FF& Input sounds.
Public MemHack32k As Boolean   ' Patch the ROM RAM_TOP to $BFFF

'// init AUTO-START TRIGGER
Public AutoStart As Boolean

'// View hexa or String codes.
Public Distag As eDisTag

' // Disk Driver
Public Disk_Buffer() As Byte
Public Disk_Data As Byte
Public IsDisk As Boolean
Public bDSK_Update As Boolean '// Larken/Mageco auto-update (Disk buffer is updated while write access)
Public bLarken As Boolean '// Larken Eprom tag.
Public bMageco As Boolean '// Mageco Eprom tag.
Public Mageco_CMD As Mageco_CMD

Type Mageco_CMD
Track As Integer
Side As Byte
Step As Integer
Drv_ON As Boolean
ROM As Boolean ' ROM RELEASE as false=2.6 and true=3.0
End Type

Public Motor_On As Byte
Public Track As Long
Public ActiveDrive As eDrives ' // 0 = Drive0 (default) 1 = drive1
Public Drive_Files(0 To 1) As String ' //  Drive file name for Drive0 and Drive1
Public CBM1541_CLK As Integer
Public bCBM1541 As Boolean ' // CBM drive coutroller trigger

Public Disk_Stat(0 To 4) As Byte ' 0= Drive Disabled. / 1= Drive Enabled. (drive0 or drive1)
                                 ' 5! instead of 2 (reserved for LKdos Spectrum release)->Combos
Public Const eDisk_Disabled = False
Public Const eDisk_Enabled = True

' Larken Header (track header)
Type TRK_Header ' 24 bytes.
Buff_SRT As Byte
Track_Nbr  As Byte
F_Name(8) As Byte
Tag_Name As Byte
Start As Integer
lenght As Integer
CRC_1 As Long
CRC_2 As Long
End Type

' Larken catalog (file datas)
Type Lk_Dos_Cat ' 36 bytes.
Tag_1 As Byte
NameStr(8) As Byte
End_Name As Byte
Clusters(24) As Byte
End Type

' Zxpand public variables def.

Type hZXPAND_Config
   CFG_BIT_LOW As Boolean ' Ram Trigger.
   CFG_BIT_DISABLED As Boolean ' Rom Trigger.
End Type

Public bZxpand As Boolean
Public ZxpandBuffer(0 To 8191) As Byte  ' 4096-1 bytes buffer to mirror the new Zx81 ROM.

'// Misc.
'/// The Fast One data base variables.
Public TFO_Low As Long '// Low memory offset for "The Fast One" data base.
Public TFO_Hi As Long  '// Hight memory offset for "The Fast One" data base.

Public TFO_Records() As String
Public TFO_Datas() As String

Public Zx_Name As String 'Store current P name

' // Audit Rom Center v2.5 compatibility.
Type Rom_Center
'set filename
S_FileName As String
'set full name
S_FullName As String
'clone filename
C_FileName As String
'clone full name
C_FullName As String
'rom filename
Rom_Name As String
'rom crc
Rom_CRC As String
'size
Rom_Size As Long
'merged clone name
MC_Name As String
'merged rom name
MR_Name As String
End Type

Public Files_DATAs() As Files_DATAs ' Rom audit arguments.

' "P" file header for tape raw images :
Type P_header '   Tape ".p" Header (size 116)
    version As Byte ' Version
    E_PPC As Uinteger
    D_FILE As Uinteger ' Basic program lengh = D_File-16509
    DF_CC As Uinteger
    VARS As Uinteger ' Sart of vars Address.
    DEST As Uinteger
    E_Line As Uinteger ' Start of Basic program.
    CH_ADD As Uinteger
    X_PTR As Uinteger
    STKBOT As Uinteger
    STKEND As Uinteger
    BERG As Byte
    MEM As Uinteger
    UnByte As Byte
    DF_SZ As Byte
    S_TOP As Uinteger
    LAST_K As Uinteger
    DEBOUNCE As Byte
    MARGIN As Byte
    Nxt_line As Uinteger
    OLDPPC As Uinteger
    FLAGX As Byte
    StrLen As Uinteger
    T_ADDR As Uinteger
    SEED As Uinteger
    FRAMES As Uinteger
    COORDS As Uinteger
    PR_CC As Byte
    S_POSN As Uinteger
    CDFLAG As Byte
    PRBUFFER As String * 32
    PRBUFEND As Byte
    MEMBOT As String * 30
    UnWord As Uinteger
End Type


Type SYSVARS '   Tape ".p" Header (size 116)
    version As Byte ' Version
    E_PPC As Integer
    D_FILE As Integer ' Basic program lengh = D_File-16509
    DF_CC As Integer
    VARS As Integer ' Sart of vars Address.
    DEST As Integer
    E_Line As Integer ' Start of Basic program.
    CH_ADD As Integer
    X_PTR As Integer
    STKBOT As Integer
    STKEND As Integer
    BERG As Byte
    MEM As Integer
    UnByte As Byte
    DF_SZ As Byte
    S_TOP As Integer
    LAST_K As Integer
    DEBOUNCE As Byte
    MARGIN As Byte
    Nxt_line As Integer
    OLDPPC As Integer
    FLAGX As Byte
    StrLen As Integer
    T_ADDR As Integer
    SEED As Integer
    FRAMES As Integer
    COORDS As Integer
    PR_CC As Byte
    S_POSN As Integer
    CDFLAG As Byte
    PRBUFFER As String * 32
    PRBUFEND As Byte
    MEMBOT As String * 30
    UnWord As Integer
End Type

'// Basic Tools
Public Lines_Report() As BasicLineProperty
Public Type BasicLineProperty
        Line_Numb As Long
        Line_Len As Long
        Line_MemOff As Long
End Type


' ZX81 floating point number.
Type Zx81_Long
        Exp As Integer ' - Exponent
        man As String ' - Mantissa
End Type


' // Disassembler offset
Public DASM_Offset As Long


' // Sound dec.
Public Snd_Monitor_counter As Long
Public Snd_vol As Long

' // Wav structure
Public wInfo As WaveHeaderInfo
Type WaveHeaderInfo
 channels As Integer
 Freq As String
 Bits As Integer
 kbps As Long
 wFilesize As String
 wPlaytime As String
End Type


' // Rom CRC Audit type.
Public Type Files_DATAs
        File_Main_Name As String
        File_Main_Comment As String
        File_Sec_Name As String
        File_Sec_Comment As String
        File_MsName As String
        File_Crc32 As String
        File_Lenght As Long
        File_Comment As String
        File_Merge As String
End Type

' // WINAPI stuff for fast screen updates
Public Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Public Const DSTINVERT = &H550009   ' (DWORD) dest invert

Public Declare Function StretchDIBits Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal Dx As Long, ByVal Dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal wSrcWidth As Long, ByVal wSrcHeight As Long, lpBits As Any, lpBitsInfo As BITMAPINFO, ByVal wUsage As Long, ByVal dwRop As Long) As Long
Public Declare Function StretchDIBits256 Lib "gdi32" Alias "StretchDIBits" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal Dx As Long, ByVal Dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal wSrcWidth As Long, ByVal wSrcHeight As Long, lpBits As Any, lpBitsInfo As BITMAPINFO16, ByVal wUsage As Long, ByVal dwRop As Long) As Long

Public Type BITMAPINFOHEADER '40 bytes
        biSize As Long
        biWidth As Long
        biHeight As Long
        biPlanes As Integer
        biBitCount As Integer
        biCompression As Long
        biSizeImage As Long
        biXPelsPerMeter As Long
        biYPelsPerMeter As Long
        biClrUsed As Long
        biClrImportant As Long
End Type

' Printer Buffer.
Private Type BITMAP
        bmType As Long
        bmWidth As Long
        bmHeight As Long
        bmWidthBytes As Long
        bmPlanes As Integer
        bmBitsPixel As Integer
        bmBits As Long
End Type

' Screen Buffering def.
Public Type BITMAPINFO
        bmiHeader As BITMAPINFOHEADER
        bmiColors(1) As RGBQUAD
End Type

Public Type BITMAPINFO16
        bmiHeader As BITMAPINFOHEADER
        bmiColors(255) As RGBQUAD
End Type

' Kempston joystick parameter
' IO : &h1F
' B0 : Right
' B1 : Left
' B2 : Down
' B3 : Up
' B4 : Fire

Public Type KempstonJoy
        IO As Byte
        Stat As Byte
End Type

Public Const BI_RGB = 0&
Public Const DIB_RGB_COLORS = 0 '  color table in RGBs
Public bmiBuffer As BITMAPINFO
Public bmiBufferHR As BITMAPINFO
Public bmiBufferDF As BITMAPINFO
Public bmiBuffer16 As BITMAPINFO16

' BM 1 bit. per pixel.
Public gcBufferBits(6912) As Byte ' 34x(8x24) *8 bits

' // Global picDisplay variable to speed things up
Public gpicDisplay As PictureBox

Public LastColor As Long ' Mageco/VTR 16 colors last color.
' // Global picDisplay variable to speed things up
Public gpicDisplay16 As PictureBox, gpicDC16 As Long
Public glBufferBits16(271, 191) As Byte ' ( 272,192)

Public D_FileCLR(795) As Byte ' Buffer to store a clear D_File (equal to CLS)

'// init common dialog (Load/Save files)
Public OpenDialog As New clsCDEx

'// init the main frame.
Public MainWindow As FrmMainWnd


'// hexadicimal editor variables.
Public giHexSelPointer As Integer   ' Pointer to the Line in Listbox
Public gbChangedFile As Boolean     ' Pointer to Change Code of File
Public gbChangedField As Boolean    ' Pointer to change code of Fields
Public giOpt00B7 As Integer         ' Pointer to the 00 or B7 Option
Public gsOldValue As String         ' Store the old value of a Hex or Ascii field
Public glLastFound As Long

Public Edit As Boolean
Public NextSearch As Boolean
Public GetHexDec As Boolean

'// Compare memory.
Public Mem_Snap() As Byte
Public Bcomp As Integer ' 1= <> 2= < 3= >
Public App_path As String

'// Tokenize.
Public ZXbuffer() As Byte
Public ZxOffset As Long ' ZxBuffer pointer.
Public bVarFlag As Boolean
Public VarsBuffer() As Byte
Public VarsOffset As Long
Public hFile As Integer
Public GRAPHIC_MODE As Boolean

Public CurNBLn As Long
Public FncString As String * 6
Public Cmp_Decay As Long
Public LastLINE As Long
Public FrtLine As Integer
Public ErrIndex As Long
Public InputLine As Long
Public Lines() As Long
Public lineCtr As Long
Public NewWord As Boolean
Public Prt_Trg As Boolean
Public bNum As Boolean
Public bREM As Boolean
Public bSave As Boolean
Public cmp As Long

'Basic un/Tokenizer.
Public TextFile As TextCompile ' Window trigger Load/save Text file.
Public TConvBasLen As Long
Public bCBIconv As Boolean
Public bTxtFormat As Boolean
Public bVars As Boolean
Public bASMhex As Boolean


' EasyDraw
Public EasyDrawTrig As Boolean
Public EasyDrawChar As Byte
Public EasyDrawAdd As Long
Public EasyPenTrig As Boolean

' Debuger.
Public Debug_Trg As Boolean
Public Debuger_Pnt(65536) As Boolean
Public Debuger_Rel As Boolean

' Forth.
Public Buff_Offset As Long


Public Sub CreateScreenBuffer16()
    bmiBuffer16.bmiHeader.biSize = Len(bmiBuffer16.bmiHeader)
    bmiBuffer16.bmiHeader.biWidth = 272 '256
    bmiBuffer16.bmiHeader.biHeight = 192 '192
    bmiBuffer16.bmiHeader.biPlanes = 1
    bmiBuffer16.bmiHeader.biBitCount = 8
    bmiBuffer16.bmiHeader.biCompression = BI_RGB
    bmiBuffer16.bmiHeader.biSizeImage = Len(bmiBuffer16.bmiHeader)
    bmiBuffer16.bmiHeader.biXPelsPerMeter = 200
    bmiBuffer16.bmiHeader.biYPelsPerMeter = 200
    bmiBuffer16.bmiHeader.biClrUsed = 0
    bmiBuffer16.bmiHeader.biClrImportant = 0

    
        InitBitmap16Colors
        
               ' Clear display buffer.
               ' ClrMemory glBufferBits16(0, 0), 272 * 192
               
               FrmMainWnd.picDisplay.BackColor = RGB(250, 250, 250)
               
               ' Clear Basic display.
                gpicDisplay.Cls
        
        
End Sub


Public Sub CreateScreenBuffer()
' Bmi Used for Basic 34x24 res.
    bmiBuffer.bmiHeader.biSize = Len(bmiBuffer.bmiHeader)
    bmiBuffer.bmiHeader.biWidth = 272 '256
    bmiBuffer.bmiHeader.biHeight = 192 '192
    bmiBuffer.bmiHeader.biPlanes = 1
    bmiBuffer.bmiHeader.biBitCount = 1
    bmiBuffer.bmiHeader.biCompression = BI_RGB
    bmiBuffer.bmiHeader.biSizeImage = 0
    bmiBuffer.bmiHeader.biXPelsPerMeter = 200
    bmiBuffer.bmiHeader.biYPelsPerMeter = 200
    bmiBuffer.bmiHeader.biClrUsed = 0
    bmiBuffer.bmiHeader.biClrImportant = 0
    
    
' Bmi Used for HR card (memotech & G007 & QS-HRG).
    bmiBufferHR.bmiHeader.biSize = Len(bmiBufferHR.bmiHeader)
    bmiBufferHR.bmiHeader.biWidth = 256
    bmiBufferHR.bmiHeader.biHeight = 192
    bmiBufferHR.bmiHeader.biPlanes = 1
    bmiBufferHR.bmiHeader.biBitCount = 1
    bmiBufferHR.bmiHeader.biCompression = BI_RGB
    bmiBufferHR.bmiHeader.biSizeImage = 0
    bmiBufferHR.bmiHeader.biXPelsPerMeter = 200
    bmiBufferHR.bmiHeader.biYPelsPerMeter = 200
    bmiBufferHR.bmiHeader.biClrUsed = 0
    bmiBufferHR.bmiHeader.biClrImportant = 0
    
' Bmi Used for the D_file viewer.
    bmiBufferDF.bmiHeader.biSize = Len(bmiBufferDF.bmiHeader)
    bmiBufferDF.bmiHeader.biWidth = 256
    bmiBufferDF.bmiHeader.biHeight = 192
    bmiBufferDF.bmiHeader.biPlanes = 1
    bmiBufferDF.bmiHeader.biBitCount = 1
    bmiBufferDF.bmiHeader.biCompression = BI_RGB
    bmiBufferDF.bmiHeader.biSizeImage = 0
    bmiBufferDF.bmiHeader.biXPelsPerMeter = 200
    bmiBufferDF.bmiHeader.biYPelsPerMeter = 200
    bmiBufferDF.bmiHeader.biClrUsed = 0
    bmiBufferDF.bmiHeader.biClrImportant = 0
    
   
    InitBitmapColors
End Sub

Public Sub CreateScreenBuffer_HR()
    bmiBuffer.bmiHeader.biSize = Len(bmiBuffer.bmiHeader)
    bmiBuffer.bmiHeader.biWidth = 256
    bmiBuffer.bmiHeader.biHeight = 192
    bmiBuffer.bmiHeader.biPlanes = 1
    bmiBuffer.bmiHeader.biBitCount = 1
    bmiBuffer.bmiHeader.biCompression = BI_RGB
    bmiBuffer.bmiHeader.biSizeImage = 0
    bmiBuffer.bmiHeader.biXPelsPerMeter = 200
    bmiBuffer.bmiHeader.biYPelsPerMeter = 200
    bmiBuffer.bmiHeader.biClrUsed = 0
    bmiBuffer.bmiHeader.biClrImportant = 0
    InitBitmapColors
    
               ' Clear display buffer.
                ClrMemory gcBufferBits(0), 6528
               
               ' Clear Basic display.
                gpicDisplay.Cls
End Sub
Public Sub InitBitmapColors()
    SetBitmapColor 0, colors(0)
    SetBitmapColor 1, colors(1)
End Sub

Public Sub InitBitmap16Colors()
' D0: LUMINANCE (0 Or +63 /255 on each chanel)
' D1: red       (0 Or +192/255)
' D2: green     (0 Or +192/255)
' D3: blue      (0 or +192/255)

Dim Cnt As Integer

' COLOR B : Back color.
    bmiBuffer16.bmiColors(0).rgbRed = 250
    bmiBuffer16.bmiColors(0).rgbGreen = 250
    bmiBuffer16.bmiColors(0).rgbBlue = 250
    
' COLOR 0 : BLACK
    bmiBuffer16.bmiColors(1).rgbRed = 0
    bmiBuffer16.bmiColors(1).rgbGreen = 0
    bmiBuffer16.bmiColors(1).rgbBlue = 0
    
' COLOR 1 :
    bmiBuffer16.bmiColors(2).rgbRed = 63
    bmiBuffer16.bmiColors(2).rgbGreen = 63
    bmiBuffer16.bmiColors(2).rgbBlue = 63
    
' COLOR 2 :
    bmiBuffer16.bmiColors(3).rgbRed = 192
    bmiBuffer16.bmiColors(3).rgbGreen = 0
    bmiBuffer16.bmiColors(3).rgbBlue = 0
    
' COLOR 3 :
    bmiBuffer16.bmiColors(4).rgbRed = 255
    bmiBuffer16.bmiColors(4).rgbGreen = 63
    bmiBuffer16.bmiColors(4).rgbBlue = 63
    
' COLOR 4 :
    bmiBuffer16.bmiColors(5).rgbRed = 0
    bmiBuffer16.bmiColors(5).rgbGreen = 192
    bmiBuffer16.bmiColors(5).rgbBlue = 0
    
' COLOR 5 :
    bmiBuffer16.bmiColors(6).rgbRed = 63
    bmiBuffer16.bmiColors(6).rgbGreen = 255
    bmiBuffer16.bmiColors(6).rgbBlue = 63
    
' COLOR 6 :
    bmiBuffer16.bmiColors(7).rgbRed = 192
    bmiBuffer16.bmiColors(7).rgbGreen = 192
    bmiBuffer16.bmiColors(7).rgbBlue = 0
    
' COLOR 7 :
    bmiBuffer16.bmiColors(8).rgbRed = 255
    bmiBuffer16.bmiColors(8).rgbGreen = 255
    bmiBuffer16.bmiColors(8).rgbBlue = 63
    
' COLOR 8 :
    bmiBuffer16.bmiColors(9).rgbRed = 0
    bmiBuffer16.bmiColors(9).rgbGreen = 0
    bmiBuffer16.bmiColors(9).rgbBlue = 192
    
' COLOR 9 :
    bmiBuffer16.bmiColors(10).rgbRed = 63
    bmiBuffer16.bmiColors(10).rgbGreen = 63
    bmiBuffer16.bmiColors(10).rgbBlue = 255
    
' COLOR 10 :
    bmiBuffer16.bmiColors(11).rgbRed = 192
    bmiBuffer16.bmiColors(11).rgbGreen = 0
    bmiBuffer16.bmiColors(11).rgbBlue = 192
    
' COLOR 11 :
    bmiBuffer16.bmiColors(12).rgbRed = 255
    bmiBuffer16.bmiColors(12).rgbGreen = 63
    bmiBuffer16.bmiColors(12).rgbBlue = 255
    
' COLOR 12 :
    bmiBuffer16.bmiColors(13).rgbRed = 0
    bmiBuffer16.bmiColors(13).rgbGreen = 192
    bmiBuffer16.bmiColors(13).rgbBlue = 192
    
' COLOR 13 :
    bmiBuffer16.bmiColors(14).rgbRed = 63
    bmiBuffer16.bmiColors(14).rgbGreen = 255
    bmiBuffer16.bmiColors(14).rgbBlue = 255
    
' COLOR 14 :
    bmiBuffer16.bmiColors(15).rgbRed = 192
    bmiBuffer16.bmiColors(15).rgbGreen = 192
    bmiBuffer16.bmiColors(15).rgbBlue = 192
    
' COLOR 15 :
    bmiBuffer16.bmiColors(16).rgbRed = 250
    bmiBuffer16.bmiColors(16).rgbGreen = 250
    bmiBuffer16.bmiColors(16).rgbBlue = 250
    
    For Cnt = 17 To 255
    bmiBuffer16.bmiColors(Cnt).rgbRed = 0
    bmiBuffer16.bmiColors(Cnt).rgbGreen = 0
    bmiBuffer16.bmiColors(Cnt).rgbBlue = 0
    Next Cnt
    
LastColor = 1
End Sub

Private Sub InitDivisionTables()
    Dim n As Long
     
    For n = 0 To 81919
        glMemAddrDiv256(n) = (n And 65535) \ 256&
        glMemAddrDiv2(n) = (n And 65535) \ 2&
    Next n
End Sub
Sub initParity()
    Dim iCounter As Integer, j As Byte, p As Long
    
    For iCounter = 0 To 255
        p = True
        For j = 0 To 7
            If (iCounter And (2 ^ j)) <> 0 Then p = Not p
        Next j
        Parity(iCounter) = p
    Next iCounter
End Sub


Public Sub InstallROMHacks()
If bZxpand Then Exit Sub

    ' // If Save_to_WAV set true, perform an output scan on FFh (ULA TV/TAPE-PIN#16)
If Not Save_to_WAV Then
    ' // Patch the 'SAVE' ROM routine with an illegal operation, which we
    ' // trap in the Z80 emulation so the file can be saved to disk instead of
    ' // the ROM trying to output it to TAPE via the ULA
    MEM(&H2FC) = &HED ' // ED FD    ; the illegal Z80 op we use for SAVE
    MEM(&H2FD) = &HFD ' //
    MEM(&H2FE) = &HC3 ' // JP 0207h ; this is where the ZX81 ROM jumps to after
    MEM(&H2FF) = &H7  ' //          ; saving a program to tape
    MEM(&H300) = &H2  ' //
End If

' // If Load_WAV set true, perform an output scan on FFh (ULA TAPE IN-PIN#20)
'If Not Load_WAV Then
' ----------------------------------------
' ----------------------------------------
' XuR now a partial emulated "Wav" loader.
' ----------------------------------------

    ' // Patch the 'LOAD' ROM routine with an illegal op, which is trapped
    ' // just like the LOAD patch above.
    MEM(&H347) = &HEB ' // EX DE,HL ; points HL to the name of the program to
                      ' //          ; load (in the ZX character set)
    MEM(&H348) = &HED ' // ED FC    ; the illegal Z80 op we use for LOAD
    MEM(&H349) = &HFC ' //
    MEM(&H34A) = &HC3 ' // JP 0207h ; this is where the ZX81 ROM jumps to after
    MEM(&H34B) = &H7  ' //          ; loading a program from tape
    MEM(&H34C) = &H2  ' //
' ----------------------------------------
' XuR now a partial emulated "Wav" loader.
' ----------------------------------------
'End If

    ' // Execute 'out (0),a' when waiting for input, and
    ' // 'out (1),a when finished waiting (used to paint
    ' // the screen during idle periods when in fast mode)
    ' // Can be remmed but the Out(0) is also used to autolaunche P files.
    MEM(&H4CA) = &HD3 ' //       OUT (0),A  ; Tell the emulator we are waiting
    MEM(&H4CB) = 0    ' //                  ; for keyboard input
    MEM(&H4CC) = &HCB ' // loop: BIT 0,(HL) ; Loop until our NMI emulation sets
    MEM(&H4CD) = &H46 ' //                  ; bit 0 of (CDFLAGS), which indicates
    MEM(&H4CE) = &H28 ' //       JR Z,loop  ; that a key has been pressed
    MEM(&H4CF) = &HFC ' //
    MEM(&H4D0) = &HD3 ' //       OUT (1),A  ; Tell the emulator that we are no
    MEM(&H4D1) = 1    ' //                  ; longer waiting for keyboard input
    MEM(&H4D2) = 0    ' //       NOP        ; NOP an old byte (filler)

' Warning ! This Pause Hack seem to corrupt D_file refresh.
'           Vars is decremented and erase low memory content.
'           This release seem working whithout this patch !

    ' // This is required for correct implementation of the PAUSE command, as the
    ' // PAUSE code in a real ZX81 is tied in with the FRAMES counter in the FAST
    ' // mode display loop which we emulate outside of the routines in the ROM.
    ' MEM(&H2A9) = &HD3 ' //   OUT (0),A  ; see above
    ' MEM(&H2AA) = 0
    ' MEM(&H2AB) = 118  ' //   HALT       ; ensures the bit of display code that
                      ' //              ; we loop through only gets executed
                      ' //              ; once per interrupt (as it would in a
                      ' //              ; real ZX81)
    ' MEM(&H2AC) = 205  ' //   CALL 0229h ; jump out of the display routine
    ' MEM(&H2AD) = &H29 ' //              ; early to avoid the nasty code that
   '  MEM(&H2AE) = 2    ' //              ; jumps right into the DFILE!
   '  MEM(&H2AF) = &HD3 ' //  OUT (1),A   ; see above
    ' MEM(&H2B0) = 1
   '  MEM(&H2B1) = 201  ' //  RET         ; Return to PAUSE command routine
  

' Remmed By XavSnap.


    ' // "COPY" Hack!
    If Copy_Hack Then
    MEM(&H86A) = 24   ' // Allow a 32x24 "Copy" function (Rom offset call &h869).
                      ' (REAL 32x22 set to &h16)
    End If
    
    If MemHack32k Then MEM(&H4) = &HBF ' // Scan the RAM-TOP to BFFF.
    
    ' // RET in memory top!
    MEM(SRamLim + 1) = 201 ' // Avoid overflow memory.
    
    
Select Case PrinterCfg
    Case 0 ' ZxPrinter
     'Remove hacks
      MEM(&H879) = &HC5: MEM(&H87A) = &HE5: MEM(&H87B) = &HAF
      MEM(&H87C) = &H5F: MEM(&H87D) = &HD3: MEM(&H87E) = &HFB: MEM(&H87F) = &HE1
      FrmMainWnd.mnuOptions(16).Visible = False
      
    Case 1 ' Memotech C. I/F Centronics.
           'Rom mirroring (display it in the memory.
    CopyMemory MEM(2166), MEM(10624), 128
      FrmMainWnd.mnuOptions(16).Visible = True
    
    Case 2 ' AGB Centronics card.
    MEM(&H879) = &HC3: MEM(&H87A) = &HD0: MEM(&H87B) = &H30
    MEM(&H87C) = &HFF: MEM(&H87D) = &HFF: MEM(&H87E) = &HFF: MEM(&H87F) = &HFF
      FrmMainWnd.mnuOptions(16).Visible = True
End Select

If bMemotext Then
    If bMemotextSw Then
        MEM(&H416) = &HCD: MEM(&H417) = &H7: MEM(&H418) = &H2
        MEM(&H419) = &HCD: MEM(&H41A) = &H6: MEM(&H41B) = &H30
        Else
        MEM(&H416) = &HCD: MEM(&H417) = &H23: MEM(&H418) = &HF
        MEM(&H419) = &HCD: MEM(&H41A) = &H2A: MEM(&H41B) = &HA
    End If
End If

End Sub

Public Sub LoadMemoCalcROM()
    On Error Resume Next
    If Dir$(App.path & "\Roms\memocalc.rom") = "" Then
        MsgBox "Error: Could not find required MemoCalc ROM image '" & App.path & "\Roms\memocalc.rom'.", vbOKOnly Or vbCritical, "vb81"
        Exit Sub
    End If
    
    
    UpdateRomAlloc App.path & "\Roms\memocalc.rom", 12288
    Load_File_In_Mem App.path & "\Roms\memocalc.rom", 12288
    
End Sub
Public Sub LoadMemoTextROM()
    On Error Resume Next
    If Dir$(App.path & "\Roms\memotext.rom") = "" Then
        MsgBox "Error: Could not find required MemoText ROM image '" & App.path & "\Roms\memotext.rom'.", vbOKOnly Or vbCritical, "vb81"
        Exit Sub
    End If
    
    UpdateRomAlloc App.path & "\Roms\memotext.rom", &H3600, 2048, False
    Load_File_In_Mem App.path & "\Roms\memotext.rom", &H3600
    
End Sub

Public Sub LoadCBIROM()

FrmMainWnd.mnuFile(1).Enabled = True

    If Dir$(App.path & "\Roms\Coral_Basic.Z81") = "" Then
        MsgBox "Error: Could not find required Coral-Basic file image '" & App.path & "\Roms\Coral_Basic.Z81'.", vbOKOnly Or vbCritical, "vb81"
         Exit Sub
    End If
    
 ' Old ROM SPECS.
 ' --------------
 '   If Dir$(App.path & "\Roms\CBI.rom") = "" Then
 '       MsgBox "Error: Could not find required CBI ROM image '" & App.path & "\Roms\CBI.rom'.", vbOKOnly Or vbCritical, "vb81"
 '       Exit Sub
 '   End If


SaveSetting "Grok", "vb81", "Ram_Pack", "4"
SRamLim = RamPack(4).Top_Ram
SRamPack = 4

  UpdateRomAlloc "Coral Basic", 27400, 5368
  
  Snap_CPU App.path & "\Roms\Coral_Basic.Z81"
    Zx_Name = "Coral-Basic COMPILER"
  FrmMainWnd.Caption = "VB81 XuR [" & Zx_Name & "] "
   
End Sub
Public Sub Load64kPatch()
  bInputWait = False
  ShowDisplay False, False
  
  MEM(16507) = 255
  MEM(16508) = 255
  
    On Error Resume Next
    If Dir$(App.path & "\Roms\init-64k.pfl") = "" Then
        MsgBox "Error: Could not find required ASM2 screen image '" & App.path & "\Roms\init-64k.pfl'.", vbOKOnly Or vbCritical, "vb81"
        Exit Sub
    End If

    Load_File_In_Mem App.path & "\Roms\init-64k.pfl", &HC552
'    regPC = &HC552
    
  bInputWait = True
  ShowDisplay True, False
'Do
'loop until regpc=
'regPC =

End Sub
Public Sub LoadASMROM()
  
    
    
  bInputWait = False
  ShowDisplay False, False
  
  
    Load_File_In_Mem App.path & "\Roms\ASM2.PFL", &H4009
   
   
  ' Set computer in Slow Mode.
  ' AF' Bit7 =1
  
  'regAF_ = regAF_ Or 32768
  ' MEM(16443) = MEM(16443) And (Not 32768)
  bInputWait = True
  ShowDisplay True, True
  ScreenPaint
  
   'jmp &H207
   
   Dim D_FILE As Long
   D_FILE = ((CLng(MEM(16397)) * 256) + CLng(MEM(16396))) + 1
   On Error Resume Next
    If Dir$(App.path & "\Roms\ASM2-Screen.BIN") = "" Then
        MsgBox "Error: Could not find required ASM2 screen image '" & App.path & "\Roms\ASM2-Screen.BIN'.", vbOKOnly Or vbCritical, "vb81"
        Exit Sub
    End If
    
Load_File_In_Mem App.path & "\Roms\ASM2-Screen.BIN", D_FILE


End Sub
Public Sub LoadCBI_Screen(D_FILE As Long)
    On Error Resume Next
    If Dir$(App.path & "\Roms\CBI-Screen.BIN") = "" Then
        MsgBox "Error: Could not find required CBI screen image '" & App.path & "\Roms\CBI-Screen.BIN'.", vbOKOnly Or vbCritical, "vb81"
        Exit Sub
    End If
    
Load_File_In_Mem App.path & "\Roms\CBI-Screen.BIN", D_FILE

End Sub

Sub LoadROM()
    Dim hFile As Long, sROM As String, iCounter As Integer
    On Error Resume Next
    App_path = App.path
    If Dir$(App.path & "\Roms\" & VB81_Rom) = "" Then
        MsgBox "Error: Could not find required ROM image '" & App.path & "\Roms\zx81.rom'.", vbOKOnly Or vbCritical, "vb81"
        Unload MainWindow
        Exit Sub
    End If
    
UpdateRomAlloc App.path & "\Roms\" & VB81_Rom, 0
Load_File_In_Mem App.path & "\Roms\" & VB81_Rom, 0

If bZxpand Then LoadZxpandBuffer

End Sub

Sub Main()
FrmSplash.Show
DoEvents
Sleep (750)
Unload FrmSplash
   
' init EasyDraw variables.
 EasyDrawAdd = -1
 EasyDrawTrig = False
 EasyPenTrig = False

If Dir(App.path & "\ROMS\*.*") = "" Then
         Static Msg As String
         Msg = "VB81 XuR can't run properly if it launched from a zipped file" & vbCrLf & "Please unzip the compressed folder whith all of compressed subdirectorys"
         MsgBox Msg
         End
End If

WinVer = Int(val(val(WindowsVersion())))

If WinVer = 4 Then
Debug.Print "XuR under Windows 95/98."
End If

If WinVer = 5 Then
Debug.Print "XuR under Windows XP (NT)."
End If

DesktopPath = Desktop_Path

FrmMainWnd.AutoKey = False
bAutoRepeat = False
bKbd = 1
  
FrmMainWnd.mnuFile(1).Enabled = False
FreezeCPU = False

' ZxPrinter Debug LOG file.

'hFile_PRT = FreeFile
'Open "DEBUG_PRT.LOG" For Output As hFile_PRT

GetHexDec = False
VT_Index = 1
SpeedCoeff = 1
 
 'Test illegal "LastPath"
 On Error GoTo Path_ERR
 ChDir (GetSetting("Grok", "vb81", "LastPath", App.path))
 GoTo Path_ok
Path_ERR:
  SaveSetting "Grok", "vb81", "LastPath", App.path
  ChDir (App.path)
Path_ok:
 
 On Error Resume Next
      
  bQS_ON = False
  If val(GetSetting("Grok", "vb81", "QuickSilvaUDG", "0")) = 0 Then
  bQSChargen = False
  Else
  bQSChargen = True
  End If
  
  bAGB_ON = False
  If val(GetSetting("Grok", "vb81", "AGBUDG", "0")) = 0 Then
  bAGBChargen = False
  Else
  bAGBChargen = True
  End If
  
   ' Memory setting.
   ' b16kRamPack = True
   SRamPack = val(GetSetting("Grok", "vb81", "Ram_Pack", "4"))
 
   ' Top of the memory to mirror address.
   RamPack(0).Name = "1 Kb Standard ZX81"
   RamPack(0).Top_Ram = 17407 ' 16384+1024-1
   RamPack(1).Name = "2 Kb Standard TS1000"
   RamPack(1).Top_Ram = 18431 ' 16384+16384-1
   RamPack(2).Name = "16 Kb Ram Pack"
   RamPack(2).Top_Ram = 32767 ' 16384+16384-1 !!!! Pause corrupt !!!!
   RamPack(3).Name = "32 Kb Ram Pack"
   RamPack(3).Top_Ram = 65535
   RamPack(4).Name = "64 Kb Ram Pack"
   RamPack(4).Top_Ram = 65535

   SRamLim = RamPack(SRamPack).Top_Ram
   
   ' 8255 PPI interface.(active the Rom shadow)
If GetSetting("Grok", "vb81", "PPI8255", "0") = "1" Then
   bPPI8255 = True
   Frm_Setting.Shadow_ROM.Enabled = False
   Else
    bPPI8255 = False
End If

    ' Kempston Joystick setup (IO=$1F)
      Kempston.IO = GetSetting("Grok", "vb81", "KempstonIO", "31")
        

    ' Capture with 32x24 and 34x24 Setting. (Colors window setup)
    If GetSetting("Grok", "vb81", "ScreenCap", "0") = "0" Then
            FrmMainWnd!mnuFile(8).Caption = "Capture ZX81 screen x1 (32 col)"
            bScrCapture = False
             Else
            FrmMainWnd!mnuFile(8).Caption = "Capture ZX81 screen x1 (34 col)"
            bScrCapture = True
    End If
    
     If GetSetting("Grok", "vb81", "ScreenCapDir", "0") = "0" Then
             bScrCaptureDir = False
             Else
             bScrCaptureDir = True
    End If
   
    ' Save Screen Shoot format.
    
    ' BMP  = 0
    ' GIF  = 1
    ' JPEG = 2
    ' PNG  = 3

    ScreenFmt = val(GetSetting("Grok", "vb81", "Screen_Fmt", "0"))
    JpegQuality = val(GetSetting("Grok", "vb81", "JpegQuality", "70"))
    
     ' Auto Capture name setup.
    If GetSetting("Grok", "vb81", "AutoCap", "0") = "0" Then
            FrmMainWnd!mnuFile(8).Caption = FrmMainWnd!mnuFile(8).Caption + " [Manual]"
            bAutoCapture = False
             Else
            FrmMainWnd!mnuFile(8).Caption = FrmMainWnd!mnuFile(8).Caption + " [Auto.]"
            bAutoCapture = True
    End If
   
    
    
    ' 0= None
    ' 1= Octavia 7 octaves, Sound mode  1 chanel mono.
    ' 2= VTR 7 octaves, Sound/noise mode  3 stereo sharped chanels.
    ' 3= QuickSilva sound card.
    ' 4= AGB sound card.
    ' 5= Fuller.
    ' 6= USER AY def.
    ' 7= SPO256
    S_Card = val(GetSetting("Grok", "vb81", "Sound", "0"))
    
       '// init Sound Kit
    '    AY8912_init 1773000, WAVE_FREQUENCY, 8
    AY8912_init 1625000, WAVE_FREQUENCY, 8
 
    
    bSND_ok = True
    If val(GetSetting("Grok", "vb81", "SoundError", CStr(0))) = 1 Then S_Card = esNo_Card: bSND_ok = False
    
    ' Display the sound Debugger?
     If val(GetSetting("Grok", "vb81", "DisplayDebugSND", "0")) = 0 Then
        bSND_Display = False

     Else
        bSND_Display = True
     End If
     

    '// Auto-Start argument
    If Command$ <> "" Then
    AutoStart = True
    'MsgBox Command$, vbInformation, "Command:"
    End If
    
    Dim iCounter As Integer, s As String
 
   Wav_Top = 0
   Snd_vol = -500
   
   'Init various buffers
   Init_Sound
   Init_D_FileCLR
   
   InitCommonControls
   
   ReDim Disk_Buffer(0 To 158719) ' =158720 bytes for then Shugart SA455 - 5.25 - 150kb (80x1984)
   
   Motor_On = &HFF
   CBM1541_CLK = &H0
   
   ActiveDrive = 0
   
   Mageco_CMD.Drv_ON = False
   Mageco_CMD.ROM = False
   Mageco_CMD.Step = 0
   Mageco_CMD.Track = 0
   Mageco_CMD.Side = 0
   
    Drive_Files(0) = GetSetting("Grok", "vb81", "Image0", "")
    Drive_Files(1) = GetSetting("Grok", "vb81", "Image1", "")
    
    '// Test if disks image are avaleable.
    On Error Resume Next
    If Dir(Drive_Files(0)) = "" Then Drive_Files(0) = "": SaveSetting "Grok", "vb81", "Image0", ""
    If Dir(Drive_Files(1)) = "" Then Drive_Files(1) = "": SaveSetting "Grok", "vb81", "Image1", ""
    
    '// Init Auto-Update.
    '/// 0: Vb81 create a image disk buffer and save it in case of exit or eject procedure.
    '/// 1: VB81 force tracks saving wile Larken drive process. (write access only)
    If GetSetting("Grok", "vb81", "DSK_AutoUpdate", "0") = "1" Then
    bDSK_Update = True
    Else
    bDSK_Update = False
    End If
    
If GetSetting("Grok", "vb81", "Larken", "0") = "1" Then
   bLarken = True
   bMageco = False
      FrmMainWnd.Disk.Caption = "Larken controller"
      FrmMainWnd.Disk.Visible = True
   Else
   bLarken = False
      FrmMainWnd.Disk.Visible = False
End If

    
 If GetSetting("Grok", "vb81", "Mageco", "0") = "1" Then
   bMageco = True
   bLarken = False
      FrmMainWnd.Disk.Caption = "Mageco controller"
      FrmMainWnd.Disk.Visible = True
   Else
   bMageco = False
      FrmMainWnd.Disk.Visible = False
End If

   If GetSetting("Grok", "vb81", "ZXpand_sw", "0") = 1 Then
   bZxpand = True
   Else
   bZxpand = False
   End If
   
   ' Load disks images. (buffering active drive)
   Load_Disk
   
   
   ' Set Curent Rom to load.
   VB81_Rom = GetSetting("Grok", "vb81", "RomZX81", "zx81a.ROM")
   
   
   ' Load enhanced Copy hack trigger.
   Copy_Hack = CBool(GetSetting("Grok", "vb81", "Copy", "0"))
   If Copy_Hack Then Frm_Setting.Copy.value = 1
   
   ' Load RAM_TOP Hack.
   MemHack32k = CBool(GetSetting("Grok", "vb81", "RAM_TOPHACK", "0"))
   If MemHack32k Then Frm_Setting.RAMTOP.value = 1
   
   ' Load "Load" Hack validation : FFh Output Port or software trigger.
   Load_WAV = CBool(GetSetting("Grok", "vb81", "Load_Wav", "0"))
   
    If Load_WAV Then
     Frm_Setting.L_WAV.value = 1: FrmMainWnd.Load_SW.picture = FrmMainWnd.SWL(1).picture
     FrmMainWnd.Tape_SW.ToolTipText = "Load from WAV files."
     Else
     Frm_Setting.L_WAV.value = 0: FrmMainWnd.Load_SW.picture = FrmMainWnd.SWL(0).picture
     FrmMainWnd.Tape_SW.ToolTipText = "Load from P files."
   End If
  
   ' Load "Save" Hack validation : FFh Output Port or software trigger.
   Save_to_WAV = CBool(GetSetting("Grok", "vb81", "Save_to_Wav", "0"))
   
   If Save_to_WAV Then
     Frm_Setting.Save_WAV.value = 1: FrmMainWnd.Sound.picture = FrmMainWnd.ISsound(1).picture
     FrmMainWnd.Tape_SW.ToolTipText = "Save to WAV files."
     Else
     FrmMainWnd.Sound.picture = FrmMainWnd.ISsound(0).picture
     FrmMainWnd.Tape_SW.ToolTipText = "Save to P files."
   End If
   

   Debug.Print val(GetSetting("Grok", "vb81", "Cursors", "0"))
   ' Load Shifted /unSifted cursors trigger.
   Select Case val(GetSetting("Grok", "vb81", "Cursors", "0"))
   
   Case 0

  'Not Shifted.
      eCursors.K5.key1_5 = 222: eCursors.K5.key6_0 = 255: eCursors.K5.keyA_G = 255: eCursors.K5.keyB_SPC = 255: eCursors.K5.keyCAPS_V = 255: eCursors.K5.keyH_ENT = 255: eCursors.K5.keyQ_T = 255: eCursors.K5.keyY_P = 255
      eCursors.K6.key1_5 = 255: eCursors.K6.key6_0 = 222: eCursors.K6.keyA_G = 255: eCursors.K6.keyB_SPC = 255: eCursors.K6.keyCAPS_V = 255: eCursors.K6.keyH_ENT = 255: eCursors.K6.keyQ_T = 255: eCursors.K6.keyY_P = 255
      eCursors.K7.key1_5 = 255: eCursors.K7.key6_0 = 238: eCursors.K7.keyA_G = 255: eCursors.K7.keyB_SPC = 255: eCursors.K7.keyCAPS_V = 255: eCursors.K7.keyH_ENT = 255: eCursors.K7.keyQ_T = 255: eCursors.K7.keyY_P = 255
      eCursors.K8.key1_5 = 255: eCursors.K8.key6_0 = 246: eCursors.K8.keyA_G = 255: eCursors.K8.keyB_SPC = 255: eCursors.K8.keyCAPS_V = 255: eCursors.K8.keyH_ENT = 255: eCursors.K8.keyQ_T = 255: eCursors.K8.keyY_P = 255
     
   Case 1
  'Shifted.
      eCursors.K5.key1_5 = 223: eCursors.K5.key6_0 = 255: eCursors.K5.keyA_G = 255: eCursors.K5.keyB_SPC = 255: eCursors.K5.keyCAPS_V = 254: eCursors.K5.keyH_ENT = 255: eCursors.K5.keyQ_T = 255: eCursors.K5.keyY_P = 255
      eCursors.K6.key1_5 = 255: eCursors.K6.key6_0 = 223: eCursors.K6.keyA_G = 255: eCursors.K6.keyB_SPC = 255: eCursors.K6.keyCAPS_V = 254: eCursors.K6.keyH_ENT = 255: eCursors.K6.keyQ_T = 255: eCursors.K6.keyY_P = 255
      eCursors.K7.key1_5 = 255: eCursors.K7.key6_0 = 239: eCursors.K7.keyA_G = 255: eCursors.K7.keyB_SPC = 255: eCursors.K7.keyCAPS_V = 254: eCursors.K7.keyH_ENT = 255: eCursors.K7.keyQ_T = 255: eCursors.K7.keyY_P = 255
      eCursors.K8.key1_5 = 255: eCursors.K8.key6_0 = 247: eCursors.K8.keyA_G = 255: eCursors.K8.keyB_SPC = 255: eCursors.K8.keyCAPS_V = 254: eCursors.K8.keyH_ENT = 255: eCursors.K8.keyQ_T = 255: eCursors.K8.keyY_P = 255
   Case 2
   ' User keys.
      LoadKB_Setting
   End Select
   
   InitDisks
   
      
    FrmMainWnd.Show
    
    InitDivisionTables
    
    ' // Get colors and initialize display
    colors(0) = &HC0C0C0
    colors(1) = 0
    colors(2) = &HC0C0C0
    colors(3) = &H808080
    
    For iCounter = 0 To 3
        s = GetSetting("Grok", "vb81", "Color" & (iCounter + 1), "")
        If s <> "" Then
            colors(iCounter) = val("&h" & s)
        End If
    Next iCounter
    
     
    ' // Init toolsbar.
    
    If GetSetting("Grok", "vb81", "ShowToolbar", "1") = "1" Then
        FrmMainWnd.mnuOptions_Click 3
    End If
    
    If GetSetting("Grok", "vb81", "ShowLarken", "0") = "1" Then
        FrmMainWnd.mnuOptions_Click 4
    End If

        
    ' // Set the correct size (standard/double)
    Select Case val(GetSetting("Grok", "vb81", "ScreenSize", "2"))
    Case 1
        FrmMainWnd.mnuOptionsDisplay_Click 1
    Case 2
        FrmMainWnd.mnuOptionsDisplay_Click 5
    Case 3
        FrmMainWnd.mnuOptionsDisplay_Click 7
    Case 4
        FrmMainWnd.mnuOptionsDisplay_Click 3
    Case 5
        FrmMainWnd.mnuOptionsDisplay_Click 4
    End Select
    
        
    ' Virtual tape window.
    If GetSetting("Grok", "vb81", "TapeManager", "0") = "1" Then
    FrmMainWnd.mnuOptions_Click 7
    End If
    
    FrmMainWnd.Ref_TB 3
    FrmMainWnd.Set_HD
    FrmMainWnd.R_Barre
    
    If GetSetting("Grok", "vb81", "AllowWritesToROM", "1") = "1" Then
        bAllowWritesToROM = True
        Else
        bAllowWritesToROM = False
    End If

    bHideInFastMode = val(GetSetting("Grok", "vb81", "HideInFastMode", "1"))
    bForceDisplay = val(GetSetting("Grok", "vb81", "ForceDisplay", "1"))
    bInv_Display = val(GetSetting("Grok", "vb81", "InvertedDisplay", "0"))
    If G_Card = eCOLOUR16 Or G_Card = ePENTRON16 Then bInv_Display = 0: bForceDisplay = 0
        
        
    bLpen = val(GetSetting("Grok", "vb81", "LIGHTPEN", "0"))

    With FrmMainWnd
        If bHideInFastMode Then
            gpicDisplay.Visible = False
            .BackColor = colors(3)
        Else
            .BackColor = colors(2)
        End If
        bDisplayShown = bHideInFastMode
        gpicDisplay.BackColor = colors(0)
        gpicDisplay.Cls
        .Cls
    
        .Show
        .Refresh
    End With

'// Init Printer (Reset)
    
    cPrinter.Init_Printer
    Printer_Art = val(GetSetting("Grok", "vb81", "Printer_Artefact", "1"))
    
    PrinterCfg = CByte(val(GetSetting("Grok", "vb81", "Printer", "0")))
    gSerialIF = CBool(GetSetting("Grok", "vb81", "MemotechSIF", "0"))
    ResetPrinterROMs
    
    ' // Initialize everything
    intIFF1 = True
    intIFF2 = True
    intIM = 0
    initParity
    
    ' // In slow mode, the ZX81 runs at approx. 0.8MHz
    glTstatesPerInterrupt = 16000 * SpeedCoeff
    
    bInputWait = False
    bBooting = False
    
    ' // Graphic Card setting.
    G_Card = val(GetSetting("Grok", "vb81", "Graphic_Card", "0"))
    
       ' // Set up the screen bitmap in memory
    If G_Card = eCOLOUR16 Or G_Card = ePENTRON16 Then CreateScreenBuffer16 Else CreateScreenBuffer
    
    ' Init 16 colors card.
    Set gpicDisplay16 = FrmMainWnd.picDisplay
    gpicDC16 = gpicDisplay16.hDC
    
    Set gpicDisplay = FrmMainWnd.picDisplay
    
    
    
    ' // Avoid rom shadow for Memotech grafic card
    'G_Card = eHiResMEMOTECH
    'If G_Card <> eNo_Card And G_Card = eHiResWRX Then bAllowWritesToROM = False
    
    ' // load the ROM image into memory
    LoadROM

    
    'If G_Card = eNo_Card And (Not bAllowWritesToROM) Then
    CopyROM ' // Copy the 8K ZX81 rom into 0x2000 - 0x3FFF (this is how the
            ' // memory map on a real ZX81 looks
   ' End If
   
       InstallROMHacks
       
    ' // Load True graphic card Eprom.
   Select Case G_Card
    Case 1
    ' HRG Memotech
     Load_TrueHrg (1)
      Case 2
     Load_TrueHrg (2)
      Case 3
     Load_TrueHrg (3)
   End Select
   
    ' // load the LDOS/MDOS ROM image into memory
    If bLarken Then Load_LDos
    If bMageco Then Load_MDos
   
    ResetKeyboard
    
    timeBeginPeriod 1
    
    glInterruptTimer = (timeGetTime() + 20) ' * SpeedCoeff
    
   
    FrmMainWnd.Display_Noise
    
    'Check the sound driver, and init the wav streeming.
    gbSoundEnabled = InitializeWaveOut()
    
    ' // Begin executing the ROM code at 0x0000
    execute
End Sub

Sub CopyROM()
    
    ' // In case of TK85 rom, the shadow memory can't overwrite the 2048b Rom extension!
    ' // We can't copy the rom onto this segment.
    
    ' Test the Rom Lenght:
    Dim Rom_Length As Long, a
    
    Rom_Length = FileLen(App.path & "\Roms\" & VB81_Rom)
    
    'On Error GoTo err_EXIT
    
    If Not bAllowWritesToROM And G_Card = 0 Then
    ' Classic ZX81/TS1000 ROM : Mirrored at &2000
    If Rom_Length <= 8192 Then
        CopyMemory MEM(8192), MEM(0), 8192
    End If
    End If
    For a = 2 To 7
    CopyMemory MEM(8192 * a), MEM(0), 8192
    Next a
    
    ClrMemory MEM(16384), SRamLim - 16384
    
        
    
    ' Extended TK85 ROM : Mirrored at 2000h but,don't overwrite existing Rom
    If Rom_Length > 8192 And Rom_Length < &H4000 Then
    CopyMemory MEM(8192 + (Rom_Length - 8192)), MEM(Rom_Length - 8192), 8192 - (Rom_Length - 8192)
    End If
    
     ' Attics ROMs : The Rom is too large to be mirrored or overwrite the RAM address (4000h)
    If Rom_Length >= &H4000 Then
    Exit Sub
    End If
    
err_EXIT:
End Sub

Public Function max(lVal1 As Long, lVal2 As Long) As Long
    max = IIf(lVal1 > lVal2, lVal2, lVal1)
End Function

Sub ResetKeyboard()
    keyB_SPC = 255
    keyH_ENT = 255
    keyY_P = 255
    key6_0 = 255
    key1_5 = 255
    keyQ_T = 255
    keyA_G = 255
    keyCAPS_V = 255
End Sub


Public Sub SetBitmapColor(lIndex As Long, lColor As Long)
    If lIndex > 1 Then Exit Sub
    
    bmiBuffer.bmiColors(lIndex).rgbRed = (lColor And &HFF&)
    bmiBuffer.bmiColors(lIndex).rgbGreen = (lColor And &HFF00&) \ 256
    bmiBuffer.bmiColors(lIndex).rgbBlue = (lColor And &HFF0000) \ 65536
    
    bmiBufferHR.bmiColors(lIndex).rgbRed = (lColor And &HFF&)
    bmiBufferHR.bmiColors(lIndex).rgbGreen = (lColor And &HFF00&) \ 256
    bmiBufferHR.bmiColors(lIndex).rgbBlue = (lColor And &HFF0000) \ 65536
    
    bmiBufferDF.bmiColors(lIndex).rgbRed = (lColor And &HFF&)
    bmiBufferDF.bmiColors(lIndex).rgbGreen = (lColor And &HFF00&) \ 256
    bmiBufferDF.bmiColors(lIndex).rgbBlue = (lColor And &HFF0000) \ 65536
  
End Sub

Public Sub ShowDisplay(ByVal flag As Boolean, bPaintFlag As Boolean)
    ' flag=TRUE (ShowDisplay)
    ' flag=FALSE (HideDisplay)
    
    If bHideInFastMode And bDisplayShown <> flag Then
        If flag Then
            If G_Card = eCOLOUR16 Or G_Card = ePENTRON16 Then FrmMainWnd.BackColor = RGB(250, 250, 250) Else FrmMainWnd.BackColor = colors(2)
            If bPaintFlag Then ScreenPaint
        Else
            If G_Card = eCOLOUR16 Or G_Card = ePENTRON16 Then FrmMainWnd.BackColor = RGB(1, 1, 1) Else FrmMainWnd.BackColor = colors(3)
        End If
        FrmMainWnd.picDisplay.Visible = flag
        FrmMainWnd.Refresh
        bDisplayShown = flag
    End If
End Sub

 Sub InitDisks()
 
Dim a, attribut As Integer, Tmp_Name As String



If GetSetting("Grok", "vb81", "Larken", "0") = "1" Or GetSetting("Grok", "vb81", "Mageco", "0") = "1" Then
    

 For a = 0 To 1: Disk_Stat(a) = val(GetSetting("Grok", "vb81", "Drive" & Str(a), "0")): Next
 
        FrmMainWnd.Disk.Visible = True
        If bLarken Then FrmMainWnd.Disk.Caption = "Larken controller"
        If bMageco Then FrmMainWnd.Disk.Caption = "Mageco controller"
        If Disk_Stat(0) = 0 And Disk_Stat(1) = 0 Then FrmMainWnd.Disk.Enabled = False
        
Else
        FrmMainWnd.Disk.Visible = False
        Disk_Stat(0) = 0: Disk_Stat(1) = 0 ' UnMount disks
End If

For a = 0 To 1
Tmp_Name = Drive_Files(a)
Disk_Stat(a) = val(GetSetting("Grok", "vb81", "Drive" & Str(a), "0"))
If Disk_Stat(a) = 0 Then
FrmMainWnd.Mount(a).Enabled = False
FrmMainWnd.Mount(a).Caption = "Drive" & Trim(Str(a)) & " [empty]"
FrmMainWnd.DSK_NAME(a).Caption = "[empty]"
FrmMainWnd.Eject(a).Enabled = False
' Init Larken ToolBar
FrmMainWnd.Drive(a).Enabled = False
FrmMainWnd.Eject_Button(a).Enabled = False
FrmMainWnd.DSK_NAME(a).Enabled = False
FrmMainWnd.active(a).Enabled = False

Else
FrmMainWnd.Disk.Enabled = True
 FrmMainWnd.Mount(a).Enabled = True
 Drive_Files(a) = GetSetting("Grok", "vb81", "Image" & Trim(Str(a)), "")
 
 ' Init Larken ToolBar
FrmMainWnd.Drive(a).Enabled = True
FrmMainWnd.Eject_Button(a).Enabled = True
FrmMainWnd.DSK_NAME(a).Enabled = True
FrmMainWnd.active(a).Enabled = True

 If Drive_Files(a) <> "" Then
 FrmMainWnd.Mount(a).Caption = "Drive" & Trim(Str(a)) & " [Loaded]": FrmMainWnd.Eject(a).Enabled = True: FrmMainWnd.Mnu_Disk(1).Enabled = True
 FrmMainWnd.DSK_NAME(a).Caption = truncatepath$(Tmp_Name, FrmMainWnd, FrmMainWnd.DSK_NAME(a))
 
 attribut = GetAttr(Drive_Files(a)) And vbReadOnly
 If attribut = vbReadOnly Then
 FrmMainWnd.active(a).Caption = "RO"
 FrmMainWnd.Pic_STA(a).picture = FrmMainWnd.Disk_RO(0).picture
 Else
 FrmMainWnd.active(a).Caption = ""
 FrmMainWnd.Pic_STA(a).picture = FrmMainWnd.Disk_RO(1).picture
 End If
 
 Else
 FrmMainWnd.Eject(a).Enabled = False: FrmMainWnd.Mount(a).Caption = "Drive" & Trim(Str(a)) & " [empty]"
 FrmMainWnd.DSK_NAME(a).Caption = "[empty]"
 FrmMainWnd.active(a).Caption = ""
 FrmMainWnd.Pic_STA(a).picture = Nothing
 End If
End If
Next
If GetSetting("Grok", "vb81", "Image0", "") = "" And GetSetting("Grok", "vb81", "Image1", "") = "" Then FrmMainWnd.Mnu_Disk(1).Enabled = False
'Drive 2 and 3 : Only for Larken Spectrum release.
 
 
If bMageco Then MEM(8312) = &HEC

 End Sub


Sub Init_D_FileCLR()
Dim a
Dim b
Dim Df_cnt
Df_cnt = 0
For a = 0 To 23
For b = 0 To 31
D_FileCLR(Df_cnt) = 0
Df_cnt = Df_cnt + 1
Next
D_FileCLR(Df_cnt) = &H76
Df_cnt = Df_cnt + 1
Next
D_FileCLR(Df_cnt) = &H80
Df_cnt = Df_cnt + 1
D_FileCLR(Df_cnt) = &HF8
End Sub

Function convert(text As String, tr As Byte) As String
Dim TmpB As Byte
Dim TMPS As String
Dim a, Tmp_Var, z
Dim Tmp_Str As String

Tmp_Str = App.FileDescription & App.LegalCopyright

For z = 1 To Len(Tmp_Str) - 1
Tmp_Var = Tmp_Var + (Asc(Mid(Tmp_Str, z, 1)) + Asc(Mid(Tmp_Str, z + 1, 1)))
Next

Tmp_Var = (Tmp_Var And &HFF) + ((Tmp_Var And &HFF00) / &H100)

If tr <> (Tmp_Var And &HFF) Then End

TMPS = ""
For a = 1 To Len(text)
TmpB = CByte(Asc(Mid(text, a, 1)))
TmpB = (TmpB Xor Tmp_Var And &HFF)
TMPS = TMPS + Chr(TmpB)
Next
convert = TMPS
End Function

Private Sub Init_Sound()

SndKit_SMP(0) = &H80 '                            +
SndKit_SMP(1) = &H80 '                            +
SndKit_SMP(2) = &HDC '                            |        +
SndKit_SMP(3) = &HDC '                            |        +

End Sub

Sub LoadKB_Setting()
Dim StrTMP As String
Dim KBval(7) As Byte
StrTMP = GetSetting("Grok", "vb81", "USER_K5", "223|255|255|255|254|255|255|255")
GetKBValues KBval(), StrTMP
eCursors.K5.key1_5 = KBval(0): eCursors.K5.key6_0 = KBval(1): eCursors.K5.keyA_G = KBval(2): eCursors.K5.keyB_SPC = KBval(3): eCursors.K5.keyCAPS_V = KBval(4): eCursors.K5.keyH_ENT = KBval(5): eCursors.K5.keyQ_T = KBval(6): eCursors.K5.keyY_P = KBval(7)

StrTMP = GetSetting("Grok", "vb81", "USER_K6", "255|223|255|255|254|255|255|255")
GetKBValues KBval(), StrTMP
eCursors.K6.key1_5 = KBval(0): eCursors.K6.key6_0 = KBval(1): eCursors.K6.keyA_G = KBval(2): eCursors.K6.keyB_SPC = KBval(3): eCursors.K6.keyCAPS_V = KBval(4): eCursors.K6.keyH_ENT = KBval(5): eCursors.K6.keyQ_T = KBval(6): eCursors.K6.keyY_P = KBval(7)

StrTMP = GetSetting("Grok", "vb81", "USER_K7", "255|239|255|255|254|255|255|255")
GetKBValues KBval(), StrTMP
eCursors.K7.key1_5 = KBval(0): eCursors.K7.key6_0 = KBval(1): eCursors.K7.keyA_G = KBval(2): eCursors.K7.keyB_SPC = KBval(3): eCursors.K7.keyCAPS_V = KBval(4): eCursors.K7.keyH_ENT = KBval(5): eCursors.K7.keyQ_T = KBval(6): eCursors.K7.keyY_P = KBval(7)

StrTMP = GetSetting("Grok", "vb81", "USER_K8", "255|247|255|255|254|255|255|255")
GetKBValues KBval(), StrTMP
eCursors.K8.key1_5 = KBval(0): eCursors.K8.key6_0 = KBval(1): eCursors.K8.keyA_G = KBval(2): eCursors.K8.keyB_SPC = KBval(3): eCursors.K8.keyCAPS_V = KBval(4): eCursors.K8.keyH_ENT = KBval(5): eCursors.K8.keyQ_T = KBval(6): eCursors.K8.keyY_P = KBval(7)

End Sub
Function GetKBValues(value() As Byte, StrTMP As String)
Dim Offset_Len
Dim index

For index = 0 To 7
Offset_Len = InStr(1, StrTMP, "|")
If Offset_Len = 0 Then Offset_Len = Len(StrTMP) + 1
value(index) = val(Mid(StrTMP, 1, Offset_Len - 1))
If InStr(1, StrTMP, "|") <> 0 Then StrTMP = Right(StrTMP, Len(StrTMP) - Offset_Len)
Next
End Function

Sub UpdateRomAlloc(RomName As String, Offset As Long, Optional oRomLen As Long = 0, Optional tUser As Boolean = False)
On Error Resume Next
Dim Cnt As Integer
Dim firstBloc As Integer
Dim Room As Long

If UCase(RomName) = UCase(App.path & "\ROMS\") Then Exit Sub
' oRomLen=0 if it's a binary ROM file.

' Set in case of "Z81", like the CBI rom loading process.
If oRomLen = 0 Then
Room = FileLen(RomName)
Else
Room = oRomLen
End If

firstBloc = CInt(Offset \ 2048)
If Room Mod 2048 <> 0 Then Room = (Room \ 2048) * 2048 + 2048
For Cnt = 0 To CInt(Room \ 2048) - 1
If (firstBloc + Cnt) < 32 Then
eRomalloc(firstBloc + Cnt).User = tUser
eRomalloc(firstBloc + Cnt).RomIndex = IIf(Cnt = 0, firstBloc, -1)
eRomalloc(firstBloc + Cnt).Enabled = True
eRomalloc(firstBloc + Cnt).RomOffset = Offset
eRomalloc(firstBloc + Cnt).RomName = RomName
eRomalloc(firstBloc + Cnt).RomLen = Room
End If
Next

End Sub


Sub LoadZxpandBuffer()
 
    Dim hFile As Long
    On Error Resume Next
    If Dir$(App.path & "\Roms\zx81-zxpand.rom") = "" Then
        MsgBox "Error: Could not find required ROM image '" & App.path & "\Roms\zx81-zxpand.rom'.", vbOKOnly Or vbCritical, "vb81"
        Exit Sub
    End If
    
  hFile = FreeFile
  Open App.path & "\Roms\zx81-zxpand.rom" For Binary Access Read Lock Read As #hFile
  Get #hFile, 1, ZxpandBuffer
  Close #hFile
Debug.Print "Zxpand buffered ROM loaded!"
End Sub

Sub ReLoadCustRoms()
Dim Cnt

'0 to 3= Zx81 rom.
' Cant reload the rom, it will overwrite the roms Hacks
For Cnt = 0 To 31
 If eRomalloc(Cnt).User Then
        If eRomalloc(Cnt).RomLen <> 0 Then
              eRomalloc(Cnt).Enabled = True
                    If eRomalloc(Cnt).RomIndex <> -1 Then
                   ' UpdateRomAlloc eRomalloc(Cnt).RomName, eRomalloc(Cnt).RomOffset, , True
                    Load_File_In_Mem eRomalloc(Cnt).RomName, eRomalloc(Cnt).RomOffset
                    End If
        End If
 End If
Next
End Sub

Public Function GetSelectFormat() As String
Select Case ScreenFmt
    Case 0 'BMP
    GetSelectFormat = "Picture files  (bmp)|*.bmp|Picture files  (*.gif)|*.gif|Picture files  (*.jpeg)|*.jpeg;*.jpg|Picture files  (*.png)|*.png|Other files (*.*)|*.*"
    Case 1 'GIF
    GetSelectFormat = "Picture files  (gif)|*.gif|Picture files  (*.bmp)|*.bmp|Picture files  (*.jpeg)|*.jpeg;*.jpg|Picture files  (*.png)|*.png|Other files (*.*)|*.*"
    Case 2 'JPG
    GetSelectFormat = "Picture files  (jpeg;jpg)|*.jpeg;*.jpg|Picture files  (*.bmp)|*.bmp|Picture files  (*.gif)|*.gif|Picture files  (*.png)|*.png|Other files (*.*)|*.*"
    Case 3 'PNG
    GetSelectFormat = "Picture files  (png)|*.png|Picture files  (*.bmp)|*.bmp|Picture files  (*.gif)|*.gif|Picture files  (*.jpeg)|*.jpeg;*.jpg|Other files (*.*)|*.*"
    End Select
End Function

Public Function GetSelectFormatATTR() As String
Select Case ScreenFmt
    Case 0 'BMP
    GetSelectFormatATTR = "bmp"
    Case 1 'GIF
    GetSelectFormatATTR = "gif"
    Case 2 'JPG
    GetSelectFormatATTR = "jpg"
    Case 3 'PNG
    GetSelectFormatATTR = "png"
End Select
End Function

Public Function SetSelectFormat(Fname As String) As SavePictureFormats

Static AttrStr As String * 3
AttrStr = LCase(Right(Fname, 3))

Select Case AttrStr
Case "bmp"
SetSelectFormat = fmtBMP

Case "gif"
SetSelectFormat = fmtGIF

Case "jpg", "peg"
SetSelectFormat = fmtJPEG

Case "png"
SetSelectFormat = fmtPNG

Case Else
SetSelectFormat = fmtBMP

End Select
End Function

